2004-11-09 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* intltool-merge.in: Updated to 0.31.2.
	* intltool-update.in: Updated to 0.31.2.
	* intltool-extract.in: Updated to 0.31.2.
	
2004-11-09 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* uim/skk-dic.c (numeric_kanji_with_position_conv) : Fix behavior
	  in case of getting 1000000.
	
2004-11-09 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* configure.ac: Removed definition of LOCALEDIR.
	
	* uim/Makefile.am: Added definition of LOCALEDIR.
	* gtk/Makefile.am: Added definition of LOCALEDIR.
	* helper/Makefile.am: Added definition of LOCALEDIR, GNOMELOCALEDIR.
	
2004-11-09 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/ximic.cpp (XimIC::get_ic_atr) : Send
	  KeyPressMask|KeyReleaseMask again for ICA_FilterEvents on
	  on-demand-synchronous method.  On full-synchronous method, send
	  KeyPressMask only since sending KeyReleaseMask causes problem in
	  rare cases for some reason.
	
2004-11-09 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* uim/skk-dic.c (numeric_kanji_with_position_conv) : Fix behavior
	  in case of zero.
	
2004-11-09 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* configure.ac: It's no longer 0.4.5-beta1. Replaced with the word 
	  "trunk". This will close Bug 1790.
	
2004-11-09 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* scm/japanese-azik.scm: Used new input-rule style like
	   ((("x" "x"). ())(("y" "y" "y") ("z" "z" "z"))).
	   This will fix the Bug 566.
	
2004-11-09 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* scm/japanese.scm: Used new input-rule style like
	   ((("x" "x"). ())(("y" "y" "y") ("z" "z" "z"))).
	   This will fix the Bug 566.
	
2004-11-09 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* scm/anthy.scm:
	 -(anthy-proc-input-state-with-preedit): Corresponsed to new input-rule
	   style like  ((("x" "x"). ())(("y" "y" "y") ("z" "z" "z")))
	
2004-11-09 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit adds dynamic configuration update of live uim client
	  processes feature to Sumika using the helper protocol message
	  'prop_custom_update'. To test this feature, uncomment (require
	  "custom.scm") in the loader.scm.
	
	* sumika/common/uimconfig.c
	  - Add #include "uim/uim-helper.h"
	  - (siod_output): Mark as static
	  - (custom_msg_tmpl, helper_fd): New static variable
	  - (helper_disconnect_cb): New static function
	  - (write_uim_config):
	    * Add the dynamic configuration update of live uim client
	      processes feature
	    * Add anthy-show-segment-separator? modification for testing
	      purpose. This code fragment only exists for testing purpose. It
	      must be removed in future
	* scm/loader.scm
	  - Move the location of (require "custom.scm")
	* scm/custom.scm
	  - (custom-prop-update-custom-handler): Change first argument name
	    'id' to 'context' in accordance with recent specification change
	    in im.scm
	
2004-11-09 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* sumika/gtk2/uimcontainer.c
	  - (uim_config_container_new): Uncomment g_signal_connect for
	    cb_uim_config_pane_save_button_clicked. This makes custom values
	    saving as ~/.uim working. But custom value update (uim_custom_set)
	    on user operations on the custom widgets are still lacking, so
	    saved ~/.uim does not reflect user modification
	  - (cb_uim_config_pane_save_button_clicked): New static function
	  - (uimconfig_create_custom_filechooser_widget): Fix
	    uim_custom_value_as_str() with uim_custom_value_as_path() This
	    fixes default value initialization of the widgets for pathname
	    custom variables such as skk-dic-file-name
	  - Fix a typo in a comment
	
	* scm/custom.scm
	  - (custom switch-im-key?): Comment out because the custom type 'key'
	    is not yet completed. This change has resolved the error on saving
	
2004-11-09 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* scm/japanese.scm: Fixed some wrong rules. whu, tha, qya, qyi, qyu,
	   qye, qyo. Thanks to OHASHI Hideya.
	
2004-11-09 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* scm/japanese.scm: Removed unused rules, "s" "s" and "n" "".
	
	* scm/japanese-azik.scm: Removed unused rule, "n" "x" "2" "7".
	
2004-11-08 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* scm/skk.scm : Add skk-use-numeric-conversion? definition.
	(skk-get-nth-candidate) : Check skk-use-numeric-conversion?
	(skk-prepare-commit-string) : Ditto.
	(skk-begin-conversion) : Ditto.
	(skk-do-update-preedit) : Ditto.  In numeric-conversion mode, show
	  preedit whose numerical strings are replaced with # if there is
	  skk-context-child-context.
	(skk-check-candidate-window-begin) : Check
	  skk-use-numeric-conversion?
	(skk-change-candidate-index) : Ditto.
	
	* scm/skk-editor.scm (skk-editor-commit-raw) : Ditto.  If
	  inputting string-length of str is 0, go back to parent context
	  according to ddskk's behavior.
	
	* uim/skk-dic.c : Add skk-lib-store-replaced-numstr,
	  skk-lib-merge-replaced-numstr, skk-lib-merge-replaced-numstr,
	  skk-lib-replace-numeric for scheme interface.  Change number of
	  accepting arguments of skk-lib-get-nth-candidate,
	  skk-lib-get-nr-candidates, skk-lib-commit-candidate in order to
	  enable numeric conversion.
	(skk_store_replaced_numeric_str) : New function.
	  Returns list of numeric strings by parsing string of
	  skk-context-head.
	(wide_num_list) : New.  List of full width numbers.
	(kanji_num_list) : New.  List of kanji numbers.
	(kanji_num_position_list) : New.  List of kanji position
	  characters.
	(numeric_wide_or_kanji_conv) : New function.  Returns full width
	  numeric string or kanji numeric string.
	(numeric_kanji_width_position_conv) : New function.  Returns kanji
	  numeric string with position characters.
	(numeric_shogi_conv) : New function.  Returns numeric string for
	  shogi.
	(numeric_convert) : New function.  Return numerically converted
	  strings corresponding to each numeric conversion methods of
	  skk.  Method #5 is not implemented yet.
	(skk_merge_replaced_numeric_str) : New function.  Return merged
	  string of the candidate and corresponding converted numeric
	  string.
	(skk_replace_numeric) : New function.  Replace numerical string of
	  the original string with #, and return its replaced string.
	(get_nth) : New function.  Returns nth content of the LISP list.
	(skk_get_nth_candidate) : Process #4 method of skk's numerical
	  conversion.
	(skk_get_nr_candidate) : Ditto.
	(skk_commit_candidate) : Ditto.
	
2004-11-08 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* I had mistakes in the commit log for r1604. Following is the correct
	  version.
	
	* sumika/gtk2/uimcontainer.c
	  - (uim_config_container_new):
	    * Comment out uim_lisp local variables and replace with the global
	      variables
	    * Add uimapi_gc_protect() for the global variables
	  - (uimconfig_create_custom_combobox_widget,
	    uimconfig_create_custom_checkbutton_widget,
	    uimconfig_create_custom_textbox_widget,
	    uimconfig_create_custom_spinbutton_widget,
	    uimconfig_create_custom_filechooser_widget,
	    uimconfig_uim_custom_widget_new,
	    uimconfig_uim_custom_widget_new_by_sym): Comment out uim_lisp
	    local variables and replace with the global variables
	
2004-11-08 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit has temporarily and partially resolved the uim-scm API
	  problem about memory corruption on GC (see Comment #4 of bug #481
	  and [Anthy-dev 1113]). The changes make Sumika partially
	  working. Before this fix Sumika often causes SEGV on GC.  But now
	  uim configuration GUI of Sumika works with following command.
	
	  $ GTK_IM_MODULE=xim LIBUIM_VERBOSE=5 sumika
	
	  GTK_IM_MODULE=<any IM of uim> still causes SEGV. I'll investigate it
	  later. Configuration loading/saving are not yet touched.
	
	* uim/siod.h
	  - (gc_protect): New API. Export as temporary solution for custom API
	* uim/slib.c
	  - (gc_protect): Unmark static
	* uim/uim-scm.h
	  - (uim_scm_gc_protect): New API. uim_scm API wrapper for gc_protect
	  - (struct uim_api_tbl): Add uim_scm_gc_protect
	* uim/uim-util.c
	  - (uim_scm_gc_protect): New API function
	  - (uim_scm_intern_c_str, uim_scm_qintern_c_str): Cosmetic change
	* sumika/common/uimconfig.c
	  - (uimapi_gc_protect): New function
	  - (uimapi_init): Add initialization of uim_scm_gc_protect
	* sumika/gtk2/uimcontainer.c
	  - (uimapi_gc_protect): Declare as extern function
	  - (groups, group_sym, cur, item, label, default_val, desc, range,
	     group, customs, custom_sym, rcustoms):
	     * New global variable
	     * These gc_protect'ed variables are moved from local variables to
	       avoid corruption on GC
	  - (uim_config_container_new):
	    * Comment out uim_lisp local variables and replace with the local
	      variables
	    * Add uimapi_gc_protect() for the global variables
	  - (uimconfig_create_custom_combobox_widget,
	    uimconfig_create_custom_checkbutton_widget,
	    uimconfig_create_custom_textbox_widget,
	    uimconfig_create_custom_spinbutton_widget,
	    uimconfig_create_custom_filechooser_widget,
	    uimconfig_uim_custom_widget_new,
	    uimconfig_uim_custom_widget_new_by_sym): Comment out uim_lisp
	    local variables and replace with the local variables
	
	* scm/custom.scm
	  - Remove invalid (require "im.scm")
	  - (custom custom-preserved-default-im-name):
	    * Follow recent im.scm specification change about im-list
	    * Add fallback labels for each IM
	  - (custom-hook-get-default-im-name): Follow recent im.scm
	    specification change about im-list
	
2004-11-08 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* scm/generic-key.scm:
	 -(generic-next-page-key?): Took off "right" from key binding.
	 -(generic-prev-page-key?): Took off "left" from key binding.
	 In anthy.scm, there is no way to close candidate window. If right and
	 left keys are used to prev/next page, we cannot change current selected
	 segment.
	 
	
2004-11-08 kzk <mover@hct.zaq.ne.jp>
	
	* Enable selecting Candidate from hitting number key
	
	* qt/quiminputcontextplugin/src/quiminputcontext.cpp
	  - (filterEvent): handle number key specially for candidate window
	* qt/quiminputcontextplugin/src/candidatewindow.cpp
	  - (setIndexInPage): new function
	  - (shiftPage): handle candidateIndex correctly
	* qt/quiminputcontextplugin/src/candidatewindow.h
	  - (setIndexInPage): new function
	
	* qt/quiminputcontextplugin-qt4/quiminputcontext.h
	  - #include <uim/uim-util.h>
	* qt/quiminputcontextplugin-qt4/quiminputcontext.cpp
	  - (filterEvent): handle number key specially for candidate window
	* qt/quiminputcontextplugin-qt4/candidatewindow.cpp
	  - (setIndexInPage): new function
	  - (shiftPage): handle candidateIndex correctly
	* qt/quiminputcontextplugin-qt4/candidatewindow.h
	  - (setIndexInPage): new function
	
2004-11-08 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/ximserver.cpp (InputContext::candidate_activate) : Use
	  correct accel_enumeration_hint argument for uim_get_candidate().
	  Add sanity check.
	
2004-11-08 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit fixes invalid input mode management in anthy.scm and
	  canna.scm that prevents setting default input mode as 'direct' or
	  'zenkaku' via action.scm. This change has resolved remaining bug
	  #1791 on anthy and canna. Thanks to UTUMI Hirosi for reporting.
	
	* scm/anthy.scm
	  - (anthy-context-new): Remove unnecessary anthy-flush invocatoin
	  - (anthy-flush): Remove inappropriate anthy-context-set-on!
	    invocation
	  - (anthy-proc-wide-latin): Add anthy-context-set-on!
	
	* scm/canna.scm
	  - (canna-context-new): Remove unnecessary canna-flush invocatoin
	  - (canna-flush): Remove inappropriate canna-context-set-on!
	    invocation
	  - (canna-proc-wide-latin): Add canna-context-set-on!
	
2004-11-08 kzk <mover@hct.zaq.ne.jp>
	
	* scm/anthy.scm
	  - (anthy-proc-converting-state): handle "anthy-prev-page-key?"
	    and "anthy-next-page-key?" before handling "anthy-next-segment-key?"
	    and "anthy-prev-segment-key?". These are apt to have same key.
	    So, we should handle "anthy-*-page-key?" which has the ristriction
	    that this key is handled when candidate-window is active;
	
	* scm/generic-key.scm
	  - add "left" key to generic-prev-page-key?
	  - add "right" key to  generic-next-page-key?
	
2004-11-08 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/COMPATIBILITY
	  - Add a new entry 'New action handling framework'
	* scm/action.scm
	  - Modify the header comment
	
2004-11-08 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/action.scm
	  - (activity-indicator-new): Fix broken handling when no activity
	    exist. Returns fallback-indication when such case. The behavior is
	    validated by test-action.scm.
	* test/test-action.scm
	  - (test activity-indicator-new): Add no activity case
	
2004-11-08 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit changes default activity of input mode widget of each
	  IMs to 'direct' mode. This change has resolved bug #1791. In
	  addition, setting these variables non-direct mode is not useful on
	  gtk-immodule until bug #1632 has been resolved because non-text
	  widgets such as menus are created with non-direct mode, so shortcut
	  operations by alphabet character does not work until the mode have
	  been changed to direct mode.
	
	* scm/anthy.scm
	  - (default-widget_anthy_input_mode): Change the value to action_anthy_direct
	
	* scm/canna.scm
	  - (default-widget_canna_input_mode): Change the value to
	    action_canna_direct
	
	* scm/skk.scm
	  - (default-widget_skk_input_mode): Change the value to action_skk_latin
	
	* scm/tutcode.scm
	  - (default-widget_tutcode_input_mode): Change the value to
	    action_tutcode_direct
	
	* scm/util.scm
	  - (any, every): Cosmetic change
	
2004-11-07 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/ximtrans.cpp (Connection::xim_open) : Check whether XIM is
	  working with full-synchronous method or on-demand-synchronous
	  method.
	* xim/ximic.cpp (XimIC::get_ic_atr) : Only send KeyPressMask.
	* xim/ximim.cpp (XimIM_impl::forward_event) : Send XIM_SYNC_REPLY
	  if xim if working with full-synchronous method.
	* xim/main.cpp : Add --fullsync command line option.
	* xim/ximserver.h : Define OPT_FULL_SYNC.
	
2004-11-05 kzk <mover@hct.zaq.ne.jp>
	
	* Enable kasumi button (configure option)
	* uim-kdehelper/configure.in.in
	  - add "--enable-kasumi" option
	* uim-kdehelper/src/common/Makefile.am
	  - handle kasumi-enabled case
	* uim-kdehelper/src/common/quimhelpertoolbar.cpp
	* uim-kdehelper/src/common/quimhelpertoolbar.h
	  - (addExecKasumiButton, slotExecKasumi): new function
	
	* use KUniqueApplication class for future uim-pref-qt
	* uim-kdehelper/src/pref/uim-pref-qt.cpp
	* uim-kdehelper/src/pref/uim-pref-qt.h
	  - (slotOk, slotApply): new function
	
	* add "const" qualifier for optimization
	* uim-kdehelper/src/toolbar/draghandler.cpp
	* uim-kdehelper/src/candwin/uim-candwin-qt.cpp
	* uim-kdehelper/src/switcher/im-switcher-qt.h
	* uim-kdehelper/src/switcher/im-switcher-qt.cpp
	* uim-kdehelper/src/common/uimstateindicator.cpp
	
	* Pot filename update
	* uim-kdehelper/po/uim-qtkde-helper.pot
	  - deleted
	* uim-kdehelper/po/uim-kdehelper.pot
	  - added
	
2004-11-05 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit replaces property and mode handlings in skk.scm with
	  the new action handling framework implemented in action.scm. Users
	  can configure widgets and actions as their preferable forms.
	
	* scm/skk.scm
	  - Replace skk-mode-handler and skk-prop-handler in register-im
	    with context-mode-handler and context-prop-activate-handler
	  - Invoke skk-configure-widgets to register widgets
	  - (skk-widgets, default-widget_skk_input_mode,
	    skk-input-mode-actions): New configuration variable
	  - (skk-mode-latin, skk-mode-hiragana, skk-mode-katakana,
	    skk-mode-wide-latin, skk-mode-hankana): Remove
	  - (skk-prepare-activation, skk-configure-widgets, skk-latin-state?):
	    New procedure
	  - (action action_skk_hiragana, action action_skk_katakana, action
	    action_skk_hankana, action action_skk_latin, action
	    action_skk_wide_latin): New action
	  - (skk-context-new): Add initialization of widgets
	  - (skk-update-mode, skk-mode-handler, skk-prop-handler,
	    skk-update-prop-label, skk-update-prop-list): Remove to replace
	    with action.scm
	  - (skk-proc-state-direct-no-preedit, skk-proc-state-direct,
	    skk-proc-state-latin, skk-proc-state-wide-latin,
	    skk-init-handler): Remove property and mode handlings to replace
	    with action.scm
	
2004-11-05 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit replaces property and mode handlings in prime.scm with
	  the new action handling framework implemented in action.scm. Users
	  can configure widgets and actions as their preferable forms.
	
	* scm/prime.scm
	  - Replace prime-mode-handler and prime-prop-handler in register-im
	    with context-mode-handler and context-prop-activate-handler
	  - Invoke prime-configure-widgets to register widgets
	  - (prime-widgets, default-widget_prime_input_mode,
	    prime-input-mode-actions): New configuration variable
	  - (action action_prime_mode_latin, action
	    action_prime_mode_hiragana, action action_prime_mode_wide_latin):
	    New action
	  - (prime-configure-widgets): New procedure
	  - (prime-context-new): Add initialization of widgets
	  - (prime-init-handler, prime-mode-set): Remove property and mode
	    handlings to replace with action.scm
	  - (prime-mode-handler, prime-prop-handler, prime-update-prop-label,
	    prime-update-prop-list, prime-mode-get-label,
	    prime-mode-get-list): Remove to replace with action.scm
	  - (prime-mode): Mark as unused
	
2004-11-05 kzk <mover@hct.zaq.ne.jp>
	
	* qt/uim-kdehelper/candwin/uim-candwin-qt.cpp
	  - (slotCandidateSelected): enable mouse clicking.
	    thanks Etsusi Kato-san!
	
2004-11-05 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit replaces property and mode handlings in canna.scm with
	  the new action handling framework implemented in action.scm. Users
	  can configure widgets and actions as their preferable forms.
	
	* scm/canna.scm
	  - Replace canna-mode-handler and canna-prop-handler in register-im
	    with context-mode-handler and context-prop-activate-handler
	  - Invoke canna-configure-widgets to register widgets
	  - Add preliminary AZIK input support
	  - (canna-widgets, default-widget_canna_input_mode,
	    default-widget_canna_kana_input_method, canna-input-mode-actions,
	    canna-kana-input-method-actions): New configuration variable
	  - (action action_canna_hiragana, action action_canna_katakana,
	    action action_canna_hankana, action action_canna_direct, action
	    action_canna_zenkaku, action action_canna_roma, action
	    action_canna_kana, action_canna_azik): New action
	  - (canna-prepare-activation, canna-configure-widgets): New procedure
	  - (canna-context-rec-spec): Fix invalid default value
	  - (canna-context-new): Add initialization of widgets
	  - (canna-mode-handler, canna-prop-handler, canna-update-prop-label,
	    canna-update-mode, canna-update-prop-list): Remove to replace with
	    action.scm
	  - (canna-proc-input-state-no-preedit, canna-init-handler,
	    canna-proc-wide-latin): Remove property and mode handlings to
	    replace with action.scm
	  - (canna-proc-input-state-with-preedit):
	    * Remove property and mode handlings to replace with action.scm
	    * Fix a typo over a procedure invocation
	  - (canna-proc-raw-state):
	    * Remove property and mode handlings to replace with action.scm
	    * Remove an unused invalid canna-update-preedit
	  - (canna-prop-list): Remove the unused procedure
	* scm/util.scm
	  - (multi-segment-mode-direct, multi-segment-mode-hiragana,
	    multi-segment-mode-katakana, multi-segment-mode-wide-latin,
	    multi-segment-mode-hankana): Remove
	
	* scm/anthy.scm
	  - A trivial cosmetic change
	
2004-11-05 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit replaces property and mode handlings in tutcode.scm with
	  the new action handling framework implemented in action.scm.
	
	* scm/tutcode.scm
	  - Invoke tutcode-configure-widgets to register widgets
	  - (tutcode-register-im): Replace tutcode-mode-handler and
	    tutcode-prop-handler in register-im with context-mode-handler and
	    context-prop-activate-handler
	  - (tutcode-widgets, default-widget_tutcode_input_mode,
	    tutcode-input-mode-actions): New configuration variable
	  - (action action_tutcode_direct, action action_tutcode_hiragana,
	    action action_tutcode_katakana): New action
	  - (tutcode-prepare-activation, tutcode-configure-widgets): New
	    procedure
	  - (tutcode-context-new): Add initialization of context-widgets
	  - (tutcode-proc-on-mode, tutcode-proc-off-mode,
	    tutcode-init-handler): Remove property and mode handlings to
	    replace with action.scm
	  - (tutcode-update-mode, tutcode-mode-handler, tutcode-prop-handler,
	    tutcode-update-prop-label, tutcode-update-prop-list): Remove to
	    replace with action.scm
	
2004-11-05 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit adds property and mode handlings in direct.scm by new
	  action handling framework implemented in action.scm.
	
	* scm/direct.scm
	  - Invoke direct-configure-widgets to register widgets
	  - Replace direct-mode-handler and direct-prop-handler in register-im
	    with context-mode-handler and context-prop-activate-handler
	  - (direct-widgets, default-widget_direct_input_mode,
	    direct-input-mode-actions): New configuration variable
	  - (action action_direct_direct): New action
	  - (direct-configure-widgets): New procedure
	  - (direct-context-new-internal): New alias of define-record'ed
	    direct-context-new
	  - (direct-context-new):
	    * New procedure
	    * Add initialization of context-widgets to default procedure
	  - (direct-mode-handler): Comment out old implementation which
	    performs im-switching by mode facility
	  - (direct-prop-handler): Remove these placeholder to replace with
	    action.scm
	
2004-11-05 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit adds property and mode handlings in m17nlib.scm by new
	  action handling framework implemented in action.scm.
	
	* scm/m17nlib.scm
	  - Invoke m17nlib-configure-widgets to register widgets
	  - (m17nlib-register): Replace m17nlib-mode-handler and
	    m17nlib-prop-handler in register-im with context-mode-handler and
	    context-prop-activate-handler
	  - (m17nlib-widgets, default-widget_m17nlib_input_mode,
	    m17nlib-input-mode-actions): New configuration variable
	  - (action action_m17nlib_off, action action_m17nlib_on): New action
	  - (m17nlib-configure-widgets): New procedure
	  - (m17nlib-mode-handler, m17nlib-prop-handler): Remove these
	    placeholders to replace with action.scm
	  - (m17nlib-context-new): Add initialization of context-widgets
	
2004-11-05 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit replaces property and mode handlings in generic.scm with
	  the new action handling framework implemented in action.scm.
	
	* scm/generic.scm
	  - Invoke generic-configure-widgets to register widgets
	  - (generic-register-im): Replace generic-mode-handler and
	    generic-prop-handler in register-im with context-mode-handler and
	    context-prop-activate-handler
	  - (generic-widgets, default-widget_generic_input_mode,
	    generic-input-mode-actions): New configuration variable
	  - (action action_generic_off, action action_generic_on): New action
	  - (generic-prepare-activation, generic-configure-widgets): New
	    procedure
	  - (generic-context-rec-spec): Fix invalid default value
	  - (generic-context-new): Add initialization of context-widgets
	  - (generic-proc-input-state, generic-proc-off-mode,
	    generic-init-handler): Remove property and mode handlings to
	    replace with action.scm
	  - (generic-mode-handler, generic-prop-handler,
	    generic-update-prop-label, generic-update-prop-list): Remove to
	    replace with action.scm
	* scm/hangul.scm
	  - (hangul-register-im): Replace generic-mode-handler and
	    generic-prop-handler in register-im with context-mode-handler and
	    context-prop-activate-handler
	
2004-11-05 kzk <mover@hct.zaq.ne.jp>
	
	* qt/uim-kdehelper/switcher/im-switcher-qt.cpp
	  - (createGUI): layout and resize mode enhancement
	  - (parseHelperStrImList): remove unnecessary code
	    for adjusting listview size
	
	* qt/uim-kdehelper/switcher/im-switcher-qt.h
	  - now class UimImSwitcher extends QDialog
	
2004-11-05 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit replaces property and mode handlings in anthy.scm with
	  the new action handling framework implemented in action.scm. Users
	  can configure widgets and actions as their preferable forms.
	
	* scm/anthy.scm
	  - Replace anthy-mode-handler and anthy-prop-handler in register-im
	    with context-mode-handler and context-prop-activate-handler
	  - Invoke anthy-configure-widgets to register widgets
	  - Add preliminary AZIK input support
	  - (anthy-widgets, default-widget_anthy_input_mode,
	    default-widget_anthy_kana_input_method, anthy-input-mode-actions,
	    anthy-kana-input-method-actions): New configuration variable moved
	    from action.scm
	  - (action action_anthy_hiragana, action action_anthy_katakana,
	    action action_anthy_hankana, action action_anthy_direct, action
	    action_anthy_zenkaku, action action_anthy_roma, action
	    action_anthy_kana): New action moved from action.scm
	  - (action action_anthy_azik): New action
	  - (anthy-prepare-activation, anthy-configure-widgets): New procedure
	    moved from action.scm
	  - (anthy-mode-direct, anthy-mode-hiragana, anthy-mode-katakana,
	    anthy-mode-wide-latin, anthy-mode-hankana): Remove
	  - (anthy-context-new): Add initialization of widgets
	  - (anthy-init-handler, anthy-proc-raw-state,
	    anthy-proc-input-state-no-preedit,
	    anthy-proc-input-state-with-preedit, anthy-proc-wide-latin, ):
	    Remove property and mode handlings to replace with action.scm
	  - (anthy-mode-handler, anthy-prop-handler, anthy-update-prop-label,
	    anthy-update-mode, anthy-update-prop-list, ): Remove to replace
	    with action.scm
	* scm/action.scm
	  - Remove invocation of anthy-configure-widgets
	  - (anthy-widgets, default-widget_anthy_input_mode,
	    default-widget_anthy_kana_input_method, anthy-input-mode-actions,
	    anthy-kana-input-method-actions, anthy-prepare-activation, action
	    action_anthy_hiragana, action action_anthy_katakana, action
	    action_anthy_hankana, action action_anthy_direct, action
	    action_anthy_zenkaku, action action_anthy_roma, action
	    action_anthy_kana, anthy-configure-widgets, anthy-context-new):
	    Move into anthy.scm
	  - (test-widgets): New variable
	  - (example-configure-widgets): New procedure
	  - (anthy-im-name-indication): Rename to example-im-name-indication
	  - (example-im-name-indication): Renamed from
	    anthy-im-name-indication
	  - (anthy-exec-im-switcher-indication): Rename to
	    example-exec-im-switcher-indication
	  - (example-exec-im-switcher-indication): Renamed from
	    anthy-exec-im-switcher-indication
	  - (action action_exec_im_switcher): Follow the renaming of
	    anthy-exec-im-switcher-indication
	
2004-11-05 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit fixes 2 problems related to action.scm. The working
	  anthy.scm using action.scm will follow soon.
	
	  I had said that "No code modification is required for each IMs at
	  now. Each IMs can switch to the action.scm in arbitrary time" in the
	  commit log of r1580, but an indication problem on uim-toolbar will
	  occur with old code. So I'm going to replace all IMs with
	  action.scm. Sorry for misleading.
	
	* uim/uim.c
	  - (uim_prop_activate): Replace prop-handler with
	    prop-activate-handler
	  - (uim_prop_update_custom): Replace prop-handler with
	    custom-set-handler
	* scm/im.scm
	  - (record im): Rename a member prop-handler with
	    prop-activate-handler
	  - (im-custom-set-handler, custom-set-handler): New procedures to
	    simplify the handler invocation
	  - (prop-activate-handler):
	    * New procedure to simplify the handler invocation
	    * Intentionally adds context-update-widgets as side effect
	  - (im-prop-handler-alist, prop-handler): Remove
	
	* scm/action.scm
	  - All changes are validated by test-action.scm
	  - (indication-compose-leaf):
	    * Fix a design bug that causes prop-activate malfunction
	    * Add an argument act-id to fix the design bug
	    * compose act-id instead of indication-id into the message
	  - (widget-compose-live-branch): Follow the specifiation change of
	    indication-compose-leaf
	  - (context-prop-activate-handler, context-mode-handler): Rename a
	    local variable that masks global one (not a bug)
	  - (widget-action-id->mode-value, widget-mode-value->action-id):
	    Cosmetic change
	* test/test-action.scm
	  - (test indication-compose-leaf, test widget-compose-live-branch,
	    test context-propagate-prop-list-update, test
	    context-propagate-widget-states, test
	    context-propagate-widget-configuration): Follow the specification
	    change of indication-compose-leaf
	
2004-11-05 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* scm/generic.scm:
	 -(generic-proc-input-state): Ignore symbol key events such as left arrow 
	  and right arrow if candidate window is opened.
	
2004-11-05 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* gtk/Makefile.am: Added @GTK2_LIBS@ to im_uim_la_LDFLAGS.
	   This will fix the problem that uim's immodule doesn't work
	   with pygtk programs like quodlibet. Thanks to Matthew Reppert.
	
2004-11-05 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit prepares the replacing property handling codes with
	  action.scm in each IMs. But no code modification is required for
	  each IMs at now. Each IMs can switch to the action.scm in arbitrary
	  time.
	
	* scm/im.scm
	  - Add (require "load-action.scm")
	  - (context-rec-spec): Add new member 'widgets'. The name may be
	    renamed in accordance with discussion about action.scm
	  - (invoke-handler): Add update of widgets
	  - (create-context): Add initialization of widgets
	* scm/action.scm
	  - (context-rec-spec, record context, invoke-handler,
	    create-context): Remove to merge into im.scm
	  - Comment out (require "anthy.scm")
	
2004-11-05 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* test/test-im.scm
	  - (testcase im im-management, test retrieve-im, test
	    find-im-for-locale, test find-default-im, test find-im, testcase
	    im context management, test context-im, test find-context, test
	    remove-context): Follow the renaming of 'default IM' (had been
	    renamed to 'direct' to avoid confusions) changed in r1567, r1568
	  - (testcase im default im): Remove placeholder
	
2004-11-05 Takuro Ashie <ashie@homa.ne.jp>
	
	* uim-cand-win-gtk.[ch]: Enabled to shrink the candidate window.
	
2004-11-05 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit makes action.scm ready to use. All procedures are
	  validated by test-action.scm.
	  
	  The term 'widget' used in this framework is still under
	  discussion. It may be renamed in accordance with result of the
	  discussion.
	  http://freedesktop.org/pipermail/uim/2004-November/000736.html
	  
	  This framework will replace property handling codes in each IMs once
	  the discussion has been end. I'm going to replace the codes of
	  anthy.scm as a test soon even if the discussion continues.
	
	* scm/action.scm
	  - All procedures are validated by test-action.scm
	  - (register-action): Fix invalid registration
	  - (action-indicate): Add handling for an error case
	  - (activity-indicator-new): Rename a wrong local variable name
	  - (widget-new-internal): New alias of define-record'ed widget-new
	  - (register-widget):
	    * Fix invalid registration
	    * Replace actions with () if #f is specified
	  - (widget-new):
	    * Swap argument order to become natural
	    * Remove an initialization with arbitrary activity
	  - (widget-activity): Modify an inappropriate message
	  - (widget-activate!):
	    * Also accepts action-id instead of actual action object
	    * Add handling for an error case
	  - (widget-configuration): Add indicator configuration information
	    to handle action-less widget properly
	  - (widget-state): Cosmetic change
	  - (widget-update-configuration): Rename to widget-update-configuration!
	  - (widget-update-configuration!):
	    * Renamed from widget-update-configuration
	    * Fix a wrong logic
	  - (widget-update-state): Rename to widget-update-state!
	  - (widget-update-state!):
	    * Renamed from widget-update-configuration
	    * Fix a wrong logic
	  - (widget-debug-message): Fix a variable name mistake
	  - (create-context): Follow the renaming of context-init-widgets
	  - (widget-compose-live-branch): Fix an invalid invocation
	  - (context-init-widgets): Rename to context-init-widgets!
	  - (context-init-widgets!):
	    * Renamed from context-init-widgets!
	    * Add an error handling for re-initialization case
	    * Allocate a widget_fallback for the context if no widgets
	      specified
	    * Reject invalid widget-id
	    * Add a comment about the specification
	  - (context-update-widgets): Follow the renaming of
	    widget-update-configuration and widget-update-state
	  - (context-propagate-widget-states): Modify the comment
	  - (context-find-mode-widget): Fix broken code
	  - (widget-action-id->mode-value):
	    * Fix invalid variable name
	    * Add error handling for invalid action-id
	  - (widget-mode-value->action-id): Add error handling for out of
	    range
	  - (context-current-mode):
	    * Fix an invalid invocation
	    * Add error handling for the case mode-widget does not exist
	  - (context-update-mode-list):
	    * Fix the lacking mode-widget retrieving
	    * Add fallback handling for the case mode-widget does not exist
	  - (widget widget_fallback): New builtin widget
	  - (action action_anthy_hiragana): Replace the indication-id
	    figure_anthy_hiragana with figure_ja_hiragana
	  - (action action_anthy_katakana, action action_anthy_hankana, action
	    action_anthy_direct, action action_anthy_zenkaku, action
	    action_anthy_roma, action action_anthy_kana): Remove old-state-id
	    from handlers
	* test/test-action.scm
	  - (testcase action): New testcase
	  - (test indicator-new, test register-action, test fetch-action, test
	    action-active?, test action-indicate, test actions-new, test
	    activity-indicator-new, test register-widget, test widget-new,
	    test widget-activity, test widget-activate!, test
	    widget-configuration, test widget-state, test
	    widget-update-configuration!, test widget-update-state!, test
	    widget-debug-message, test indication-compose-label, test
	    indication-compose-branch, test indication-compose-leaf, test
	    widget-compose-live-branch, test context-init-widgets!, test
	    context-update-widgets, test context-propagate-prop-label-update,
	    test context-propagate-prop-list-update, test
	    context-propagate-widget-states, test
	    context-propagate-widget-configuration, test
	    context-prop-activate-handler, test context-find-mode-widget, test
	    widget-action-id->mode-value, test widget-mode-value->action-id,
	    test context-current-mode, test context-update-mode, test
	    context-update-mode-list, test context-mode-handler): New test
	* scm/property.scm
	  - Remove
	* test/test-property.scm
	  - Remove
	
	* scm/util.scm
	  - (alist-replace!): Remove
	  - (alist-replace): New procedure. Validated by test-util.scm
	* test/test-util.scm
	  - (test alist-replace): New test
	
	* scm/Makefile.am
	  - (SCM_FILES):
	    * Remove property.scm
	    * Add action.scm and load-action.scm
	
2004-11-04 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* Replace the comment of --with-canna 'with uim-canna' with 'with
	  libcanna' to conform to the meaning of --with in autoconf
	
2004-11-04 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* helper/toolbar-common-gtk.c: Fixed C++ style pointer notations.
	
2004-11-04 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* helper/dict-canna.h: Fixed C++ style pointer notations.
	
2004-11-04 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* helper/helper-xfce4-applet.c: Removed an unused file.
	
2004-11-04 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* helper/Makafile.am: uim-dict need dict-util.h for build.
	
2004-11-04 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* helper/im-switcher-gtk.c: Fixed all C++ style pointer notations.
	
2004-11-04 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* helper/input-pad-ja.c: Fixed all C++ style pointer notations.
	
2004-11-04 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* gtk/gtk-im-uim.c: Fixed C++ style pointer notation 'gchar*'.
	  This intends to fix the bug 1483.
	
2004-11-04 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* scm/direct.scm: Renamed from scm/default-im.
	
	* uim/uim.c: Replaced "default-im.scm" with "direct.scm".
	
2004-11-04 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	scm/default-im.scm: replaced all words 'default' with 'direct'
	  to avoid confusion. This changes will close the bug 1768.
	
2004-11-03 kzk <mover@hct.zaq.ne.jp>
	
	* qt/quiminputcontextplugin/src/candidatewindow.h
	* qt/quiminputcontextplugin/src/candidatewindow.cpp
	* qt/quiminputcontextplugin-qt4/candidatewindow.h
	* qt/quiminputcontextplugin-qt4/candidatewindow.cpp
	  - (layoutWindow): more proper handling of candidate
	    window's location. In consideration of preedit's
	    height.
	  - (forceInside): removed
	
	* qt/quiminputcontextplugin/src/quiminputcontext.cpp
	* qt/quiminputcontextplugin-qt4/quiminputcontext.cpp
	  - doesn't strdup the return value of uim_get_im_name,
	    uim_get_language_name_from_locale, uim_get_im_short_desc
	
2004-11-03 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* gtk/gtk-im-uim.c:
	 -(im_module_create): finalize im context object if uim_init failed.
	
	
2004-11-03 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* gtk/gtk-uim-uim.c:
	 -(im_module_create): Get im_name by uim_get_default_im_name according
	   to the current localename.
	 -(im_module_list): List only 1 input method "uim".
	
	These changes aim to show one input method "uim" only by right click upon 
	text widget.
	
	
2004-11-03 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	 * Makefile.am:
	 -(releasetest): New rule.
	
2004-11-03 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* configure.ac: Removed unused compile flag XFCE4_PANEL.
	
2004-11-03 kzk <mover@hct.zaq.ne.jp>
	
	* reneme qtkde-helper to uim-kdehelper
	
	* qt/uim-kdehelper/configure.in.in
	  - release uim-kdehelper 0.1.0
	* qt/uim-kdehelper/po/uim-qtkde-helper.pot
	  - update pot file
	
2004-11-03 kzk <mover@hct.zaq.ne.jp>
	
	* qt/qtkde-helper/src/pref/uimqtconfig
	  - added
	* pref/uim-pref-qt.cpp
	  - release all modules in exiting
	
	* pref/Makefile.am
	  - add uimqtconfig to SUBDIRS
	* pref/uimconfig/kcmuimconfigmodule.cpp
	  - remove unnecessary #include
	* pref/uim-pref-qt.h
	  - Ditto
	
2004-11-03 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* scm/m17nlib.scm:
	 - (m17nlib-on-key?): New key definition.
	 - (m17nlib-off-key?): New key definition.
	 - (m17nlib-proc-direct-state): New procedure.
	 - (m17nlib-commit-raw): New procedure.
	 - (m17nlib-press-key-handler): Call m17nlib-context-on to check the current
	   input state is on or off.
	   
	This changes implements on/off feature to uim's m17n-lib support.
	
2004-10-31 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit adds the replacement of property.scm to the IM framework
	  in accordance with recent discussions on uim@fdo.
	  
	  This user-operable action handling framework will eliminates all of
	  property related handlings such as im-update-prop-list or
	  im-update-prop-label from each input method. Input method developer
	  can forget about the property (and legacy 'mode') feature except for
	  context creation process.
	  
	  The term 'widget' used in this framework is still under
	  discussion. It may be renamed in accordance with result of the
	  discussion.
	  http://freedesktop.org/pipermail/uim/2004-October/000731.html
	  
	  This framework will replace property handling codes in each IMs once
	  the discussion has been end and the implementation has been
	  validated by test.
	
	* scm/action.scm
	  - (indication-rec-spec, action-rec-spec, indicator-rec-spec,
	    widget-rec-spec, action-list, widget-proto-list): New variable
	  - (record indication, record action, record indicator, record
	    widget): New record
	  - (indicator-new-internal): New alias procedure
	  - (indicator-set-id!, indicator-set-activity-pred!,
	    indicator-set-activate-handler!): New placeholders to disable
	    the 3 automatically defined procedures
	  - (indicator-new, register-action, fetch-action, action-active?,
	    action-indicate, actions-new, activity-indicator-new,
	    fallback-indication, register-widget, widget-new, widget-activity,
	    widget-activate!, widget-configuration, widget-state,
	    widget-update-configuration, widget-update-state,
	    widget-debug-message, indication-compose-label,
	    indication-compose-branch, indication-compose-leaf,
	    widget-compose-live-branch, context-init-widgets,
	    context-update-widgets, context-propagate-widget-states,
	    context-propagate-widget-configuration, context-find-mode-widget,
	    widget-action-id->mode-value, widget-mode-value->action-id,
	    context-current-mode): New procedure
	  - (context-propagate-prop-label-update,
	    context-propagate-prop-list-update, context-prop-activate-handler,
	    context-update-mode, context-update-mode-list,
	    context-mode-handler): Rewrite implementations in accordance with
	    the new action-based framework
	  - (context-init-prop-list, context-propagate-prop-configuration,
	    context-propagate-prop-state, prop-list-find-mode-prop,
	    prop-state-compose-branch, prop-state-compose-label,
	    prop-state-compose-leaf, property-activate-state!,
	    property-compose-live-branch, property-debug-message,
	    property-definition-list, property-definition-rec-spec,
	    property-mode-value->prop-state-id, property-new,
	    property-new-internal, property-next-state,
	    property-prop-state-id->mode-value, property-transit-state!,
	    property-will-state-transit?, register-property, record
	    prop-state, record property, record property-definition): Remove
	  - (context-rec-spec, record context, create-context,
	    invoke-handler): New implementations for im.scm. They will be
	    moved into im.scm once the switching to action.scm has been
	    started
	  - (anthy-widgets, default-widget_anthy_input_mode,
	    default-widget_anthy_kana_input_method, anthy-input-mode-actions,
	    anthy-kana-input-method-actions, anthy-prepare-activation,
	    anthy-im-name-indication, anthy-exec-im-switcher-indication,
	    anthy-configure-widgets, anthy-context-new): New implementations
	    and definitions for anthy.scm. They will be moved into anthy.scm
	    once the switching to action.scm has been started
	  - (anthy-property-id-list, default-prop_anthy_input_mode,
	    default-prop_anthy_kana_input_method): Remove
	* scm/load-action.scm
	  - New file. This loads action.scm in accordance with platform
	    configuration
	
2004-10-30 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/action.scm
	  - New file to replace property.scm with. Just a copy of property.scm
	    at now
	
	* scm/util.scm
	  - (alist-replace!): New procedure. Not yet tested
	
	* scm/im.scm
	  - Remove a comment
	* scm/anthy.scm
	  - Modify a comment
	
2004-10-30 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	* uim/skk-dic.c (do_search_line) : rename from do_search. And some comments.
	
2004-10-30 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	* AUTHORS : add Ashie-san's entry. ;)
	
2004-10-28 kzk <mover@hct.zaq.ne.jp>
	
	* qt/quiminputcontext/src/quiminputcontext.cpp
	  - fixed typo of previous commit...
	
2004-10-28 kzk <mover@hct.zaq.ne.jp>
	
	* qt/quiminputcontextplugin/src/quiminputcontext.cpp
	  - use uim_get_language_name_from_locale() function
	* qt/quiminputcontextplugin/src/quiminputcontext.h
	  - #include<uim-util.h>
	
2004-10-28 kzk <mover@hct.zaq.ne.jp>
	
	* Code Optimization
	  - improving use of iterator
	
	* qt/qtkde-helper/src/candwin/uim-candwin-qt.cpp
	  - (strParse): moving end() outside of the for declaration
	* qt/quiminputcontextplugin/src/quiminputcontext.cpp
	  - (getPreeditString, getPreeditCursorPosition, getPreeditSelectionLength) : Ditto
	* qt/quiminputcontextplugin-qt4/quiminputcontext.cpp
	  - (getPreeditString, getPreeditCursorPosition, getPreeditSelectionLength) : Ditto
	* qt/qtkde-helper/src/common/uimstateindicator.cpp
	  - (propListUpdate): use iterator instead of while(!str.isEmpty())
	
2004-10-27 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/main.cpp (main) : Prevent startup hang.
	
2004-10-27 kzk <mover@hct.zaq.ne.jp>
	
	* qt/quiminputcontextplugin/src/candidatewindow.h
	  - not to use postfix-increment for iterator (optimization)
	* qtkde-helper/src/candwin/uim-candwin-qt.h
	  - Ditto
	
2004-10-26 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/xim.h (class XimIC) : Add private member m_keyState.
	* xim/ximtrans.cpp (Connection::xim_open) : Handle KeyRelease
	  filter event.
	* xim/ximic.cpp (XimIC::OnKeyEvent) : Use internal m_keyState.
	(XimIC::get_ic_atr) : Send KeyReleaseMask.
	* xim/ximim.cpp (XimIM_impl::forward_event) : Handle KeyRelease
	  event.
	* xim/ximserver.cpp (get_im_lang_from_engine) : Indentation fix.
	(InputContext::pushKey) : Handle KeyRelease
	  event with uim_release_key().
	(keyState::keyState) : New default constructor.
	  keyState::keyState(keyEventX *x) is deleted.
	(keyState::~keyState) : New destructor.
	(keyState::check_key) : New function.  Mostly moved from deleted
	  keyState::keyState(keyEventX *x).  Revise mod1-5 modifiers using
	  revise_mod().  Handle XK_Meta_L and XK_Meta_R.  Store keypress
	  or keyrelease state.  Also store modifier key state.
	(keyState::revise_mod) : Revise modifier value according to stored
	  key state.
	* xim/convdisp.cpp (ConvdispRw::update_preedit) : Indentation fix.
	(ConvdispOv::layoutCharEnt) : Plug leak.
	
2004-10-26 kzk <mover@hct.zaq.ne.jp>
	
	* qt/qtkde-helper/src/pref
	  - add the skelton part of "uim-pref-qt"
	    This dialog reuses KControl's module system
	
2004-10-26 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/KEY
	  - Add FAQ section
	  - Add the exact match issue to FAQ section
	  - Remove signature
	
2004-10-26 kzk <mover@hct.zaq.ne.jp>
	
	* qt/qtkde-helper/src/toolbar/draghandler.cpp
	  - have fixed width. This problem is reported by
	    AWASHIRO Ikuya. Thank you!
	
	* qt/qtkde-helper/src/src/switcher/im-switcher-qt.h
	  - (reloadImList): new function
	* qt/qtkde-helper/src/src/switcher/im-switcher-qt.cpp
	  - (reloadImList): new function
	  - reverse OK button and Cancel button. This is also
	    reported by AWASHIRO Ikuya. Thank you!
	
	* qt/qtkde-helper/src/common/quimhelpertoolbar.cpp
	  - fixed indent
	
2004-10-25 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/COMPATIBILITY
	  - Update 'New logical order string API for Scheme (ustr)'
	* scm/ustr.scm
	  - Modify a comment
	
2004-10-25 Takuro Ashie <ashie@homa.ne.jp>
	
	* helper/dict-anthy-gtk.c: Removed old file.
	
2004-10-25 Takuro Ashie <ashie@homa.ne.jp>
	
	* po/POTFILES.in, po/uim.pot, po/ja.po
	  helper/dict-anthy.c, helper/dict-main-gtk.c,
	  helper/dict-word-list-win-gtk.c, helper/dict-word-win-gtk.c:
	  Translate messages into Japanese.
	
2004-10-25 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit adds proper rkc restoration on anthy-cancel-conv. The
	  requirement had been reported in [Anthy-dev 1195] by Konosuke
	  Watanabe. Thanks.
	
	* scm/rk.scm
	  - (rk-peek-terminal-match): New API procedure. Returns the rule
	    entry that exactly matches with current pending key sequence. rkc
	    will not be altered. i.e. rk-push-key-last! without side effect
	  - (record rk-context): Fix invalid boolean default values
	  - (rk-push-key-last!):
	    * Mark as API
	    * Add a comment about the procedure name. I suggest
	      rk-terminate-input!
	* doc/COMPATIBILITY
	  - Add a new entry 'rk-push-key-last! without side effect'
	
	* scm/anthy.scm
	  - (anthy-make-whole-string):
	    * Remove the side effect which alters rkc
	    * Revert the change in r1538 which alters
	      anthy-context-preconv-ustr
	  - (anthy-begin-conv):
	    * Remove rk-flush to restore proper rkc when anthy-cancel-conv
	      performed
	    * Describe above intention as comment
	
2004-10-24 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/anthy.scm
	  - (anthy-init-lib-ok?): Rename to anthy-lib-initialized?
	  - (anthy-lib-initialized?): Renamed from anthy-init-lib-ok?
	  - (anthy-context-new): Follow the renaming
	
2004-10-24 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* test/test-ustr.scm
	  - (test ustr-append!, test ustr-append! #2, test ustr-prepend!, test
	    ustr-prepend! #2): Move the position in the file
	
2004-10-24 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/ustr.scm
	  - All changes are validated by test-ustr.scm
	  - (ustr-set-nth!, ustr-ref, ustr-cursor-at-beginning?,
	    ustr-cursor-at-end?): New procedure
	  - (ustr-cursor-set-frontside!, ustr-cursor-set-backside!):
	    * New procedure
	    * Returns whether the operation has been succeeded or not
	  - (ustr-set-cursor-pos!): Change the behavior on out of range as
	    returns whether the operation has been succeeded or not rather
	    than raise error
	  - (ustr-cursor-delete-frontside!, ustr-cursor-delete-backside!):
	    Change the behavior as returns whether the operation has been
	    succeeded or not
	  - (ustr-nth): Rewrite the implementation using ustr-ref for
	    efficiency
	  - (ustr-append!, ustr-prepend!): Move the position in the file
	* test/test-ustr.scm
	  - (test ustr-set-nth!, test ustr-ref, test
	    ustr-cursor-at-beginning?, test ustr-cursor-at-end?, test ustr-cursor-set-frontside!, test ustr-cursor-set-backside!): New test
	  - (test usr-nth): Add error checkings for invalid range
	  - (test ustr-set-cursor-pos!): Follow the specification change
	  - (test ustr-cursor-move!, test ustr-cursor-delete-frontside!, test
	    ustr-cursor-delete-backside!): Follow the implicit specification
	    change caused by ustr-set-cursor-pos!
	
	* scm/anthy.scm
	  - (anthy-context-rec-spec):
	    * Remove 'index-list' and 'cur-seg' to replace with 'segments'
	    * Add 'segments' as ustr of candidate indices
	    * Fix invalid default values
	  - (anthy-context-new):
	    * Fix broken anthy-lib existence check caused by a typo over sexp
	    * Simplify the initialization of ac-id
	    * Add initialization of anthy-context-segments
	  - (anthy-flush, anthy-converting-state-preedit,
	    anthy-get-commit-string, anthy-commit-string,
	    anthy-resize-segment, anthy-move-candidate,
	    anthy-get-candidate-handler): Follow the introduction of
	    anthy-context-segments
	  - (anthy-begin-conv):
	    * Add ac-id validity check moved from
	      anthy-proc-input-state-with-preedit
	    * Simplify
	  - (anthy-proc-input-state-with-preedit): Move ac-id validity check
	    to anthy-begin-conv
	  - (anthy-cancel-conv): Add anthy-context-segments handling
	  - (anthy-input-state-preedit):
	    * Follow the introduction of anthy-context-segments
	    * Suppress redundant empty segments
	  - (anthy-correct-segment-cursor): New procedure
	  - (anthy-move-segment):
	    * Follow the introduction of anthy-context-segments
	    * Add anthy-reset-candidate-window
	  - (anthy-proc-converting-state, anthy-set-candidate-index-handler):
	    * Follow the introduction of anthy-context-segments
	    * Simplify with new anthy-move-segment
	  - (anthy-release-key-handler): Cosmetic change
	  - (anthy-release-handler): Replace let* with let
	
2004-10-24 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* scm/anthy.scm:
	 - (anthy-make-whole-string): Store residual-kana to preconv-str
	   if possible.
	
2004-10-24 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/anthy.scm
	  - (anthy-context-rec-spec): Rename the inappropriate member name
	    'state' to 'converting'
	  - (anthy-flush, anthy-begin-input, anthy-update-preedit,
	    anthy-begin-conv, anthy-press-key-handler): Follow the renaming of
	    anthy-context-state
	  - (anthy-compose-state-preedit): Rename to
	    anthy-converting-state-preedit
	  - (anthy-converting-state-preedit): Rename from
	    anthy-compose-state-preedit
	  - (anthy-proc-compose-state): Rename to anthy-proc-converting-state
	  - (anthy-proc-converting-state): Rename from anthy-proc-compose-state
	  - (anthy-cancel-conv): New procedure
	  - (anthy-proc-converting-state): Simplify with anthy-cancel-conv
	
2004-10-23 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/anthy.scm
	  - (anthy-move-segment): Comsmetic change
	  - (anthy-resize-segment, anthy-move-candidate): Simplify
	
2004-10-23 kzk <mover@hct.zaq.ne.jp>
	
	* qt/qtkde-helper/src/candwin/uim-candwin-qt.cpp
	  - (moveCand): fix last candidate is hidden in size changing
	
	* qt/qtkde-helper/src/switcher/im-switcher-qt.h
	  - add Copyright
	* qt/qtkde-helper/src/switcher/im-switcher-qt.cpp
	  - add Copyright
	  - change default size
	
2004-10-23 kzk <mover@hct.zaq.ne.jp>
	
	* qt/qtkde-helper/src/candwin/uim-candwin-qt.cpp
	  - (moveCand): consider screen geometry
	
2004-10-23 kzk <mover@hct.zaq.ne.jp>
	
	* qt/qtkde-helper/src/common/uimstateindicator.cpp
	  - (propListUpdate): add ToolTip to the button
	  - delete unnecessary spaces
	
2004-10-23 kzk <mover@hct.zaq.ne.jp>
	
	* qt/qtkde-helper/src/candwin/uim-candwin-qt.cpp
	  - (activateCand): more empty check of given String
	  - (moveCand): Ditto
	* qt/qtkde-helper/src/common/uimstateindicator.cpp
	  - (propListUpdate): Ditto
	
2004-10-22 kzk <mover@hct.zaq.ne.jp>
	
	* This is the initial commit of uim-im-switcher-qt, the Qt
	  version of im switching tool.
	
	* qt/qtkde-helper/src/switcher/im-switcher-qt.h
	* qt/qtkde-helper/src/switcher/im-switcher-qt.cpp
	* qt/qtkde-helper/src/switcher/Makefile.am
	  - new files
	* qt/qtkde-helper/src/Makefile.am
	  - add switcher directory to subdirs
	* qt/qtkde-helper/src/common/quimhelpertoolbar.cpp
	  - use "uim-im-switcher-qt" instead of "uim-im-switcher"
	
	* helper/im-switcher-gtk.c
	  - fixed typo
	* helper/input-pad-ja.c
	  - (create_hiragana_tab): renamed from (create_tab1)
	  - (create_katakana_tab): renamed from (create_tab2)
	  - (create_eisu_tab): renamed from (create_tab3)
	
2004-10-22 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/locale.cpp (is_locale_included) : Indentation fixes.
	* xim/ximserver.cpp (InputContext::createUimContext) : Cosmetic
	  changes.
	(changeContext) : Update comment.
	* xim/ximserver.h : Add comment about get_first_locale().
	
2004-10-22 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/anthy.scm
	  - (anthy-begin-conv): Simplify
	
2004-10-22 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/anthy.scm
	  - (anthy-compose-state-preedit): Suppress garbage null segments
	
2004-10-22 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/util.scm
	  - (context-update-preedit): New procedure
	* scm/anthy.scm
	  - (anthy-update-preedit): Simplify with context-update-preedit
	  - (anthy-pushback-separator): Remove
	  - (anthy-separator): New procedure
	  - (anthy-pushback-preedit-segments): Remove. Merge into
	    anthy-compose-state-preedit
	  - (anthy-compose-state-preedit, anthy-input-state-preedit): Return
	    segment-list instead of pushback directly
	
2004-10-22 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/util.scm
	  - All changes are validated by test-util.scm
	  - (string-list-concat, string-find): Simplify
	  - (truncate-list): Replace the implementation with list-head's
	  - (list-head): Simplify using truncate-list
	  - (list-tabulate, iota): New procedure. Validated by test-util.scm
	  - (make-list): Simplify using list-tabulate
	  - (filter): Replace the implementation with iterate-lists
	  - (filter-map):
	    * Replace the implementation with iterate-lists
	    * Become multiple lists acceptable
	  - (multi-segment-make-index-list): Simplify using make-list
	  - (multi-segment-make-index-list-rec): Remove. Optimize out
	* test/test-util.scm
	  - (test list-tabulate, test iota): New test
	  - (test make-list): Add an error case
	  - (test filter-map): Add tests for multiple lists
	  - (testcase util multi-segment utils): New testcase
	  - (test multi-segment-make-index-list): New test
	  - (test multi-segment-opposite-kana): New test
	
	* scm/anthy.scm
	  - All changes are refactoring
	  - (anthy-append-string): Remove because unnecessary
	  - (anthy-begin-conv, anthy-move-candidate, anthy-resize-segment):
	    Cosmetic changes
	  - (anthy-proc-input-state-no-preedit,
	    anthy-proc-input-state-with-preedit): Replace anthy-append-string
	    with ustr-insert-elem!
	  - (anthy-pushback-preedit-segment-rec): Remove. Replaced with
	    anthy-pushback-preedit-segments
	  - (anthy-pushback-separator): New procedure
	  - (anthy-pushback-preedit-segments): New procedure. Replaces
	    anthy-pushback-preedit-segment-rec and simplifies
	  - (anthy-get-commit-string, anthy-commit-string): Simplify. The args
	    'idx' and 'nseg' are removed
	  - (anthy-compose-state-preedit, anthy-do-commit): Simplify
	  - (anthy-move-segment): Rename the inappropriate arg name 'dir' with
	    'offset'
	  - (anthy-reset-handler): Add a comment
	
	* doc/COMPATIBILITY
	  - Modify an English expression
	
	* scm/ustr.scm
	  - Remove outdated release information
	
2004-10-22 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* configure.ac: uim-canna doesn't build by default.
	
2004-10-21 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/COMPATIBILITY
	  - Add a new entry 'New logical order string API for Scheme (ustr)'
	  - Add a new entry 'New locale based IM-name retrieving API'
	
2004-10-21 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/ximserver.cpp (InputContext::createUimContext) : Use
	  combination of uim_get_default_im_name() and
	  uim_get_im_name_for_locale() for clients with legacy encoding.
	
2004-10-21 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit adds a im-name retrieving API function. See following
	  message thread
	  http://freedesktop.org/pipermail/uim/2004-October/000692.html
	
	* uim/uim.h
	  - (uim_get_im_name_for_locale): New API function
	* uim/uim.c
	  - (uim_get_im_name_for_locale): New function
	* scm/im.scm
	  - (uim-get-im-name-for-locale): New procedure
	
2004-10-21 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/locale.cpp : Update and fix typo in comment.
	* xim/ximtrans.cpp : Ditto.
	* xim/ximic.cpp : Ditto.
	* xim/ximserver.cpp : Ditto.
	* xim/convdisp.cpp : Ditto.
	(create_default_fontset) : Compare zh_TW:zh_HK explicitly.
	
2004-10-21 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/anthy.scm
	  - Require util.scm and ustr.scm
	  - (anthy-context-rec-spec):
	    * Remove left-string, right-string, left-raw-string,
	      right-raw-string, and unused-13th in the comment
	    * Add preconv-ustr and raw-ustr
	  - (anthy-context-new): Add initialization of preconv-ustr and
	      raw-ustr
	  - (anthy-flush): 
	    * Remove re-initialization for left-string, right-string,
	      left-raw-string and right-raw-string
	    * Add re-initialization for preconv-ustr and raw-ustr
	  - (anthy-make-whole-string, anthy-make-whole-raw-string,
	    anthy-append-string, anthy-proc-input-state-no-preedit,
	    anthy-has-preedit?, anthy-proc-input-state-with-preedit,
	    anthy-proc-input-state-with-preedit, anthy-input-state-preedit):
	    Simplify with ustr
	
2004-10-21 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* qt/qtkde-helper/src/common/uimstateindicator.cpp
	  - (tmpButton): Rename to a meaningful name 'fallbackButton'
	  - (fallbackButton): Renamed from tmpButton
	  - (UimStateIndicator): Follow the renaming of tmpButton
	  - (propListUpdate):
	    * Follow the renaming of tmpButton
	    * Raname 'tmpList' with a meaningful name 'fields'
	  - (propLabelUpdate): Raname 'tmpList' with a meaningful name
	    'fields'
	
	* qt/qtkde-helper/src/common/quimhelpertoolbar.h
	* qt/qtkde-helper/src/common/quimhelpertoolbar.cpp
	  - Replace CRLF in each line end with LF
	
2004-10-21 kzk <mover@hct.zaq.ne.jp>
	
	* cleaning qtkde-helper's Makefile.am
	
	* qtkde-helper/src/toolbar/Makefile.am
	  - add noinst_HEADERS
	  - link $(LIB_KDECORE) for i18n String
	* qtkde-helper/src/applet/Makefile.am
	  - delete "message:" rule
	
2004-10-21 kzk <mover@hct.zaq.ne.jp>
	
	* This commit aims to gettextize qtkde-helper
	
	* qtkde-helper/po/Makefile.am
	  - new file
	* qtkde-helper/po/uim-qtkde-helper.pot
	  - new file
	* qtkde-helper/src/common/quimhelpertoolbar.cpp
	  - add i18n string
	
	
2004-10-21 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/Makefile.am
	  - (SCM_FILES): Add ustr.scm and property.scm
	
	* scm/property.scm
	  - (register-property): Fix update of property-definition-list
	  - (record prop-state): Rename tooltip with short-desc to remove the
	    assumption about the purpose
	  - (property-new): Add error handling against invalid prop-id
	  - (property-next-state):
	    * Fix a wrong procedure invocation
	    * Show error message only when verbose level >= 5
	  - (property-will-state-transit?, property-transit-state!): Fix a
	    wrong procedure invocation
	  - (prop-state-compose-leaf):
	    * Fix a wrong procedure invocation
	    * Replace prop-state-tooltip with prop-state-short-desc
	  - (property-compose-live-branch): Fix wrong procedure invocations
	  - (register-property prop_anthy_input_mode): Fix wrong procedure
	    invocations
	* test/test-property.scm
	  - New file
	  - Some tests are not yet written
	  - (testcase property): New testcase
	  - (test register-property, test property-new, test
	     property-next-state property-will-state-transit?, test
	     property-transit-state!, test property-activate-state!, test
	     property-debug-message, test prop-state-compose-label, test
	     prop-state-compose-branch, test prop-state-compose-leaf, test
	     property-compose-live-branch): New test
	
2004-10-21 kzk <mover@hct.zaq.ne.jp>
	
	* This commit aims to prevent excessive update
	  of im-switcher exec button. For future, many
	  buttons like exec uim-dict will be added.
	  Updating these buttons on each list updating
	  is ugly.
	
	* src/common/quimhelpertoolbar.h
	* src/common/quimhelpertoolbar.cpp
	  - (checkHelperConnection, parseHelperStr,
	     propListUpdate, propLabelUpdate,
	     slotStdinActivated, insertHelperItem,
	     slotMenuActivated): moved to class
	    UimStateIndicator
	
	* src/common/uimstateindicator.h
	* src/common/uimstateindicator.cpp
	  - new files
	  - class UimStateIndicator deals with uim's
	    helper message handling. In contrast,
	    QUimHelperToolbar only deals with buttons
	    which aren't affected by helper messages.
	  - (checkHelperConnection, parseHelperStr,
	     propListUpdate, propLabelUpdate,
	     slotStdinActivated, insertHelperItem,
	     slotMenuActivated): moved from class
	     QUimHelperToolbar
	  - remove codes for debugging
	
	* src/common/Makefile.am
	  - updated
	
	* src/applet/uimhelperapplet.h
	* src/applet/uimhelperapplet.cpp
	  - (setPopupDirectionFromPosition): deleted
	    now in no use
	
2004-10-21 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/locale.cpp (find_localename_from_encoding) : Removed.
	(UTF8_Locale::uStringToCtext) : No need to call setlocale() here,
	  since InputContext::createUimContext() and
	  InputContext::focusIn() now handle it properly.
	(compose_localenames_from_im_lang) : Renamed from
	  compose_localename_from_im_lang() since it may compose locale
	  name list like zh_TW:zh_HK.
	(is_locale_included) : New function to check whether locale name
	  is included within locale name list.
	(get_first_locale) : New function.  Return first entry of locale
	  name list.
	* xim/xim.h : Add #include <X11/Xos.h>.  Thanks to KIHARA Hideto.
	(class XimIM) : Add new member function set_lang_region() and
	  get_lang_region().  Add new protected member variable
	  mLangRegion.
	(class icxatr) : Add new member function set_locale_name().  Change
	  font_set_name as private member.  Add new member m_locale.
	(class XimIC) : Add new member function get_lang_region().
	* xim/ximtrans.cpp (Connection::xim_open) : Get locale (lang and
	  region) information of client and store it.
	* xim/ximic.cpp (struct FSCache) : Add new member locale.
	(get_font_set) : Check locale information of fontset.
	(release_font_set) : Ditto.
	(icxatr::set_locale_name) : Store locale name information.
	(XimIC::XimIC) : Get locale name information from InputContext and
	  store it in m_xatr.
	(XimIC::force_send_packet) : Explicitly write down dynamic_cast.
	* xim/ximim.cpp (XimIM::set_lang_region) : New function.  Store
	  locale (lang and region) information of client.
	(XimIM::get_lang_region) : New function.  Return lang and region
	  information of client.
	* xim/main.cpp (init_supported_locales) : Handle locale name list
	  properly.  Plug leak.
	(send_im_list) : Handle locale name list properly.
	(main) : Don't call init_convdisp().
	* xim/ximserver.cpp : Add #include <X11/Xlib.h>.
	(InputContext::createUimContext) : Handle client's locale
	  properly.  Store working locale name of the context.
	(InputContext::changeContext) : Handle locale name list properly.
	  Set locale name information into mConvdisp.
	(InputContext::focusIn) : Call setlocale() with proper locale
	  name.
	(InputContext::get_locale_name) : New function.  Return working
	  locale name of the context.
	* xim/convdisp.cpp : Remove global default fontsets.
	(init_convdisp) : Removed.
	(create_default_fontset) : New function to create default fontset
	  considering with locale information for root-style preedit
	  window.
	(choose_default_fontset) : Use locale name as a argument and call
	  create_default_fontset().
	(class PeWin) : Now constructor uses locale name information.
	(class PeLineWin) : Ditto.
	(class PeOvWin) : Ditto.
	(class ConvdispOv) : Rename set_lang() as set_im_lang().
	(Convdisp::Convdisp) : Store locale name information of its
	  InputContext.
	(Convdisp::set_locale_name) : New function.
	* xim/ximserver.h : Add some new prototype from xim/locale.c.
	(class InputContext) : Add new member function
	  get_locale_name() and new variable mLocaleName.
	* xim/convdisp.h (class Convdisp) : Rename set_lang() as
	  set_im_lang().  Add set_locale_name().  Add mLocaleName.
	(get_font_set) : Use locale name as a argument.
	
2004-10-20 Takuro Ashie <ashie@homa.ne.jp>
	
	* configure.ac: Marked uim-dict as broken.
	
2004-10-20 Takuro Ashie <ashie@homa.ne.jp>
	
	* helper/Makefile.am, helper/dict-anthy.c, helper/dict-anthy.h
	  helper/dict-canna.c, helper/dict-canna.h, helper/dict-cclass-dialog.c
	  helper/dict-cclass-dialog.h, helper/dict-dict.c, helper/dict-dict.h
	  helper/dict-main-gtk.c, helper/dict-main-gtk.h, helper/dict-util.c
	  helper/dict-util.h, helper/dict-word-list-view-gtk.c
	  helper/dict-word-list-view-gtk.h, helper/dict-word-list-win-gtk.c
	  helper/dict-word-list-win-gtk.h, helper/dict-word-win-gtk.c
	  helper/dict-word-win-gtk.h, helper/dict-word.c, helper/dict-word.h:
	  - Added new dictionary management tool.
	  - It's based on sumika, and many code improvements are made.
	  - Currentry, it support only Anthy.
	  - It's still broken. To complete this work, we should modify Anthy's
	    API. It's too poor and buggy for GUI use.
	
2004-10-18 kzk <mover@hct.zaq.ne.jp>
	
	* Refactoring of PopupMenu handling
	
	* qt/qtkde-helper/src/common/quimhelpertoolbar.cpp
	* qt/qtkde-helper/src/common/quimhelpertoolbar.h
	  - (class QHelperButton): deleted
	  - (propListUpdate): use QToolButton's native PopupMenu
	    handling instead of original one. This seems more
	    general way than before.
	
2004-10-18 kzk <mover@hct.zaq.ne.jp>
	
	* qt/qtkde-helper/src/common/quimhelpertoolbar.cpp
	  - (propListUpdate): use pressed() instead of clicked().
	    This is the way official QPushButton does. This will
	    prevent the problem which popup menu is hidden
	    immediately (this is reported by UEYAMA-san, thank you)
	
2004-10-18 kzk <mover@hct.zaq.ne.jp>
	
	* qt/quiminputcontextplugin/src/candidatewindow.cp
	* qt/quiminputcontextplugin/src/candidatewindow.h
	  - (slotCandidateSelected): remove wrong "const" qualifier
	
	* qt/qtkde-helper/src/candwin/uim-candwin-qt.h
	* qt/qtkde-helper/src/candwin/uim-candwin-qt.cpp
	  - (slotCandidateSelected): remove wrong "const" qualifier
	  - handle candwin's position correctly
	  - handle charset correctly (previously, message is always
	    supposed to be UTF-8 encoded. this bug is reported by
	    UEYAMA-san. thank you!)
	
2004-10-18 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/locale.cpp : Explicitly use "im_lang" instead of "lang" as
	  argument names.
	(class UTF8_Locale) : Rename set_localename_from_lang() into
	  set_localename_from_im_lang().  Remove
	  compose_localename_from_lang() from the member.
	(compose_localename_from_im_lang) : Move from class UTF8_Locale
	  and renamed.
	* xim/connection.h : Cosmetic changes.
	* xim/ximic.cpp (get_font_set) : Remove static.
	* xim/ximserver.cpp : Use renamed member variables, mIMName and
	  mIMLang
	(XimServer::get_im_lang_from_engine) : Change to set mEngineName
	  in createUimContext().
	(XimServer::createUimContext) : Set mEngineName here.
	* xim/main.cpp : Cosmetic changes.
	* xim/convdisp.cpp (create_default_fontset) : Create default
	  fontset mainly for UTF-8 locale used with root-style preedit
	  window.
	(choose_default_fontset) : Use encoding information, and set
	  default fontset only for legacy encodings.
	* xim/canddisp.cpp : Include "config.h" instead of <config.h>.
	* xim/ximserver.h (class XimServer) : Rename private variable
	  mName and mLang into mIMName and mIMLang.
	* xim/convdisp.h : Add prototype get_font_set().
	* xim/xdispatch.h : Cosmetic change.
	
2004-10-18 kzk <mover@hct.zaq.ne.jp>
	
	* qt/qtkde-helper/src/common/quimhelpertoolbar.cpp
	  - (slotStdinActivated): fix the crash of wrong message parsing
	
2004-10-18 kzk <mover@hct.zaq.ne.jp>
	
	* qt/qtkde-helper/src/toolbar/draghandler.h
	* qt/qtkde-helper/src/candwin/uim-candwin-qt.h
	  - prevent reincluding header file
	
2004-10-18 kzk <mover@hct.zaq.ne.jp>
	
	* release UimQt 0.2.0 and qtkde-helper 0.1.0-beta1
	* add "const" qualifier to many functions
	
	* qt/quiminputcontextplugin/configure.in.in
	  - release 0.2.0 (require uim 0.4.4)
	* qt/quiminputcontextplugin/qhelpermanager.h
	* qt/quiminputcontextplugin/qhelpermanager.cpp
	  - (parseHelperStr): add const qualifier
	  - (parseHelperStrImChage): Ditto
	* qt/quiminputcontextplugin/quiminputcontext.h
	* qt/quiminputcontextplugin/quiminputcontext.cpp
	  - (commitString, pushbackPreeditString): Ditto
	* qt/quiminputcontextplugin/candidatewindow.h
	* qt/quiminputcontextplugin/candidatewindow.cpp
	  - (setCandidates): Ditto (much optimized!)
	  - (slotCandidateSelected): Ditto
	
	* qt/quiminputcontextplugin-qt4/qhelpermanager.h
	* qt/quiminputcontextplugin-qt4/qhelpermanager.cpp
	  - (parseHelperStr, parseHelperStrImChange): Ditto
	* qt/quiminputcontextplugin-qt4/quiminputcontext.h
	* qt/quiminputcontextplugin-qt4/quiminputcontext.cpp
	  - (commitString, pushbackPreeditString): Ditto
	* qt/quiminputcontextplugin-qt4/candidatewindow.h
	* qt/quiminputcontextplugin-qt4/candidatewindow.cpp
	  - (setCandidates): Ditto
	
	* qt/qtkde-helper/configure.in.in
	  - release 0.1.0-beta1
	* qt/qtkde-helper/src/candwin/uim-candwin.h
	* qt/qtkde-helper/src/candwin/uim-candwin.cpp
	  - (activateCandm selectCand, moveCand,
	     slotCandidateSelected, strParse): add const qualifier
	* qt/qtkde-helper/src/common/quimhelpertoolbar.h
	* qt/qtkde-helper/src/common/quimhelpertoolbar.cpp
	  - (parseHelperStr, propListUpdate, propLabelUpdate): Ditto
	
	
2004-10-18 kzk <mover@hct.zaq.ne.jp>
	
	* qt/qtkde-helper/bootstrap
	  - add "release" option
	
	* qt/qtkde-helper/src/candwin/uim-candwin-qt.cpp
	  - (activateCand): handle charset correctly
	
2004-10-18 kzk <mover@hct.zaq.ne.jp>
	
	* qt/qtkde-helper/src/applet/uimhelperapplet.h
	  - remove (resizeEvent)
	* qt/qtkde-helper/src/applet/uimhelperapplet.cpp
	  - remvoe (resizeEvent)
	  - fix applet size handling (fit for the contents).
	
2004-10-16 Masanari Yamamoto <h013177b@ice.nuie.nagoya-u.ac.jp>
	
	* fep/uim-fep.c, README.ja
	  - (get_default_im_name): delete UIM_FEP environment variable
	  - (usage): add short description
	  - (init_agent): check im name
	
	* fep/str.c 
	  - (get_enc) replace LC_ALL, LC_CTYPE, LANG with setlocale(LC_CTYPE, "")
	
2004-10-16 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit makes ustr ready to use
	
	* uim/slib.c
	  - (my_err): Disable backtrace if (siod_verbose_level < 5) for valid
	    interaction between uim-test-util and uim-sh
	
	* scm/util.scm
	  - (list-head, list-tail): Add lower bound range checking for
	    ustr-cursor-move!
	* test/test-util.scm
	  - Add copyright header
	  - (list-head, list-tail): Add lower bound range checking
	
	* scm/ustr.scm
	  - Modify some comments about usage
	  - All procedures has been validated by test-ustr.scm and ready to use
	  - (ustr=): New procedure
	  - (ustr-copy!, ustr-nth, ustr-cursor-move-beginning!,
	    ustr-cursor-delete-frontside!, ustr-cursor-delete-backside!,
	    ustr-insert-elem!): Fix invalid argument passing
	  - (ustr-set-cursor-pos!):
	    * Fix wrong procedure name on calling
	    * Error handling has implicitly been added by list-tail and
	      list-head
	  - (ustr-cursor-move!): Error handling has implicitly been added by
	    ustr-set-cursor-pos!
	  - (ustr-cursor-move-backward!, ustr-cursor-move-forward!): Fix
	    invalid list reorganization
	  - (ustr-cursor-frontside, ustr-cursor-backside):
	    * Fix returning wrong opposite side element
	    * Add error handling about range checking
	* test/test-ustr.scm
	  - New file
	  - (testcase ustr): New testcase
	  - (test ustr-new, test ustr-whole-seq, test ustr-former-seq, test
	     ustr-latter-seq, test ustr-set-whole-seq!, test
	     ustr-set-former-seq!, test ustr-set-latter-seq!, test
	     ustr-empty?, test ustr-clear!, test ustr-clear-former!, test
	     ustr-clear-latter!, test ustr-copy!, test ustr=, test
	     ustr-length, test ustr-nth, test map-ustr-whole, test
	     map-ustr-former, test map-ustr-latter, test
	     append-map-ustr-whole, test append-map-ustr-former, test
	     append-map-ustr-latter, test string-append-map-ustr-whole, test
	     string-append-map-ustr-former, test
	     string-append-map-ustr-latter, test ustr-cursor-pos, test
	     ustr-set-cursor-pos!, test ustr-cursor-move!, test
	     ustr-cursor-move-backward!, test ustr-cursor-move-forward!, test
	     ustr-cursor-move-beginning!, test ustr-cursor-move-end!, test
	     ustr-cursor-frontside, test ustr-cursor-backside, test
	     ustr-cursor-delete-frontside!, test ustr-cursor-delete-backside!,
	     test ustr-insert-elem!, test ustr-insert-seq!, test
	     ustr-insert-seq! #2, test ustr-append!, test ustr-append! #2,
	     test ustr-prepend!, test ustr-prepend! #2): New test
	
	* test-custom.scm
	* test-i18n.scm
	* test-im.scm
	* test-intl.scm
	* test-key.scm
	* test-slib.scm
	* test-uim-test-utils.scm
	* test-uim-util.scm
	* test-util.scm
	  - Add copyright header
	
2004-10-16 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/convdisp.cpp (set_lang) : Disable fontset change of 
	  over-the-spot style preedit area upon im-switch.
	
2004-10-15 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* scm/skk.scm (skk-use-with-vi?) : New config for comfortable use
	  of skk with vi.
	(skk-vi-escape-key?) : New key definition.
	(skk-proc-state-direct-no-preedit) : Check skk-use-with-vi? first
	  and if this is #t, change its state into skk-state-latin with
	  escape key.
	(skk-proc-state-wide-latin) : Ditto.
	
2004-10-15 kzk <mover@hct.zaq.ne.jp>
	
	* Rename "uim-helper-candwin-qt" to "uim-candwin-qt"
	
	* qt/qtkde-helper/src/candwin/uim-candwin-qt.h
	  - renamed from uim-helper-candwin-qt.h
	* qt/qtkde-helper/src/candwin/uim-candwin-qt.cpp
	  - renamed from uim-helper-candwin-qt.cpp
	* qt/qtkde-helper/src/candwin/Makefile.am
	  - modified
	
	
2004-10-15 kzk <mover@hct.zaq.ne.jp>
	
	* This commit aims to add draggable function to
	  uim-toolbar-qt
	
	* qt/qtkde-helper/src/toolbar/draghandler.h
	* qt/qtkde-helper/src/toolbar/draghandler.cpp
	  - the indicator by which users can drag whole toolbar
	  - (class UimToolbarDraggingHandler): new class
	
	* qt/qtkde-helper/src/toolbar/uim-toolbar-qt.cpp
	  - renamed from uim-helper-toolbar-qt.cpp
	  - add draghandler
	
	* qt/qtkde-helper/src/toolbar/Makefile.am
	  - modified
	
2004-10-15 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/locale.cpp : Add #include <locale.h>.
	
2004-10-15 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* configure.ac: Release 0.4.5-beta1
	
2004-10-15 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* scm/anthy.scm:
	 - (anthy-latin-key?): Added control-j.
	
2004-10-15 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/ximserver.cpp (check_modifier) : Fix typo.
	
2004-10-14 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/util.scm
	  - (list-head, list-tail):
	    * Add error handling for out of range
	    * Validated by test-util.scm and ready to use
	  - (make-list, zip, append-reverse, find, any, every, fold, remove,
	    alist-delete): Validated by test-util.scm and ready to use
	* test/test-util.scm
	  - (test list-head, test list-tail, test make-list, test zip, test
	    find, test any, test every, test fold, test remove, test
	    alist-delete): New test
	
2004-10-14 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit adds a preliminary 'ustr' object. But it is not yet used
	  by current uim implementation, and not yet tested. it will be
	  incorporated into various scm files after next stable uim has been
	  released.
	
	  'ustr' stands for 'universal string'. It represents a logical order
	  string of abstract elements for general purpose. Since it does not
	  assume any specific type of the elements, we can reuse it against
	  several generations of composition table architectures such as rk or
	  hk. It should be isolated from composition table architecture to
	  keep flexibility, reusability and simplicity. ustr provides only
	  basic string operations.
	
	  Developers, take a look into the code (but do not review, it's not
	  validated by test yet) and tell me your requirements or
	  opinions. I'm going to redesign of composition table architecture
	  based on this to simplify each IM codes to prepare introduction of
	  more complex IM features. I'll post the suggestion to the
	  mailinglist after next stable release.
	
	* scm/ustr.scm
	  - New file
	  - All procedures are not yet validated by test
	  - (ustr-rec-spec): New variable
	  - (record ustr): New record
	  - (ustr-new-internal): New alias for define-record'ed ustr-new
	  - (ustr-new, ustr-whole-seq, ustr-former-seq, ustr-latter-seq,
	    ustr-set-whole-seq!, ustr-set-former-seq!, ustr-set-latter-seq!,
	    ustr-empty?, ustr-clear!, ustr-clear-former!, ustr-clear-latter!,
	    ustr-copy!, ustr-length, ustr-nth, map-ustr-whole,
	    map-ustr-former, map-ustr-latter, append-map-ustr-whole,
	    append-map-ustr-former, append-map-ustr-latter,
	    string-append-map-ustr-whole, string-append-map-ustr-former,
	    string-append-map-ustr-latter, ustr-cursor-pos,
	    ustr-set-cursor-pos!, ustr-cursor-move!,
	    ustr-cursor-move-backward!, ustr-cursor-move-forward!,
	    ustr-cursor-move-beginning!, ustr-cursor-move-end!,
	    ustr-cursor-frontside, ustr-cursor-backside,
	    ustr-cursor-delete-backside!, ustr-cursor-delete-frontside!,
	    ustr-insert-elem!, ustr-insert-seq!, ustr-append!, ustr-prepend!):
	    New procedure
	
	* scm/util.scm
	  - All procedures added by this commit are not yet validated by test
	  - (iterate-lists): New procedure for local use
	  - (make-list, zip, append-reverse, any, every, remove,
	    alist-delete): New SRFI procedure
	  - (fold): Make workable
	  - (filter, filter-map): Add an alternative implementation as
	    comment. It will replace old one after next stable release
	
	* scm/Makefile.am
	  - (SCM_FILES): Add ustr.scm and property.scm into a comment as
	    placeholder
	
	* scm/property.scm
	  - Modify a comment about release plan
	
2004-10-13 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/locale.cpp (find_localename_from_encoding) : Support
	  zh_CN.gb2312 and zh_HK.big5hkscs locale.
	
2004-10-13 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/ximserver.cpp (InputContext::pushback_preedit_string) :
	  Recover wrong change in r1432, and add comment about this.
	
2004-10-13 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/main.cpp (remove_current_fd_watch) : Remove static
	  declaration.
	* xim/canddisp.cpp (candwin_read_cb) : Indentation fix.  Close fd
	  and stop fd watch of candidate helper application if it crashes
	  or doesn't exist.
	
2004-10-13 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* doc/XIM-SERVER : Update 'Internal Implementation' section.
	
2004-10-13 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* uim/intl.c : Move place of including config.h.
	
2004-10-13 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* uim/intl.c
	  - Surround #include <locale.h> with #ifdef ENABLE_NLS
	
2004-10-13 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/XIM-SERVER
	  - Add a new section 'Internal Implementation' which describes what
	    happened to the xim-uim recently
	
2004-10-12 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/XIM-SERVER
	  - Fix an English word
	
2004-10-12 kzk <mover@hct.zaq.ne.jp>
	
	* qt/qtkde-helper/src
	  - add uim project's copyright to all the file(*.h and *.cpp).
	
2004-10-12 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/locale.cpp (utf8_to_native_str) : Plug leak.
	* xim/ximic.cpp (XimIC::onSendPacket) : Delete string if
	  conversion fails.
	* xim/ximserver.cpp (InputContext::createUimContext) : Add
	  comment.
	
2004-10-12 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* doc/XIM-SERVER : Add caveat about working encoding.
	
2004-10-12 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/locale.cpp (utf8_to_native_str) : Cosmetic change.
	(utf8_wctomb) : Ditto.
	* xim/ximic.cpp (XimIC::reset_ic) : Do more sanity response if
	  converting to compound text fails.
	(XimIC::onSendPacket) : Ditto.
	* xim/convdisp.cpp (ConvdispOv::layoutCharEnt) : Don't return even
	  if string conversion fails.
	
2004-10-12 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/locale.cpp (utf8_mbtowc) : Cosmetic change.
	(utf8_wctomb) : Ditto.
	
2004-10-12 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* gtk/gtk-im-uim.c
	  - Re-include uim/uim-im-switcher.h which commented out in
	    r1468. It's a required header
	  - Replace inappropriate #include <uim/foo> with #include "uim/foo"
	
2004-10-12 Takuro Ashie <ashie@homa.ne.jp>
	
	* gtk/gtk-im-uim.c: Fixed compile time error & warnings.
	
2004-10-12 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* configure.ac
	  - Add new option --enable-dict to make build of uim-dict
	    configurable. Since it had been derived from Sumika, it also
	    requires GTK+ 2.4.0 or later. So we must separate it from normal
	    GTK2 category for other helper applets
	* helper/Makefile.am
	  - Build uim-dict only if DICT is defined
	
2004-10-12 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* uim/uim-func.c
	  - (uim_iconv_code_conv): Replace const qualifier of second arg of
	    iconv(3) with ICONV_CONST macro to suppress warning on Linux glibc
	    version of iconv(3)
	* xim/locale.cpp
	  - (utf8_to_native_str): Cast second arg of iconv(3) to (ICONV_CONST
	    char **) to avoid compilation error on GNU libiconv version of
	    iconv(3) which FreeBSD platform uses
	
	* uim/intl.c
	  - Add #include <string.h>
	
2004-10-11 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/anthy.scm
	  - (anthy-begin-conv): Fix pending rk string truncation problem
	    reported in [Anthy-dev 1169] by Konosuke Watanabe. Thanks. It had
	    been enbuged in r1447
	
2004-10-11 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/default-im.scm
	  - (default-init-handler): Disable im-list for mode
	  - (default-mode-handler): Disable im-switching by mode switching
	
2004-10-11 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/locale.cpp : Revert r1461 change since it breaks compilation on
	  Linux.
	
2004-10-11 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/locale.cpp (ustring_to_utf8_str) : Change to use locally
	  prepared wctomb().
	(utf8_to_native_str) : New.
	(UTF8_Locale::uStringToCtext) : Do setlocale() with locale name
	  retrived from encoding name.  Add sanity check.
	(UTF8_Locale::compose_localename_from_lang) : Change to return
	  names without UTF-8 encoding name.
	(utf8_mbtowc) : New.
	(utf8_wctomb) : New.
	(find_localename_from_encode) : Remove static.
	(utf8_to_native_str) : Ditto.  Return NULL if it fails to convert.
	* xim/ximic.cpp (XimIC::reset_ic) : Add sanity check.
	(XimIC::onSendPacket) : Ditto.
	* xim/main.cpp (init_supported_locales) : Don't check UTF-8 name
	  since now compose_localename_from_lang() returns name without
	  UTF-8 suffix.
	(send_im_list) : Only send im with supported encoding of the
	  context.
	* xim/ximserver.cpp (print_ustring) : Use locally prepared
	  wctomb().
	(XimServer::strToUstring) : Use locally prepared mbtowc().
	(InputContext::createUimContext) : Do setlocale() with
	  corresponding encoding of own context.  Use default im if
	  encoding of the contexts doesn't match the one from requested
	  im.
	(InputContext::changeContext) : Don't change im if encoding of the
	  context doesn't match the one from requested im.
	(InputContext::focusIn) : Ditto.
	* xim/convdisp.cpp (init_convdisp) : Change to create fontset with
	  locale with legacy encoding.
	(class PeWin) : Add argument encoding for PeWin().  Add new
	  variable mEncoding.
	(class PeLineWin) : Add argument encoding for PeLineWin().
	(class PeOvWin) : Add argument encoding for PeOvWin().
	(PeWin::draw_char) : Use XmbDrawImageString() instead of
	  XwcDrawImageString() for string which has been converted to
	  legacy encoding.
	(ConvdispOv::layoutCharEnt) : Use XmbTextExtents().
	(ConvdispOs::compose_preedit_array) : Add sanity check.
	* xim/ximserver.h : Add new prototypes, utf8_to_native_str(),
		  utf8_mbtowc(), and utf8_wctomb().
	
2004-10-11 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* xim/locale.cpp
	  - (utf8_to_native_str): Fix a compile error involving constness
	    checking
	
2004-10-11 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* uim/intl.c
	  - (intl_init_locale):
	    * Remove invalid textdomain("uim") here. textdomain() must not be
	      performed by a library because it masks application's one. Use
	      dgettext() always. This fixed bug #1599
	    * Perform setlocale(3) only if it maybe did not performed
	      before. This avoids the pointer invalidation of the string
	      previously returned by setlocale() in some case
	
2004-10-11 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* helper/toolbar-common-gtk.c
	  - (prop_button_released): Add GTK_CHECK_VERSION() to avoid bug #1598
	
	* scm/util.scm
	  - Add a procedure category header as comment
	
2004-10-11 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/util.scm
	  - Oops, previous commit (r1457) also committed these 3 preliminary
	    procedures as side effect. They are not tested or completed. Don't
	    use them yet.
	  - (list-head): New de facto standard procedure
	  - (list-tail): New R5RS procedure
	  - (fold): New SRFI procedure
	
2004-10-11 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit fixes bug #1600 'uim-fep does not look up standard
	  default IM configuration'
	
	* fep/uim-fep.c
	  - (DEFAULT_ENGINE): Remove to replace with standard uim default IM
	    selection scheme
	  - (get_default_im_name): New static function. It gets default IM
	    name by get_default_im_name().
	  - (main, usage): Replace default IM lookup with get_default_im_name()
	
2004-10-11 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/locale.cpp (UTF8_Locale::uStringToCtext) : Convert utf8
	  string into XCompoundtext via native locale string.
	(find_localename_from_encoding) : New.  Handles only CJK locale
	  for the moment.
	(utf8_to_native_str) : New.
	* xim/xim.h (class XimIM) : Add member function set_encoding() and
	  get_encoding().  Add private variable mEncoding.
	(class XimIC) : Add member function get_encoding().
	* xim/ximtrans.cpp (Connection::xim_encoding_negotiation) : Check
	  encoding.
	* xim/ximic.cpp (XimIC::reset_ic) : Convert uString into Ctext
	  using encoding information.
	(XimIC::onSendPacket) : Ditto.
	* xim/ximim.cpp (XimIM::set_encoding) : New.
	(XimIM::get_encoding) : New.
	* xim/ximserver.cpp (XimServer::uStringToCtext) : Use encoding.
	* xim/convdisp.cpp (Convdisp::Convdisp) : Get encoding information
	  from its XimIC.
	(ConvdispOs::compose_preedit_array) : Convert uString into Ctext
	  using encoding information.
	* xim/ximserver.h (class Locale) : Add argument encoding for
	  uStringToCtext().
	* xim/convdisp.h (class Convdisp) : Add new variable mEncoding.
	
2004-10-11 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* configure.ac: Release 0.4.4.2.
	
2004-10-11 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* test/Makefile.am:
	 - Removed unexisting files.
	
2004-10-11 Masahito Omote <omote@utyuuzin.net>
	
	* canna.scm (canna-proc-input-state-no-preedit): Fix not accepting some keys
	  when no preedit exists.
	
2004-10-11 Masahito Omote <omote@utyuuzin.net>
	
	* helper/GNOME_UimApplet.server.in.in: s/helper/toolbar/.
	
2004-10-11 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* sumika/
	 include/canna.h: Removed unneed file.
	 gtk2/cannacontainer.c: Ditto.
	 gtk2/cannacontainer.h: Ditto. 
	
2004-10-11 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* sumika/:
	 ad-hoc modification for through compile process.
	
2004-10-11 kzk <mover@hct.zaq.ne.jp>
	
	* xim/canddisp.cpp
	  - (candwin_command): "uim-candwin-gtk" was renamed from
	    "uim-helper-candwin-gtk"
	
2004-10-10 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/anthy.scm
	  - Add comments about the role for members of anthy-context
	  - Fix some default values of anthy-context
	  - (anthy-begin-conv): Fix invalid conversion state when beginning a
	    conversion with preedit only contains rkc pending string
	  - (anthy-flush): Add cur-seg re-initialization
	
2004-10-10 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* configure.ac: Release 0.4.4.1.
	
2004-10-10 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* uim/agent.c:
	 - changed #include <uim/uim.h> to "uim.h". Old style isn't valid 
	   if uim isn't installed already.
	
2004-10-10 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* configure.ac: Release 0.4.4.
	
2004-10-10 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* helper/Makefile.am:
	 - Added top_buidddir to CPPFLAGS to pass make distcheck.
	 
	* gtk/Makefile.am:
	 - Ditto.
	
2004-10-10 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/japanese.scm
	  - (ja-rk-rule-basic):
	    * Replace wide-katakana result of "xca", "xka", "xka" with similar
	      hankaku-katakana
	    * Add lacking hankaku-katakana result slot of "z/" and so on
	  - (ja-rk-rule-additional): Remove inappropriate spaces in results
	
2004-10-10 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/japanese.scm
	  - Revert all changes came from invalid patch application in r1370
	  - Cleanly re-apply the patch contributed in [Anthy-dev 1101] by
	    OHASHI Hideya. Thanks
	  - (ja-rk-rule-basic): Most of unfamiliar 3-letter romaji entries
	    that conflicts AZIK composing rules has been moved into
	    ja-rk-rule-additional
	  - (ja-rk-rule-additional): Import the 3-letter romaji entries from
	    the ja-rk-rule-basic
	* doc/COMPATIBILITY
	  - Rename the inappropriate entry title 'Additional romaji-kana
	    conversion table has been added' to 'romaji-kana conversion table
	    has been split into two parts'
	  - Describe the changes
	
2004-10-10 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* uim/uim.h
	  - (uim_init): Add a attention about setlocale(3)
	
2004-10-10 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* xim/main.cpp:
	 - (main): Moved the location of setlocale just before check_default_engine.
	
2004-10-10 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* uim/uim-helper.c
	  - (uim_helper_fd): Make static. This function should not be exported
	    since it uses local enum definition which has a popular short name
	    easy to conflict
	  - (uim_helper_fd_readable): Reenable the function
	* uim/uim-helper.h
	  - (uim_helper_fd_readable): Exported
	
	* uim/uim-helper-client.c
	  - (uim_helper_read_proc): Replace uim_helper_fd() with
	    uim_helper_fd_readable()
	
	* doc/COMPATIBILITY
	  - Add a new entry 'uim_helper_fd_readable() has been exported'
	
2004-10-10 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* uim.pc.in : Add @LIBINTL@ and @M17NLIB_LIBS@ for Libs.
	* xim/Makefile.am : Add connection.h for uim_xim_SOURCES.
	
2004-10-10 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit moves the 2 im-switching API functions into
	  uim-im-switcher.h to segregate the optional im-switching feature
	  from uim core
	
	* uim/uim.h
	  - (uim_switch_im, uim_get_current_im_name): Move into
	    uim-im-switcher.h
	* uim/uim-im-switcher.h
	  - New file
	  - (uim_switch_im, uim_get_current_im_name): Moved from uim.h
	* uim/Makefile.am
	  - (libuim_la_SOURCES): Move uim-util.h to pkginclude_HEADERS because
	    external uim bridges such as MacUIM or IMKit-uim will require it
	    installed
	  - (pkginclude_HEADERS): Add uim-util.h and uim-im-switcher.h
	* uim/uim.c
	* qt/quiminputcontextplugin/src/qhelpermanager.cpp
	* qt/quiminputcontextplugin-qt4/qhelpermanager.cpp
	* gtk/gtk-im-uim.c
	* xim/main.cpp
	  - Add #include "uim-im-switcher.h"
	
2004-10-09 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/COMPATIBILITY
	  - Describe about order of entries
	
	* scm/property.scm
	  - (prop-state-compose-leaf): Add missing 'leaf' tag
	  - (property-prop-activate-handler): Rename to
	    context-prop-activate-handler to indicate correct belongingness of
	    the procedure
	  - (context-prop-activate-handler): Renamed from
	    property-prop-activate-handler
	  - (property-mode-handler): Rename to context-mode-handler to
	    indicate correct belongingness of the procedure
	  - (context-mode-handler): Renamed from property-mode-handler
	  - (prop-list-find-mode-prop): Cosmetic change
	
2004-10-09 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/connection.cpp : Cosmetic changes.
	* xim/locale.cpp : Ditto.
	* xim/xim.h : Fix comment.
	(class XimIC) : Remove changeMode().
	* xim/ximtrans.cpp : Cosmetic changes.
	* xim/ximic.cpp : Ditto.
	(XimIC::changeMode) : Remove.
	(ui_update_ic_stat) : Remove.
	(ui_update_input_mode) : Remove.
	* xim/ximim.cpp : Cosmetic changes.
	* xim/main.cpp : Ditto.
	* xim/ximserver.cpp : Ditto.
	(InputContext::getMode) : Removed.
	(InputContext::setMode) : Removed.
	* xim/canddisp.cpp : Cosmetic changes.
	* xim/convdisp.cpp : Ditto.
	* xim/ximpacket.cpp : Ditto.
	* xim/ximsever.cpp (class InputContext) : Cosmetic changes.
	  Remove unused getMode() and setMode().
	* xim/canddisp.h : Cosmetic changes.
	
2004-10-09 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/HELPER-PROTOCOL
	  - Replace the abstract of 'Property messages' section which had been
	    described incorrectly by my misunderstanding of what 'property'
	    represents. The word 'property' implies that it is owned by
	    something, but I couldn't identify which element is a property,
	    and what owns a property. Now I've found a consistent mapping 'a
	    branch = a property' and 'an input context = an owner'. So I've
	    modified the description in accordance with the mapping. Sorry for
	    my impatient misunderstanding. Please tell me the truth if I'm still
	    misunderstanding.
	  - (prop_list_update): Add an explanation for branch which represents
	    property
	
2004-10-09 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/COMPATIBILITY
	  - Add a new entry 'Flag field has been added to prop_list_update message'
	
2004-10-09 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/COMPATIBILITY
	  - Move uim_get_default_im_name() from 'New IM-switching related API'
	    into 'New information retrival API'
	  - Update 'New information retrival API'
	  - Update 'New IM-switching related API'
	
2004-10-09 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* configure.ac
	  - Replace agent.c with COPYING for AC_CONFIG_SRCDIR. Thanks to Jun
	    Inoue
	* Makefile.am
	  - Remove obsolete gabage entries for uim-agent
	
	* scm/Makefile.am
	  - Remove obsolete iso-639-1.scm from SCM_FILES
	
	* scm/property.scm
	  - Was new file appeared in r1427
	
2004-10-08 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit adds a preliminary property handling framework. But it
	  is not yet used by current uim implementation, and not yet
	  tested. It is maybe used in 0.4.5 release.
	
	  This framework eliminates all of property related handlings such as
	  im-update-prop-list or im-update-prop-label from each input
	  method. Input method developer can forget about the property feature
	  (and legacy 'mode' feature implicitly handled by this framework)
	  except for register-property, register-im and init-handler.
	
	  Developers, take a look into the code (but do not review, it's
	  completely lacking tests) and tell me your requirements.
	
	* scm/property.scm
	  - Contains property definitions for anthy. It will be moved into
	    anthy.scm later
	  - (record property-definition, record prop-state, record property):
	    New record
	  - (property-new-internal): New alias for define-record'ed
	    property-new
	  - (property-definition-list, property-definition-rec-spec): New
	    variable
	  - (register-property, property-new, property-next-state,
	    property-will-state-transit?, property-transit-state!,
	    property-activate-state!, property-debug-message,
	    prop-state-compose-label, prop-state-compose-branch,
	    prop-state-compose-leaf, property-compose-live-branch,
	    context-init-prop-list, context-propagate-prop-label-update,
	    context-propagate-prop-list-update, context-propagate-prop-state,
	    context-propagate-prop-configuration,
	    property-prop-activate-handler, prop-list-find-mode-prop,
	    property-prop-state-id->mode-value,
	    property-mode-value->prop-state-id, context-update-mode,
	    context-update-mode-list, property-mode-handler): New procedure
	  - (anthy-property-id-list, default-prop_anthy_input_mod,
	    default-prop_anthy_kana_input_method): New variable for anthy.scm
	  - (prop_anthy_input_mode, prop_anthy_kana_input_method): New
	    property definition for anthy.scm
	
	* scm/util.scm
	  - (find): New SRFI procedure. Not yet tested
	
2004-10-08 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/ximtrans.cpp (Connection::OnRecv) : Handle mRxQ at once to
	  avoid packet mismatch caused by extreme key repeats.
	
2004-10-08 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* uim/intl.c
	  - (init_intl): Replace bind_textdomain_codeset with
	    bind-textdomain-codeset to conform to lisp culture
	* doc/COMPATIBILITY
	  - Update 'New gettext API for Scheme'
	
2004-10-06 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* uim/iso-639-1.def
	  - Define "Divehi" as "dv"
	  - Add comments for Flemish, Konkani and Syriac
	
	* doc/COMPATIBILITY
	  - Update 'New i18n-related API for Scheme'
	  - Reorder by close date
	  - Cosmetic change
	
2004-10-06 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* ChangeLog
	  - Remove as said in [Anthy-dev 1128]
	
2004-10-06 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* helper/im-switcher-gtk.c
	  - (parse_helper_str_im_list): Apply get_text() to short_desc in
	    accordance with the gettext treatment said in following message
	    http://freedesktop.org/pipermail/uim/2004-October/000653.html
	* scm/im.scm
	  - (uim-get-im-short-desc): Remove ugettext translation
	
2004-10-06 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* uim/uim-util.c
	  - (struct _locale_language_table): Swap the order of members as said
	    in following message
	    http://freedesktop.org/pipermail/uim/2004-October/000653.html
	  - (NR_LOCALE_LANGUAGE): New macro to define symbolic value of the
	    number of elements in locale_language_table[]
	  - (get_language_name_from_locale): Cosmetic change
	* uim/iso-639-1.def
	  - Swap the order of members in each element
	
2004-10-06 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit reorganizes uim_get_language_name_from_locale() and
	  related parts. See 'URL' firld of 'New information retrival API'
	  entry in doc/COMPATIBILITY
	
	* doc/COMPATIBILITY
	  - Describe this change into 'New information retrival API'
	  - Reorder by close date
	
	* scm/iso-639-1.scm
	  - Remove to replace with iso-639-1.def
	* scm/i18n.scm
	  - Remove (require "iso-639-1.scm")
	  - (lang-code->lang-name): Replace lang-code retrival using
	    iso-639-1-alist with lang-code->lang-name-raw written in C
	  - (uim-get-language-name-from-locale): Remove
	  - (langgroup-primary-lang-code): New procedure comprise of code
	    fragments of uim-get-language-name-from-locale. This procedure is
	    called from uim_get_language_name_from_locale() to handle
	    "zh_TW:zh_HK" style localeas temporary specification of the
	    function for backward compatibility
	
	* uim/uim-util.c
	  - (uim_get_language_name_from_locale): Remove the alternative
	    implementation using Scheme
	  - (get_language_name_from_locale):
	    * New static function renamed from
	      uim_get_language_name_from_locale()
	    * replace strncmp(s, s, 2) with strcmp to properly translate zh
	      locales such as "zh_CN"
	  - (uim_get_language_name_from_locale): Add "zh_TW:zh_HK" style
	    locale handling
	  - (lang_code_to_lang_name_raw): New function
	  - (uim_init_util_subrs): Add initialization of
	    lang-code->lang-name-raw
	* uim/iso-639-1.def
	  - Add copyright header
	  - Add a comment about original specification information
	
2004-10-06 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* helper/im-switcher-gtk.c:
	 - (create_switcher): Pack button box into right side.
	 - (create_switcher): GTK_STOCK_APPLY changed to GTK_STOCK_OK.
	
2004-10-06 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* sumika/gtk2/Makefile.am:
	 - Don't install sumika by default.
	
2004-10-06 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* uim/uim-helper-client.c:
	 - (uim_helper_get_message): Added explicit (void) to the function definition.
	
2004-10-06 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* uim/agent.c:
	  - Moved from top_srcdir.
	
2004-10-06 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/im.scm
	  - (register-im, retrieve-im, find-im-for-locale): Optimize out
	    redundant im-name of each IM in im-list
	
2004-10-06 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/COMPATIBILITY
	  - Note almost Scheme API changes between 0.4.3 and 0.4.4 without
	    detailed description. The desctiption should also be described
	    before 0.4.4 release, if possible
	  - Add a new entry 'New i18n-related API for Scheme'
	  - Add a new entry 'short-desc argument has been added to register-im'
	  - Add a new entry 'New gettext API for Scheme'
	  - Add a new entry 'Additional romaji-kana conversion table has been added'
	  - Add a new entry 'New IM selection API for Scheme'
	  - Add a new entry 'New helper protocol messages for IM management'
	
2004-10-05 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/locale.cpp (UTF8_Locale::compose_localename_from_lang) :
	  Handle zh_TW:zh_HK.
	* xim/convdisp.cpp (choose_default_fontset) : Ditto.
	* xim/main.cpp (init_supported_locales) : Ditto.  These hack for
	  locale handling in uim-xim should be rewritten after 0.4.4.
	
2004-10-05 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/COMPATIBILITY
	  - Note all C API changes between 0.4.3 and 0.4.4 without detailed
	    description. The desctiption and Scheme API changes should also be
	    described before 0.4.4 release
	  - Add a new entry 'Format extension of language attribute of IM'
	  - Add a new entry 'Deprecation of preliminary uim-scm API'
	  - Add a new entry 'Fix a typo of an API function name'
	  - Add a new entry 'New IM-switching related API'
	  - Add a new entry 'New information retrival API'
	  - Add a new entry 'New surrounding text API'
	
	* README
	  - Fix 'International Phonetic Association' with 'International
	    Phonetic Alphabet'
	
2004-10-05 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* uim/uim-helper-client.c (uim_helper_get_message) : Fix to terminate
	  at proper place.
	
2004-10-05 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* ChangeLog
	  - Update
	
2004-10-05 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/HELPER-PROTOCOL
	  - Define charset and str
	  - Remove unused iso639_lang_code definition
	  - Cosmetic changes
	
2004-10-05 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* test/test-slib.scm
	  - New file
	  - Merged from test-macro.scm and test-ext.scm
	  - (test case): Replace 'uim' with 'uim-bool' to suppress the error
	    due to bug #617
	* test/test-macro.scm
	  - Merge into test-slib.scm
	* test/test-ext.scm
	  - Ditto
	
	* test/test-uim.scm
	  - Remove. Equivalent test is already included in test-util.scm
	
2004-10-05 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* helper/im-switcher-gtk.c : Remove unncecessary "\n" for
	  uim_helper_send_message().
	* uim/uim-helper-client.c (uim_helper_get_message) : malloc with i+2
	  is sufficient.  Terminate buffer properly.
	
2004-10-05 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/prime.scm
	  - (prime-command-register-conv-input): Replace obsolete
	    prime-proc-input-no-preedit with prime-push-key to fix crashing on
	    word-register mode by the patch posted in [Anthy-dev 1031] by
	    Masaki Yatsu. Thanks.
	
2004-10-05 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/ximserver.cpp (init_modifier_keys) : Free strage allocated by
	  XGetModifierMapping() and XGetKeyboardMapping().
	
2004-10-05 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit make uim "zh_TW:zh_HK:en:de:fr" style colon-separated
	  language acceptable. It may affect bridge implementations. Please
	  check.
	
	* uim/uim.c
	  - (uim_init_scm): Load default-im.scm after loader.scm to ensure
	    lowest preference
	* scm/im.scm
	  - Move (require "default-im.scm") into uim.c
	  - (find-im-for-locale):
	    * Accept language group expression using langgroup-covers?
	    * Remove fallback 'default' IM since the IM matches with any
	      languages by langgroup-covers?
	* test/test-im.scm
	  - (test find-im-for-locale):
	    * Replace IM for "zh" locale with m17n-zh-py in accordance with
	      the change of lang of pinyin-big5
	    * Passed all zh locale tests
	
	* scm/i18n.scm
	  - (langgroup-covers?): New predicate. Wildcard expression is
	    temporalily defined as "*", and "" is kept as 'matches nothing'
	    for ipa IM
	  - (lang-code->lang-name): Change default value "" to "-"
	  - (uim-get-language-name-from-locale): Accepts "zh_TW:zh_HK" format
	    and returns first language
	* test/test-i18n.scm
	  - (test langgroup-covers?): New test
	
	* scm/default-im.scm
	  - Replace the language "en" on register-im with "*"
	* scm/pyload.scm
	  - Replace the language "zh" on generic-register-im with "zh_TW:zh_HK"
	
2004-10-05 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/main.cpp : Fix silly typo for sizeof(char).
	
2004-10-05 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/im.scm
	  - (find-default-im): Remove uim-default-im-engine in accordance with
	    [Anthy-dev 1108, 1115]
	* xim/main.cpp
	  - (main): Replace uim-default-im-engine in a comment with
	    default-im-name in accordance with the discontinuance of it
	
2004-10-05 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/im.scm
	  - Validated by test-im.scm except for zh_TW and zh_HK related issues
	  - (current-im): Remove as obsolete
	  - (register-im):
	    * Avoid duplicate register properly
	    * Remove current-im handling ramained as comment
	  - (find-im-for-locale): Fallback to 'default to provide IM for any
	    locale
	  - (find-default-im): Remove fallback current-im since
	    find-im-for-locale which fallbacks to 'default precedes current-im
	  - (find-im): Rename the arg 'lang' to 'localestr' in accordance with
	    locale string capability
	* test/test-im.scm
	  - (test im-record accessors): Remove because define-record ensures
	    proper accessor definition
	  - (test register-im):
	    * Remove current-im related tests
	    * Add duplicate register test
	  - (test retrieve-im): New test
	  - (test default-im-for-debug): New test
	  - (test find-im-for-locale):
	    * New test
	    * Currently fails for pinyin-big5 selection for zh_TW and
	      zh_HK. Implementation will be modified to conform to the test
	      result
	  - (test find-default-im): New test
	  - (test find-im):
	    * Remove current-im related tests
	    * Revised for new implementation involving find-im-for-locale
	  - (testcase im context management): Revise setup proc in accordance
	    with new im.scm implementation
	  - (test set-context-data!): Remove
	  - (test add-context (add as new id)): Remove
	  - (test add-context (duplicate id)): Remove
	  - (test register-context (add as new id)): New test. Revised from
	    test add-context
	  - (test register-context (duplicate id)): New test. Revised from
	    test add-context
	
	* uim/uim-func.c
	  - (im_register_im):
	    * Fix memory leak of short_desc
	    * Eliminate redundant string duplications
	
	* uim/uim.c
	  - (uim_switch_im): Add a comment related to the commit log of
	    r1400. I think that we should not add the API
	    uim_destroy_context()
	
2004-10-05 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* uim/uim.c:
	 - (uim_switch_im): Call reset_context before creating new context. 
	   IMO we need a new api uim_destroy_context.
	
2004-10-05 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* uim/uim-helper.c:
	 - (uim_helper_fd): Unmarked as static function.
	 
	* uim/uim-helper-client.c:
	 - (uim_helper_read_proc): Read all readable messages at once function call.
	
	
2004-10-04 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* uim/context.h
	  - #include "gettext.h" to call gettext functions properly from
	    UIM_EVAL_STRING macros
	
	* uim/intl.c
	  - #include <locale.h> for setlocale(). The inclusion position among
	    gettext.h is appropriate
	
	* test/test-i18n.scm
	  - Add reivsion information of successfully tested
	
2004-10-04 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/ximserver.cpp : Add #include <locale.h> for setlocale(3).
	* xim/convdisp.cpp : Ditto.
	
2004-10-04 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/i18n.scm
	  - Validated by test-i18n.scm
	  - (locale-new):
	    * Fix invalid initialization from LC_ALL or LANG when it is
	      configured as "C" or "POSIX"
	    * Reject invalid locale strings such as "de_.UTF-8". See
	      test-i18n.scm to view various patterns
	  - (locale-str): Fix a typo over a variable name which crashes the
	    execution in the case returning only lang-territory part
	  - (locale-set-lang!, locale-set-territory!,
	    locale-lang-territory-str): Reorder swappable argument as popular
	    order
	* test/test-i18n.scm
	  - New file
	  - (testcase i18n locale): New testcase
	  - (test locale-new, locale-new native environment, locale-set-lang!,
	    locale-set-territory!, locale-lang-territory-str, locale-str,
	    locale-zh-awared-lang): New test
	  - (testcase i18n ISO 639-1 language code #1): New testcase
	  - (test lang-code->lang-name in en locale): New test
	  - (testcase i18n ISO 639-1 language code #2): New testcase
	  - (test lang-code->lang-name in ja_JP locale):
	    * New test
	    * Currently disabled due to strange execution error
	
	* uim/uim-util.c
	  - (c_setenv, c_unsetenv): New function
	  - (uim_init_util_subrs): Add setenv and unsetenv as new procedures
	* test/test-uim-util.scm
	  - (test setenv, test unsetenv): New test
	
	* scm/im.scm
	  - (find-im-for-locale):
	    * Rename a local variable
	    * Remove redundant logic
	
	* uim/Makefile.am
	  - Move '-D' definitions in libuim_la_CFLAGS to libuim_la_CPPFLAGS
	  - Add -DDEBUG to libuim_la_CPPFLAGS
	
2004-10-04 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/convdisp.cpp : Fix taipeifont entry for zh_TW fontset.
	
2004-10-04 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* doc/HELPER-CANDWIN : Fix typo.  Add description about message
	  format for sending.
	
2004-10-04 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* helper/im-switcher-gtk.c
	  - (parse_helper_str_im_list): Revert the change committed in r1392
	    since it should not be performed yet
	
2004-10-04 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/im.scm
	  - (uim-get-im-short-desc): Returen "-" rather than "" if invalid
	    string has been gotten
	
	* helper/im-switcher-gtk.c
	  - (parse_helper_str_im_list): Disable get_text() since the string
	    has already been gettext'ed
	
2004-10-04 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit Adds i18n-ized short-desc feature
	
	* scm/im.scm
	  - (record im): Add a new member short-desc to allow time-by-time
	    gettext translation
	  - (register-im): Add short-desc arg to im-new
	  - (uim-get-im-short-desc): New procedure to get gettext'ed
	    short-desc from C
	
	* uim/uim.c
	  - (uim_get_im_short_desc): Add short-desc update which performs
	    gettext based on current locale and current client encoding
	  - (uim_switch_im): Add short_desc handling. But it is currently
	    disabled by #if 0 since I don't know when uc->short_desc is used
	
2004-10-04 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* uim/Makefile.am : Add @LIBINTL@ for libuim_la_LIBADD.
	
2004-10-03 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* uim/uim-scm.h
	  - Add a comment that cautions the defective API
	
2004-10-03 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/convdisp.cpp (PeLineWin::draw_segment) : Draw underline when
	  PE_UNDERLINE is on with root-style preedit window.
	
2004-10-03 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* helper/im-switcher-gtk.c:
	 - (create_switcher_treeview): Added radio buttons.
	 - (change_input_method): New function.
	 - (sort_by_language_name): Removed.
	 - (sort_by_input_method_name): Removed.
	 - (change_this_text_area_only): Removed.
	 - (change_whole_desktop): Removed.
	 - (change_this_application_only): Removed.
	
2004-10-02 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/convdisp.cpp (class ConvdispOv) : Add private variable
	  m_lang_changed for fontset selection hack.
	
2004-10-02 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	* uim/skk-dic.c
	 - add comments on each structure
	 - (find_border) avoid possibility of infinite loop.
	
2004-10-02 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* doc/XIM-SERVER : Update description about default im selection.
	* xim/ximpn.h : Translate some Japanese comments into English.
	* xim/xim.h : Ditto.
	* xim/ximtrans.cpp : Ditto.
	* xim/ximic.cpp : Ditto.
	* xim/ximim.cpp : Ditto.
	* xim/convdisp.cpp : Ditto.
	* xim/convdisp.h : Ditto.
	* xim/ximserver.cpp : Ditto.  Remove unused init_converter() and
	  global_finalize().
	* xim/canddisp.cpp : Update comment.
	* xim/locale.cpp : Add comment.
	* xim/main.cpp : Use uim_default_im_name() for default IM
	  selection.  Do init_convdisp() earlier.
	
2004-10-02 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* uim/uim-helper-client.c
	  - (BUFFER_SIZE): Increase to 64KB from 2KB to receive large message
	
	* scm/m17nlib.scm
	  - (m17nlib-register): Replace short-desc with proper one
	
2004-10-02 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/loader.scm
	  - Separate CKV languages from 'other languages'
	
	* scm/iso-639-1.scm
	  - Remove (require "i18n.scm") in accordance with the procedure
	    relocation
	  - (lang-code->lang-name, uim-get-language-name-from-locale): Move to
	    i18n.scm
	* scm/i18n.scm
	  - Add (require "iso-639-1.scm") in accordance with the procedure
	    relocation
	  - (lang-code->lang-name, uim-get-language-name-from-locale): Move
	    from iso-639-1.scm
	* scm/im.scm
	  - Remove (require "iso-639-1.scm") in accordance with the procedure
	    relocation
	
2004-10-02 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* uim/uim-util.c
	  - (uim_get_language_name_from_locale): Add NULL check for argument
	    to Scheme version of the function
	
2004-10-01 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/im.scm
	  - (find-im-for-locale): Reflect preference-order for each language
	    by using load order
	
	* scm/loader.scm
	  - Reorder Japanese IMs to make ordinary IM (such as Anthy) be
	    selected as default
	
2004-10-01 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* uim/slib.c
	  - (init_dbg): Rename the feature 'debugging to 'debug
	
	* scm/im.scm
	  - (debugging-default-im): Rename the strange name to default-im-for-debug
	  - (default-im-for-debug):
	    * Renamed from debugging-default-im
	    * Replace (feature? 'debugging) with (feature? 'debug)
	      inaccordance with the renaming about the feature
	  - (find-default-im): Follow the renaming of find-default-im
	
2004-10-01 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/im.scm
	  - (current-im): Fix invalid default value. current-im must points to
	    im, not a im-name
	
2004-10-01 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit modifies an API function suggested in following message
	  http://freedesktop.org/pipermail/uim/2004-September/000646.html
	
	* uim/context.h
	  - (struct uim_im): Reorder members in accordance with the argument
	    reorder about short-desc
	  - (struct uim_context_): Fix a typo
	* uim/uim-func.c
	  - (im_register_im): Swap argument order 's_desc, enc' to 'enc,
	    s_desc' as I suggested in
	* scm/im.scm
	  - (register-im): Swap argument order 'short-desc encoding' to
	    'encoding short-desc' as I suggested in
	
	* scm/tutcode.scm
	* scm/prime.scm
	* scm/spellcheck.scm
	* scm/canna.scm
	* scm/anthy.scm
	* scm/skk.scm
	  - Follow the specification change of register-im
	  - Surround the short-desc by N_ as (N_ "short-desc") to prepare
	    message translation
	
	* scm/m17nlib.scm
	  - Follow the specification change of register-im
	  - Add a new short-desc as comment. It is not used for now due to the
	    bug #1502
	
	* scm/default-im.scm
	  - Follow the specification change of register-im
	  - Modify the short-desc  
	  - Surround the short-desc by N_ as (N_ "short-desc") to prepare
	    message translation
	
	* scm/generic.scm
	  - (generic-register-im): Follow the specification change of
	    register-im
	
	* scm/tcode.scm
	* scm/ipa.scm
	* scm/viqr.scm
	* scm/pyload.scm
	  - Follow the specification change of generic-register-im
	  - Surround the short-desc by N_ as (N_ "short-desc") to prepare
	    message translation
	
	* scm/hangul.scm
	  - (hangul-register-im): Follow the specification change of
	    register-im
	  - Follow the specification change of hangul-register-im
	  - Follow the specification change of generic-register-im
	  - Surround the short-desc by N_ as (N_ "short-desc") to prepare
	    message translation
	
2004-10-01 kzk <mover@hct.zaq.ne.jp>
	
	* qt/qtkde-helper/src/candwin
	  - make candwin understand display_limit message
	  - code clean up
	
2004-10-01 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/main.cpp (main) : Again, do init_convdisp() here.
	* xim/convdisp.cpp (init_convdisp) : Do setlocale() for every CJK
	  fontset.  Set default CJK fontset with size 16 available from
	  /usr/X11R6/lib/X11/fonts/misc.
	(create_convdisp) : Move init_convdisp() to main from here.
	(PeLineWin::draw_segment) : Adjust to font size 16.
	
2004-09-30 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit renames an API function suggested in following message
	  http://freedesktop.org/pipermail/uim/2004-September/000646.html
	
	* uim/uim.h
	  - (uim_change_input_method_engine): Rename to uim_switch_im
	  - (uim_switch_im):
	    * Renamed from uim_change_input_method_engine
	    * Modify the function description
	* uim/uim.c
	  - (uim_change_input_method_engine): Rename to uim_switch_im
	  - (uim_switch_im): Renamed from uim_change_input_method_engine
	
	* gtk/gtk-im-uim.c
	  - (im_uim_parse_helper_str_im_change): Replace
	    uim_change_input_method_engine() with uim_switch_im()
	
	* qt/quiminputcontextplugin/src/qhelpermanager.cpp
	  - (parseHelperStrImChange): Ditto
	
	* qt/quiminputcontextplugin-qt4/qhelpermanager.cpp
	  - (parseHelperStrImChange): Ditto
	
2004-09-30 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit fixes default IM selection algorithm in accordance with
	  [Anthy-dev 1104]
	
	* scm/i18n.scm
	  - (locale-new):
	    * Accept #f, "C" and "POSIX" as "en" locale. This resolved some
	      initialization problem
	    * Accept "" as native locale as like as performed in
	      setlocale(). It attempt to retrieve the locale information from
	      LC_ALL and LANG environment variable. If failed to retrieve the
	      information from the two variable, it defaults to "en". It does
	      not attempt to retrieve from particular locale category such as
	      LC_CTYPE or LC_MESSAGES since appropriate category for input
	      method does not exist
	
	* scm/default-im.scm
	  - Change 'lang' information for register-im to "en" from "*" to be
	    selected against "en" locales on the default IM selection process.
	    Although it should ideally be matched against several locales as
	    "en:fr:de" or "*", current implementation does not accept such
	    expressions. We should revise it later
	
	* scm/im.scm
	  - (current-im):
	    * Replace default value #f with 'default
	    * Mark as 'may be deprecated'
	  - (register-im): Comment out update of current-im. This makes
	    current-im permanently points to 'default IM
	
2004-09-30 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/im.scm
	  - (find-default-im): Add symbol-bound? check for
	    uim-default-im-engine to avoid craching when the variable is not
	    defined
	
2004-09-30 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/im.scm
	  - (find-default-im): Fix a typo over sexp
	
2004-09-30 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* japanese.scm:
	 - (ja-rk-rule): Splitted into two parts. ja-rk-rule-basic and 
	    ja-rk-rule-additional.
	
2004-09-30 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* xim/convdisp.cpp:
	 - (ConvdispOs::move_candwin): Added a comment.
	
2004-09-30 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit enables proper gettext handling within Scheme world,
	  adds locale object for Scheme, and adds an alternative
	  implementation of uim_get_language_name_from_locale() written in
	  Scheme
	
	* Although the codes for Scheme gettext is sufficient, automatic
	  update of po files involving scm files are not yet provided
	
	* configure.ac
	  - Fix localedir definition by replacing "${prefix}/share/locale"
	    with "${datadir}/locale"
	  - Define LOCALEDIR to properly expand ${datadir}. We should use more
	    safe macro such as AC_EXPAND_DIR later
	  - Add a comment about [ $prefix = NONE ] handling. I can't imagine
	    when prefix does not exist
	
	* uim/context.h
	  - #include "config.h" to know whther ENABLE_NLS is defined or not
	  - (uim_last_client_encoding): New decalaration for an
	    library-private variable
	  - Add a comment about why we don't use variadic macro
	    (i.e. __VA_ARGS__)
	  - (UIM_PREPARE_SAVING_TEXTDOMAIN_CODESET,
	    UIM_SWITCH_TEXTDOMAIN_CODESET, UIM_RESTORE_TEXTDOMAIN_CODESET):
	    New macros for gettext handling within UIM_EVAL_STRING macros
	  - (UIM_EVAL_STRING_INTERNAL): New macro to simplify UIM_EVAL_STRING
	    macros
	  - (UIM_EVAL_STRING, UIM_EVAL_FSTRING1, UIM_EVAL_FSTRING2,
	    UIM_EVAL_FSTRING3, UIM_EVAL_FSTRING4, UIM_EVAL_FSTRING5):
	    * Simplify using UIM_EVAL_STRING_INTERNAL()
	    * Add gettext handling
	
	* uim/uim.c
	  - (uim_last_client_encoding): New library-private variable
	  - (uim_create_context): Add client encoding saving for
	    bind_textdomain_codeset(). The value is used when
	    UIM_EVAL_STRING() is called without uim_context. The specification
	    assumes client always uses consistent encoding
	  - (uim_get_default_im_name): Replace the sexp template
	    "(find-default-im-name)" with "(uim-get-default-im-name)" in
	    accordance with the renaming
	  - (uim_init): Add initialization for uim_last_client_encoding
	  - (uim_quit): Add cleanup for uim_last_client_encoding
	
	* uim/uim-util.c
	  - (uim_scm_load_file): Simplify using UIM_EVAL_FSTRING1()
	  - (struct _locale_language_table, locale_language_table):
	    Temporalily comment out by #if 0
	  - (uim_get_language_name_from_locale):
	    * Temporalily replace interenal implementation with extended
	      alternative one written by Scheme
	    * It returns gettext'ed string converted for client encoding of
	      libuim rather than system locale encoding. For example, it
	      properly returns UTF-8 string for GTK+ environment even if
	      system locale is using different encoding such as EUC-JP
	    * We should implement such functionalities by Scheme to acquire
	      flexibility. In this case, we can also perform langcode ->
	      langname translation in Scheme world by the alternative
	      implementation. The replacement is performed temporalily by #if 0.
	    * I should know whether other requirement that requires C version
	      of implementation. In addition, the alternative implementation
	      requires API change (remove const from return value). Currently
	      it has a memory leak problem due to the API
	
	* uim/intl.c
	  - (intl_gettext_package): New function. It returns GETTEXT_PACKAGE
	    as a Scheme procedure gettext-package
	  - (intl_init_locale):
	    * Replace locale configuration involving environment variable with
	      simple setlocale(LC_ALL, ""). I believe that is's sufficient
	    * Configure gettext environment properly using compile-time
	      information. It has gotten ready to gettext
	  - (init_intl):
	    * Add definition of gettext-package
	    * Provide 'nls if ENABLE_NLS is defined
	
	* uim/slib.c
	  - (lreadr): Remove non-standard _"str" style syntax handling for
	    i18n. We use the form (_ "str") to represent gettext string to be
	    compatible with other lisp implementations
	
	* scm/Makefile.am
	  - Add i18n.scm and iso-639-1.scm to SCM_FILES
	
	* scm/im.scm
	  - Describe an abstract of this file as comment
	  - Additionaly require i18n.scm and iso-639-1.scm
	  - (locale-lang): Remove to replace with new locale handling
	    procedures defined in i18n.scm
	  - (find-im-for-locale): Make zh locales handling proper
	  - (find-default-im): Rename the arg to distinguish locale string and
	    locale object
	  - (find-default-im-name): Rename to uim-get-default-im-name to
	    indicate tight relationship with uim_get_default_im_name()
	  - (uim-get-default-im-name):
	    * Renamed from find-default-im-name
	    * Rename the arg to distinguish locale string and locale object
	
	* scm/i18n.scm
	  - New file for i18n functions
	  - (ugettext): New procedure. Convenience shorthand of runtime
	    translation
	  - (_): New procedure. It is an alias of ugettext, and also used as
	    the keyword for xgettext
	  - (N_): New procedure. It is only used as the keyword for xgettext
	  - (record locale): New record
	  - (locale-new-internal, locale-set-lang-internal!,
	    locale-set-territory-internal!): New aliases to preserve original
	    definitions defined by define-record
	  - (locale-new): New procedure. It accepts
	    language[_territory][.codeset] style locale string as argument
	  - (locale-set-lang!, locale-set-territory!): New procedures. They
	    adds a validation to original one defined by define-record
	  - (locale-lang-territory-str): New procedure. It returns
	    "language_territory" or "language" style string from locale object
	    in accordance with existence of 'territory' attribute
	  - (locale-str): New procedure. It returns
	    "language_territory.codeset" or locale-lang-territory-str style
	    string from locale object in accordance with existence of
	    'territory' and codeset attribute
	  - (locale-zh-awared-lang): New procedure. It returns language part
	    of locale object, but returns locale-lang-territory-str for zh
	    locale
	
	* scm/iso-639-1.scm
	  - New file for definition about ISO 639-1 language codes
	  - (iso-639-1-alist): New variable. This defines the translation
	    table with gettext keyword
	  - (lang-code->lang-name): New procedure. It translates the
	    two-letter language code into a human readable language name with
	    gettext translation
	  - (uim-get-language-name-from-locale): New procedure. It called from
	    uim_get_language_name_from_locale() as its actual implementation
	
2004-09-30 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* helper/toolbar-common-gtk.c (button_destroy) : Use
	  gtk_widget_destroy instead of gtk_container_remove to remove
	  reference count of object.
	(uim_applet_fd_read_cb) : Use free instead of g_free.
	
2004-09-30 kzk <mover@hct.zaq.ne.jp>
	
	* Until this commit, all known bug of qtkde-helper
	  is fixed. It's ready to use I think. After testing
	  at my machine in a few days and it doesn't cause
	  aproblem, I'll release qtkde-helper.
	
	* candwin/uim-helper-candwin-qt.cpp
	  - handle utf-8 string properly
	  - handle candidate string properly
	  - fix the position to move
	  - fix wrong message reading
	  - remove unnecessary debug message
	
	* toolbar/uim-helper-toolbar-qt.cpp
	  - move to the proper position at startup
	    (not proper way)
	
	
2004-09-30 kzk <mover@hct.zaq.ne.jp>
	
	* qt/qtkde-helper/src/common/quimhelpertoolbar.cpp
	  - (checkHelperConnection): new function
	  - call uim_helper_client_get_prop_list() once widget
	    is created. This aims to avoid display "?" when
	    toolbar starts.
	
	* qt/qtkde-helper/src/common/quimhelpertoolbar.h
	  - (checkHelperConnection): new function
	  - declare following functions as protected
	    (parseHelperStr,propListUpdate,propLabelUpdate)
	
	* qt/qtkde-helper/src/applet/uimhelperapplet.cpp
	  - kill warning
	
	
2004-09-29 Masahito Omote <omote@utyuuzin.net>
	
	* uimcontainer.c, uimcontainer.h: Change UI interface.
	  - (uim_config_container_new): Use GtkTreeView lists for selecting
	    instead of tabs.
	  - (cb_treeview_cursor_changed): New callback when item is selected.
	
2004-09-29 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* scm/skk.scm : Recover the wrong behavior of index-hander with recent
	  scm changes.
	
2004-09-29 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* test/test-intl.scm
	  - Add (use file.util) to avoid environment dependent error
	  - (testcase intl): Add LC_ALL and implicit C locale handling to
	     avoid environment dependent error
	
2004-09-29 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit adds a test suite for intl.c. The patch has been
	  contributed by Kouhei Sutou by following message. Thank you for
	  cooperation.
	  http://lists.sourceforge.jp/mailman/archives/anthy-dev/2004-September/001088.html
	
	* test/test-intl.scm
	  - New file
	
2004-09-29 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/im.scm
	  - (find-default-im): Complement a lacking close paren that enbuged
	    in r1359
	
2004-09-29 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/im.scm
	  - (find-default-im): Add existence check for uim-default-im-engine
	     to avoid startup error
	
2004-09-29 kzk <mover@hct.zaq.ne.jp>
	
	* helper/im-switcher-gtk.c
	  - enable sorting by clicking column header
	
2004-09-29 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/ximserver.cpp (InputContext::focusIn) : Do setlocale() here
	  since different context may have im with different language.
	* xim/convdisp.cpp (gFontset_ja) : Revert Japanese default font
	  for the sake of safely.
	
2004-09-29 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/00INDEX
	  - Add 'COMPATIBILITY' as an entry
	
2004-09-29 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/convdisp.cpp : Change default fontset size as 16.
	
2004-09-29 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* helper/toolbar-common-gtk.c
	 - (button_size_group): New global variable
	 - (helper_applet_prop_list_update): Use size group to synchronize
	   the size of buttons.
	
2004-09-29 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/ipa.scm: Fix short-desc as 'International Phonetic
	  Alphabet'. 'International Phonetic Association' is the organization
	  which provides the 'International Phonetic Alphabet' standard. Our
	  'IPA' means 'Alphabet'.
	
2004-09-29 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* configure.ac: Disable Sumika by default. It should not be installed
	  by default yet.
	
2004-09-28 kzk <mover@hct.zaq.ne.jp>
	
	* doc/HELPER-PROTOCOL
	  - update label related part
	
2004-09-28 kzk <mover@hct.zaq.ne.jp>
	
	* helper/im-switcher-gtk.c
	  - first argument type of gtk_box_set_spacing is
	    (GtkBox*)
	
2004-09-28 kzk <mover@hct.zaq.ne.jp>
	
	* qt/quiminputcontextplugin/src/qhelpermanager.cpp
	* qt/quiminputcontextplugin-qt4/qhelpermanager.cpp
	  - (sendImList): Handle utf8 string properly
	  - (update_prop_list_cb): Ditto
	  - (update_prop_label_cb): Ditto
	
2004-09-28 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* uim/uim.c
	  - (uim_get_default_im_name): Replace the implementation with
	    equivalent one written in Scheme. Such complex and ad-hoc handling
	    should be written in Scheme to acquire flexibility. 'Written in
	    Scheme' is a most important value of the uim.
	
	* uim/context.h
	  - (UIM_EVAL_STRING): New macro
	  - (UIM_EVAL_FSTRING1, UIM_EVAL_FSTRING2, UIM_EVAL_FSTRING3,
	    UIM_EVAL_FSTRING4, UIM_EVAL_FSTRING5): Make the argument uc
	    NULL-ready. repl_c_string() will be called instead of
	    uim_eval_string() when NULL is passed as uc. i.e. Can be called
	    without uim_context
	
	* scm/im.scm
	  - (create-context): Fix 'discard old context without invoking
	    release-handler' problem
	  - (retrieve-im): New procedure. Generalized from the local procedure
	    of find-im
	  - (debugging-default-im): New procedure. Performs getting default-im
	    from the environment variable for debugging purpose
	    "UIM_IM_ENGINE". It is performed only when compiled with
	    --enable-debug
	  - (find-default-im): New procedure. This procedure attempts
	    retrieving 'default IM' by several methods including evaluation
	    of Scheme variables default-im-name and uim-default-im-engine.
	    preexisting default-im-name should used instead of
	    uim-default-im-engine
	  - (locale-lang): New procedure. Extracts language part of locale
	  - (find-im-for-locale): lookup an arbitrary IM for specified
	    locale. Per-language special IM selection handling should be
	    written in here
	  - (find-default-im-name): New procedure. Written to be called by
	    uim_get_default_im_name()
	  - (find-im): Simplify and extend using new procedures. 'lang' is
	    now also used to find most suitable IM
	
2004-09-28 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* helper/toolbar-common-gtk.c : Oops, cast GTK_BUTTON to GTK_WINDOW was 
	  invalid.  Revert it, but comment out using gtk_widget_size_request.
	
2004-09-28 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/main.cpp :  Enable default im selection with
	  "uim-default-im-engine" in ~/.uim.
	* doc/XIM-SERVER : Update document for refrecting above change.
	
2004-09-28 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* uim/uim-util.c
	  - (c_getenv): Fix SEGV on getting undefined environment
	    variable. Tested by test-uim-util.scm
	* test/test-uim-util.scm
	  - (test getenv): Add a test for non-existing environment variable
	
2004-09-28 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* uim/slib.c
	  - (provide): Add prototype declaration
	  - (init_dbg): Provide 'debugging
	
2004-09-28 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* uim/slib.c
	  - (featurep, provide): Fix broken variable evaluation. Corresponding
	    Scheme procedures 'feature?' and 'provide' has been able to be
	    used
	
2004-09-28 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* uim/uim.c
	  - (uim_change_input_method_engine):
	    * Fix invalid Scheme expression '#f (quoted #f). It was intended
	      to consist of quoted langname, but currently not used. So I
	      directly embed "#f" into the template string
	    * Add a comment about function renaming. I'll suggest this to the
	      mailinglist once im-switcher related implementation has been
	      refactored
	
2004-09-28 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* uim/skk-dic.c:
	 - (do_search): Reverted to r1339, because that expression has no
	    problem. (Because min and max indicate offset from the base
	    dictionary address.)
		 
	
2004-09-28 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* uim/skk-dic.c:
	 - (do_search): Fixed (min+max)/2 to min +(max-min)/2, because the 
	    former expression has tacit possibility of interger overflow.
	
2004-09-28 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* uim/uim.c (uim_change_input_method_engine) : Plug leak.
	
2004-09-28 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* uim/uim.c:
	 - (uim_check_im_exist): Replaced strstr with strcmp. I cannot
	   understand why I used strstr before.
	
2004-09-28 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* helper/toolbar-common-gtk.c : One more removal of '*' from
	  gpointer...
	
2004-09-28 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	 * helper/toolbar-common-gtk.c : More removal of '*' from gpointer
	 argumetns.
	
2004-09-28 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* helper/Makefile.am : Use install-exec-hook instead of
	  install-exec-local to make sure install-exec-hook-applet is
	  performed after install-libexecPROGRAMS.  Use DESTDIR for
	  install-exec-hook-applet.
	
	* helper/toolbar-common-gtk.c : Don't use fixed sized buttons,
	  as reported on [anthy-dev 1070].  Confirm behavior of the gnome
	  applet with middle and right click of im-switcher button.
	  Remove '*' from gpointer in some arguments.
	
	* sumika/Makefile.am : Don't compile sumika when configured with
	  --disable-sumika.
	* sumika/include/Makefile.am : Ditto.
	* sumika/gtk/Makefile.am : Ditto.
	* sumika/common/Makefile.am : Ditto.
	
2004-09-28 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* uim/uim.c
	  - (uim_check_im_exist):
	    * Make this unexposed function static
	    * Reform coding style to ordinary one
	    * Add a comment about specification. Why use strstr() rather than
	      strcmp()? In this implementation, "skk" will match against
	      another IM such as "skk-extreme".
	  - (uim_get_default_im_name):
	    * Fix inappropriate constness handling
	    * Make meaning of the code clear with a renaming of bad variable
	      name 'tmp'
	    * Reform coding style to ordinary one
	
	* uim/uim-util.c
	  - (uim_custom_value_as_symbol, uim_custom_ctype): Make failsafe
	  - (struct _locale_language_table): Remove useless and invalid
	    storage class specifier 'static'
	
	* uim/uim-func.c
	  - (uim_iconv_code_conv): Fix inappropriate constness handling
	
	* uim/uim-helper.c
	  - (uim_helper_fd_readable): Ignore this unused function at compile
	    time
	
	* uim/uim-helper-server.c
	  - (uim_helper_server_process_connection): Make this unexposed
	    function static
	
	* uim/uim-helper-client.c
	  - (get_server_command): Make this unexposed function static
	
	* uim/slib.c
	  - (dbg_curpos): Ignore this unused function declaration at compile
	    time
	
2004-09-28 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* helper/toolbar-common-gtk.c:
	 -(hbox_hierarchy_changed):Marked as static.
	 - Added some function prototypes.
	
2004-09-28 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/HELPER-PROTOCOL
	  - Generalize a definition as 'charset_specifier'
	  - Modify a description about the meaning of 'property' in computer
	    programming domain
	  - (prop_label_update): Describe a design decision of Hiroyuki
	    Tokunaga who said in 2004-06-16 in his diary
	  - (im_list):
	    * Describe well
	    * Fix wrong definition about imlang. It's not a ISO 639 language
	      code
	  - (im_list_get, im_change_this_text_area_only,
	    im_change_this_application_only, im_change_whole_desktop):
	    Describe well
	
2004-09-28 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* helper/im-switcher-gtk.c
	  - (sort_by_language_name, sort_by_input_method_name): Fix a typo
	  - (send_message_im_change): Replace meaningless variable name 'tmp'
	    with 'msg'
	
2004-09-28 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* gtk/gtk-im-uim.c
	  - Add #include <uim/uim-util.h>
	  - (im_uim_send_im_list):
	    * Fix C++ style variable declaration enbuged in r1329
	
2004-09-28 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* gtk/gtk-im-uim.c
	  - (im_uim_send_im_list):
	    * Fix a possible memory leak
	    * Replace meaningless variable name 'tmp' with 'msg'
	    * Modify a comment to express original intention well
	    * Reform coding style
	
2004-09-28 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/COMPATIBILITY
	  - Add a new entry 'Replace IM-specific context object definition by
	    define-record'
	  - Add some information to the entry 'Context object integration'
	  - Add new fields 'Updates' and 'Version'
	  - Rename a field name 'Changed' with 'Changes'
	  - Swap field order
	  - Modify some English expressions
	
2004-09-28 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* uim/uim-util.h
	  - Add #ifndef _uim_util_h_included_
	
2004-09-28 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit declines C++ style pointer notation such as 'char*' or
	  'void*'. They have been replaced with traditional 'char *' or
	  'void *'. Even if it does not cause compile error, I think that such
	  coding style is a bad habit that leads a human error due to
	  misinterpretation about type declaration.
	
	  For example, a declaration 'char* a, b, c;' may sometimes be
	  interpreted as 'char* a; char* b; char* c;' by less-experienced
	  C/C++ programmers. But it of course results 'char* a; char b; char c;'.
	
	  So we should write pointers as 'char *' style. 'char *a, b, c;' will
	  not cause such misinterpretation. We should remind that the uim
	  library will be used by wide-range of programmers. We should
	  eliminate any source of human errors.
	
	  Since I don't know the coding style of GTK+ well, gtk-related codes
	  have been left untouched about such pointer notations. We should
	  also rewrite them if no recommendation about C++ style pointer
	  notation exists for GTK+.
	
	* uim/uim.h
	  - (uim_get_default_im_name, uim_ipc_send_command): Decline C++ style
	    pointer notation
	* uim/uim.c
	  - (uim_check_im_exist, uim_get_default_im_name): Ditto
	* uim/uim-ipc.c
	  - (uim_ipc_send_command): Ditto
	* uim/uim-util.h
	  - (uim_get_language_name_from_locale): Ditto
	* uim/uim-util.c
	  - (eucjp_string_to_list, uim_get_language_name_from_locale): Ditto
	* uim/uim-helper.c
	  - (uim_helper_get_pathname): Ditto
	* uim/uim-helper-client.c
	  - (get_server_command): Ditto
	* uim/uim-helper-server.c
	  - (proc_func): Ditto
	* uim/uim-table.c
	  - (find_line_head, find_next_linefeed, cut_off_line_from_table):
	    Ditto
	* uim/m17nlib.c
	  - (register_callbacks, get_left_of_cursor, get_right_of_cursor,
	    get_left_of_candidate, get_selected_candidate,
	    get_right_of_candidate, m17nlib_utf8_find_next_char): Ditto
	* uim/anthy.c
	  - (get_anthy_api): Ditto
	* uim/canna.c
	  - (struct canna_api): Ditto
	* uim/slib.c
	  - (lprin1g): Ditto
	* fep/callbacks.c
	  - (pushback_cb): Ditto
	
2004-09-28 kzk <mover@hct.zaq.ne.jp>
	
	* scm/prime.scm
	  - update list at proper timing
	  - (prime-prop-handler): fix unbound problem
	
2004-09-28 kzk <mover@hct.zaq.ne.jp>
	
	* scm/prime.scm
	  - fix unbound symbol problem occured at r1304
	
2004-09-28 Masahito Omote <omote@utyuuzin.net>
	
	* scm/custom.scm(canna-server-name):
	  - Fix conflicted definition in string and bool.
	* sumika/gtk2/uimcontainer.c:
	  - Probably works.
	  - Drop dlopen completely.
	  - (uim_config_container_new): Drop hardcode widget creation on each
	    configurations.
	  - (uimconfig_create_custom_combobox_widget, uimconfig_uim_custom_widget_new):
	    Fix endless loops. 
	  - (uimconfig_uim_custom_widget_new_by_sym): New function for dynamic UI
	    creation for each IM's configuraion.
	    uimconfig_custom_widget_new will become obsolete.
	
2004-09-28 kzk <mover@hct.zaq.ne.jp>
	
	* qt/qtkde-helper/src/toolbar/Makefile.am
	  - rename uim-helper-toolbar-qt to uim-toolbar-qt
	
	* qt/qtkde-helper/src/systray/Makefile.am
	  - rename uimhelpersystray to uim-toolbar-qt-systray
	
	
2004-09-27 Masahito Omote <omote@utyuuzin.net>
	
	* uimcontainer.c(uimconfig_create_custom_combobox_widget):
	  Fix endless loop when 'lab_str == NULL' (currently default-input-method
	  becomes empty).
	
2004-09-27 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/ximserver.cpp (InputContext::update_prop_label) : Stop 
	  sending the label for "prop_engine_" method.
	
2004-09-27 Masahito Omote <omote@utyuuzin.net>
	
	* sumika/common/uimconfig.c, sumika/gtk2/uimconfig.c sumika/gtk2/Makefile.am:
	  Drop dlfcn loading of libuim. For transition, you can build the old one,
	  by compile with -DUSE_DLOPEN.
	* This change still does *not* works sumika properly.
	
2004-09-27 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/COMPATIBILITY
	  - Modify fill-column and a English expression
	
2004-09-27 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/COMPATIBILITY
	  - New file
	  - Describe format
	  - Add 'Context object integration' as a entry
	
	* doc/HELPER-PROTOCOL
	  - modify indentation
	
2004-09-27 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/main.cpp (parse_helper_str_im_change) : Fix silly bug upon
	  receiving "im_change_whole_desktop".  Now changes all ximservers.
	
2004-09-27 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* doc/XIM-SERVER : Update description.
	
2004-09-27 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/xim.h : Use the name of conversion engine as a argument for
	  creating XimIC.
	* xim/ximic.cpp : Ditto.
	* xim/ximim.cpp (class XimIM_impl) : Add name of conversion engine
	  as a private variable.
	* xim/ximserver.cpp (XimServer::createContext) : Create new
	  context with explicitly selected conversion engine instead of
	  XimServer's global one.  This fixes im of newly created context
	  with the application whose im has been switch by "Change this
	  application only" method.
	
2004-09-27 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* uim/slib.c:
	 -(vload): call dbg_lineinc() only when DEBUG_SCM enabled.
	
2004-09-27 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/m17nlib.scm
	  - (m17nlib-translate-ukey-to-mkey): Simplify
	
2004-09-27 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit fixes nested loading problem and extends debugging
	  capability of siod interpreter. The patch has been contributed by
	  Jun Inoue in following message. Thank you for cooperation.
	  http://lists.sourceforge.jp/mailman/archives/anthy-dev/2004-September/001081.html
	
	* uim/siod.h
	  - (struct obj): Replace C-oriented dbg_info implementation with lisp
	    object
	
	* uim/slib.c
	  - (_NEWCELL): New macro to preserve original implementation of
	    NEWCELL
	  - (NEWCELL): Switch implementation in accordance with DEBUG_SCM
	  - (dbg_readabrt, dbg_curpos): New function placeholder
	  - (dbg_curfile, dbg_curline): Remove to replace with dbg_pos
	  - (dbg_pos): New static variable
	  - (dbg_lineinc, dbg_linedec, init_dbg): New static
	    function
	  - (gc_protect): Add declaration
	  - (show_backtrace, vload, readtl, dbg_getc, dbg_ungetc,
	    dbg_readini, dbg_readend): Follow new dbg_info implementation
	  - (gc_mark): Also mark dbg_info in a lisp object
	  - (siod_init): Add invocation of init_dbg()
	
2004-09-27 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/convdisp.cpp (ConvdispOv::check_atr) : Fix to set initial
	  fontset information only once.
	
2004-09-27 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* uim/uim-util.h : Make uim_get_language_from_locale() available
	  for C++.
	* xim/main.cpp (get_uim_info) : Add short description.
	(send_im_list) : Fix to send language name and the description.
	* xim/ximserver.h (UIMInfo) : Add const char *desc.
	
2004-09-27 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit fixes a bug in uim-m17n which arbitrary limits a number
	  of candidates at once in candidate-window. The patch has been
	  contributed by Seiichi SATO by following message. Thank you for
	  cooperation.
	  http://lists.sourceforge.jp/mailman/archives/anthy-dev/2004-September/001080.html
	
	* scm/m17nlib.scm
	  - (m17nlib-update-candidate):
	    * Unbreak the limitation about number of candidate at once. The
	      patch has been modified in accordance with recent 'context
	      object integration' in r1304
	    * Fix a misidentification about id and mid
	
	* uim/m17nlib.c
	  - (get_nr_candidates): New function
	  - (get_nth_candidate): Extract candidates properly
	  - (uim_init_m17nlib): Add definition of m17nlib-lib-get-nr-candidates
	
2004-09-27 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/main.cpp (send_im_list) : Oops, this fixs compilation error of
	  previous commit.
	
2004-09-27 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/xim.h (class XimIM) : Add virtual method changeContext().
	(class XimIC) : Add changeContext().
	* xim/ximic.cpp (XimIC::changeContext) : New function to change
	  uim engine of its own InputContext.
	* xim/ximim.cpp (class XimIM_impl) : Add changeContext().
	(XimIM_impl::changeContext) : New function to change uim engine of
	  its XimIC.
	* xim/ximserver.cpp (XimServer::changeContext) : Renamed back from
	  changeWholeContext().
	(InputContext::update_prop_list) : Disable using "prop_engine_".
	(InputContext::update_prop_label) : Add more sanity check.
	* xim/main.cpp (parse_helper_str_im_change) : New function to
	  support im switching.
	(send_im_list) : Ditto.  Currently it only sends the name of
	  conversion engines, and need to add language and description
	  later.
	(helper_str_parse) : Support "im_list_get" and "im_change".
	* xim/ximserver.h (class XimServer) : Rename changeWholeContext()
	  back into changeContext().
	
2004-09-27 kzk <mover@hct.zaq.ne.jp>
	
	* helper/toolbar-common-gtk.c
	  - (calc_menu_position): consider button's height
	
2004-09-27 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit performs the 'context object integration' suggested in
	  the following message. This fixes bug #1450.
	  http://freedesktop.org/pipermail/uim/2004-September/000641.html
	
	  The modification changes the Scheme API for IM implementors.The
	  difference will be described in doc/COMPATIBILITY.
	
	* The context object for each IMs have inherit 'context' defined in
	  im.scm. This is performed by concatenating the 2 specs for
	  define-record. So the context object for each IMs have acquired 'id'
	  and 'im' members defined in 'context' and accessors for them
	
	* uim/uim-func.c
	  - (retrieve_uim_context): New static function. This function
	    performs retrieval of a uim_context by Scheme-side integrated
	    context object. This also accepts 'id' for backward
	    compatibility. This is not a uim API, so did not name as
	    uim_retrieve_context()
	  - (im_clear_preedit, im_pushback_preedit, im_update_preedit,
	    im_commit, im_commit_raw, im_set_encoding, im_clear_mode_list,
	    im_pushback_mode_list, im_update_mode_list, im_update_prop_list,
	    im_update_prop_label, im_update_mode,
	    im_activate_candidate_selector, im_select_candidate,
	    im_shift_page_candidate, im_deactivate_candidate_selector,
	    im_request_surrounding, im_delete_surrounding): Replace
	    uim_find_context() with retrieve_uim_context() to accept the
	    integrated context object as first argument
	
	* scm/util.scm
	  - (define-record): Add partial initialization feature of *-new. The
	    feature has been tested by test/test-util.scm
	* test/test-util.scm
	  - (test define-record record definition): Add new tests for partial
	    initialization of *-new
	
	* scm/im.scm
	  - (context-rec-spec): New variable to define-record context object
	  - (context-id, context-im): Replace with define-record
	  - (context-data, set-context-data!): Remove unneeded procedures to
	    follow the context object integration
	  - (add-context): Remove to replace with register-context
	  - (register-context): New procedure which replaces add-context. This
	    procedure don't perform context object creation
	  - (invoke-handler): Replace id with context in arguments for handler
	  - (create-context):
	    * Manually call im-init-handler instead of using invoke-handler to
	      follow specification change of init-handler
	    * Replace add-context with register-context
	  - (key-press-handler, key-release-handler, prop-handler): Replace
	    some id with context
	  - (default-push-back-mode, default-init-handler,
	    default-release-handler, default-key-press-handler,
	    default-key-release-handler, default-reset-handler,
	    default-mode-handler, default-get-candidate-handler,
	    default-set-candidate-index-handler, default-prop-handler): Move
	    to new file default-im.scm
	  - Add (require "default-im.scm")
	
	* scm/Makefile.am
	  - Add default-im.scm
	
	* scm/default-im.scm
	  - New file
	  - (default-context-rec-spec): New variable to define-record context
	    object
	  - (record default-context): New record
	  - (default-push-back-mode, default-release-handler,
	    default-key-press-handler, default-key-release-handler,
	    default-reset-handler, default-mode-handler,
	    default-get-candidate-handler,
	    default-set-candidate-index-handler, default-prop-handler):
	    * Move from im.scm
	    * Integrate the context objects
	  - (default-init-handler):
	    * Move from im.scm
	    * Add argument 'im'
	    * Follow the specificatoin change of init-handler
	  - (default-key-release-handler):
	    * Move from im.scm
	    * Integrate the context objects
	    * Add lacking im-commit-raw to properly through user input
	
	* scm/generic.scm
	  - (record generic-context): Inherit 'context' defined in im.scm
	  - (generic-context-rec-spec): New variable to define-record context
	    object
	  - (generic-context-new):
	    * Add arguments 'id' and 'im'
	    * Initialize 'context' part of the object
	  - (generic-init-handler):
	    * Add argument 'im'
	    * Add argument 'im' to actual init-handler
	    * Follow the specificatoin change of init-handler
	    * Integrate the context objects
	  - (generic-update-preedit, generic-commit-raw,
	    generic-proc-input-state, generic-proc-converting-state,
	    generic-proc-off-mode, generic-key-press-handler,
	    generic-key-release-handler, generic-reset-handler,
	    generic-mode-handler, generic-get-candidate-handler,
	    generic-set-candidate-index-handler, generic-prop-handler,
	    generic-update-prop-label, generic-update-prop-list): Integrate
	    the context objects
	  - (generic-register-im): Rename short_desc to short-desc to conform
	    to lisp culture
	
	* scm/hangul.scm
	  - (hangul-proc-on-mode, hangul-key-press-handler): Integrate the
	    context objects
	  - (hangul-register-im): Rename short_desc to short-desc to conform
	    to lisp culture
	  - (hangul2-init-handler, hangul3-init-handler, romaja-init-handler):
	    * Add argument 'im'
	    * Follow the specificatoin change of init-handler
	    * Integrate the context objects
	  - Modifiy a comment for hangul3 IM
	
	* scm/pyload.scm
	  - (py-init-handler, pyunihan-init-handler, pinyin-big5-init-handler):
	    * Add argument 'im'
	    * Follow the specificatoin change of init-handler
	    * Integrate the context objects
	
	* scm/viqr.scm
	  - (viqr-init-handler):
	    * Add argument 'im'
	    * Follow the specificatoin change of init-handler
	
	* scm/ipa.scm
	  - (ipa-init-handler):
	    * Add argument 'im'
	    * Follow the specificatoin change of init-handler
	
	* scm/tcode.scm
	  - (tcode-init-handler):
	    * Add argument 'im'
	    * Follow the specificatoin change of init-handler
	
	* scm/tutcode.scm
	  - (record tutcode-context): Inherit 'context' defined in im.scm
	  - (tutcode-context-rec-spec): New variable to define-record context
	    object
	  - (tutcode-context-new):
	    * Add arguments 'id' and 'im'
	    * Initialize 'context' part of the object
	  - (tutcode-init-handler):
	    * Add argument 'im'
	    * Follow the specificatoin change of init-handler
	  - (tutcode-update-mode, tutcode-proc-on-mode, tutcode-proc-off-mode,
	    tutcode-key-press-handler, tutcode-key-release-handler,
	    tutcode-mode-handler, tutcode-prop-handler,
	    tutcode-update-prop-label, tutcode-update-prop-list,
	    tutcode-update-prop-list, tutcode-reset-handler,
	    tutcode-get-candidate-handler,
	    tutcode-set-candidate-index-handler): Integrate the context
	    objects
	
	* scm/m17nlib.scm
	  - Insert missing license header
	  - (record m17nlib-context):
	    * Inherit 'context' defined in im.scm
	    * Rename the member 'id' to 'mc-id' to avoid conflict with
	      context-id
	  - (m17nlib-context-rec-spec): New variable to define-record context
	    object
	  - (m17nlib-context-new):
	    * Add arguments 'id' and 'im'
	    * Initialize 'context' part of the object
	  - (m17nlib-init-handler):
	    * Add argument 'im'
	    * Follow the specificatoin change of init-handler
	  - (m17nlib-update-preedit, m17nlib-update-candidate,
	    m17nlib-release-handler, m17nlib-mode-handler, m17nlib-push-key,
	    m17nlib-press-key-handler, m17nlib-release-key-handler,
	    m17nlib-reset-handler, m17nlib-get-candidate-handler,
	    m17nlib-set-candidate-index-handler, m17nlib-prop-handler):
	    Integrate the context objects
	
	* scm/anthy.scm
	  - (record anthy-context): Inherit 'context' defined in im.scm
	  - (anthy-context-rec-spec): New variable to define-record context
	    object
	  - (anthy-context-new):
	    * Add arguments 'id' and 'im'
	    * Initialize 'context' part of the object
	  - (anthy-init-handler):
	    * Add argument 'im'
	    * Follow the specificatoin change of init-handler
	    * Integrate the context objects
	  - (anthy-commit-raw, anthy-release-handler, anthy-mode-handler,
	    anthy-update-preedit, anthy-proc-raw-state,
	    anthy-proc-input-state-no-preedit,
	    anthy-proc-input-state-with-preedit, anthy-proc-input-state,
	    anthy-pushback-preedit-segment-rec, anthy-compose-state-preedit,
	    anthy-input-state-preedit, anthy-do-commit, anthy-move-candidate,
	    anthy-reset-candidate-window, anthy-resize-segment,
	    anthy-proc-compose-state, anthy-proc-wide-latin,
	    anthy-press-key-handler, anthy-release-key-handler,
	    anthy-reset-handler, anthy-get-candidate-handler,
	    anthy-set-candidate-index-handler, anthy-prop-handler,
	    anthy-update-prop-label, anthy-update-mode,
	    anthy-update-prop-list): Integrate the context objects
	
	* scm/canna.scm
	  - Remove unneeded (require "generic-key.scm")
	  - (record canna-context): Inherit 'context' defined in im.scm
	  - (canna-context-rec-spec): New variable to define-record context
	    object
	  - (canna-context-new):
	    * Add arguments 'id' and 'im'
	    * Initialize 'context' part of the object
	  - (canna-init-handler):
	    * Add argument 'im'
	    * Follow the specificatoin change of init-handler
	    * Integrate the context objects
	  - (canna-commit-raw, canna-mode-handler, canna-update-preedit,
	    canna-proc-input-state-no-preedit,
	    canna-proc-input-state-with-preedit, canna-proc-input-state,
	    canna-pushback-preedit-segment-rec, canna-compose-state-preedit,
	    canna-input-state-preedit, canna-do-commit, canna-release-handler,
	    canna-mode-handler, canna-move-candidate,
	    canna-reset-candidate-window, canna-resize-segment,
	    canna-proc-compose-state, canna-proc-wide-latin,
	    canna-press-key-handler, canna-release-key-handler,
	    canna-reset-handler, canna-get-candidate-handler,
	    canna-set-candidate-index-handler, canna-prop-handler,
	    canna-proc-raw-state, canna-update-prop-label, canna-update-mode,
	    canna-update-prop-list): Integrate the context objects
	
	* scm/skk.scm
	  - (record skk-context): Inherit 'context' defined in im.scm
	  - (skk-context-rec-spec): New variable to define-record context
	    object
	  - (skk-context-new):
	    * Add arguments 'id' and 'im'
	    * Initialize 'context' part of the object
	    * Integrate the context objects
	  - (skk-init-handler):
	    * Add argument 'im'
	    * Follow the specificatoin change of init-handler
	    * Integrate the context objects
	  - (skk-current-context): Remove unneeded procedure
	  - (skk-commit-raw, skk-commit-raw-with-preedit-update, skk-commit,
	    skk-prepare-commit-string, skk-begin-conversion,
	    skk-begin-completion, skk-do-update-preedit, skk-update-mode,
	    skk-update-preedit, skk-commit-editor-context,
	    skk-proc-state-direct-no-preedit, skk-proc-state-direct,
	    skk-proc-state-kanji, skk-setup-child-context,
	    skk-check-candidate-window-begin, skk-change-candidate-index,
	    skk-reset-candidate-window, skk-back-to-kanji-state,
	    skk-change-completion-index, skk-proc-state-completion,
	    skk-proc-state-converting, skk-proc-state-okuri,
	    skk-proc-state-latin, skk-proc-state-wide-latin, skk-push-key,
	    skk-press-key-handler, skk-release-key-handler, skk-reset-handler,
	    skk-mode-handler, skk-get-candidate-handler,
	    skk-set-candidate-index-handler, skk-prop-handler,
	    skk-update-prop-label, skk-update-prop-list): Integrate the
	    context objects
	
	* scm/skk-editor.scm
	  - (record skk-editor): Remove unneeded member 'id'
	  - (skk-editor-new, skk-editor-commit-raw): Integrate the context
	    objects
	
	* scm/prime.scm
	  - (record prime-context): Inherit 'context' defined in im.scm
	  - (prime-context-rec-spec): New variable to define-record context
	    object
	  - (prime-context-new):
	    * Add arguments 'id' and 'im'
	    * Initialize 'context' part of the object
	  - (prime-init-handler):
	    * Add argument 'im'
	    * Follow the specificatoin change of init-handler
	    * Integrate the context objects
	  - (prime-uim-candwin-get-range, prime-command-commit-raw,
	    prime-command-register-mode, prime-command-wide-latin-input,
	    prime-command-conv-next, prime-command-register-conv-next,
	    prime-command-conv-prev, prime-command-conv-cancel,
	    prime-command-conv-commit, prime-command-register-conv-commit,
	    prime-command-conv-select, prime-command-register-conv-select,
	    prime-command-conv-input, prime-command-register-conv-input,
	    prime-command-preedit-cancel, prime-command-preedit-backspace,
	    prime-command-preedit-delete, prime-command-preedit-commit,
	    prime-command-register-preedit-commit,
	    prime-command-preedit-cursor-left-edge,
	    prime-command-preedit-cursor-right-edge,
	    prime-command-preedit-cursor-left,
	    prime-command-preedit-cursor-right, prime-command-preedit-input,
	    prime-command-preedit-commit-candidate,
	    prime-command-register-preedit-commit-candidate,
	    prime-command-preedit-convert,
	    prime-command-preedit-convert-reversely, prime-command-fund-input,
	    prime-command-fund-space, prime-command-fund-altspace,
	    prime-command-fund-commit-ja-direct,
	    prime-command-register-fund-backspace,
	    prime-command-register-fund-delete,
	    prime-command-register-fund-cancel,
	    prime-command-register-fund-commit,
	    prime-command-register-fund-cursor-left-edge,
	    prime-command-register-fund-cursor-right-edge,
	    prime-command-register-fund-cursor-left,
	    prime-command-register-fund-cursor-right, prime-push-key,
	    prime-commit-raw, prime-commit-without-learning,
	    prime-commit-word-data, prime-commit-candidate,
	    prime-commit-to-register-buffer, prime-convert-selection-move,
	    prime-begin-conversion-internal, prime-begin-conversion-reversely,
	    prime-begin-conversion, prime-update, prime-update-state,
	    prime-update-history, prime-update-preedit,
	    prime-register-state-update-preedit,
	    prime-preedit-state-update-preedit, prime-display-preedit,
	    prime-display-preedit-cursor, prime-update-prediction,
	    prime-update-candidate-window, prime-press-key-handler,
	    prime-release-key-handler, prime-reset-handler, prime-mode-set,
	    prime-mode-handler, prime-get-candidate-handler,
	    prime-set-candidate-index-handler, prime-prop-handler,
	    prime-update-prop-label, prime-update-prop-list): Integrate the
	    context objects
	
	* scm/spellcheck.scm
	  - (record spell-context): Inherit 'context' defined in im.scm
	  - (spell-context-rec-spec): New variable to define-record context
	    object
	  - (spell-context-new):
	    * Add arguments 'id' and 'im'
	    * Initialize 'context' part of the object
	  - (spell-init-handler):
	    * Add argument 'im'
	  - (spell-begin-conversion, spell-update-preedit, spell-update-mode,
	    spell-update-candidate-window, spell-proc-input-no-preedit,
	    spell-proc-input-with-preedit, spell-proc-state-converting,
	    spell-proc-mode-latin, spell-push-key, spell-press-key-handler,
	    spell-release-key-handler, spell-reset-handler,
	    spell-mode-handler, spell-get-candidate-handler,
	    spell-set-candidate-index-handler): Integrate the context objects
	  - Add a short-desc to register-im
	
2004-09-27 kzk <mover@hct.zaq.ne.jp>
	
	* qt/qtkde-helper/src/candwin/uim-helper-candwin-qt.cpp
	  - fix prime's infinite loop
	    (corresponding change of r1225)
	
2004-09-27 kzk <mover@hct.zaq.ne.jp>
	
	* This is the big change of qtkde-helper.
	  Equivalent to recent changes of gtk's toolbar.
	
	* quimhelpertoolbar.cpp
	* quimhelpertoolbar.h
	  - proper charset parsing
	  - add whatsthishelp to popupMenu item
	  - add tooltip to button
	  - add switcher exec button
	  - fix memory leak
	  - (class QHelperButton): renamed from HelperButton
	  - fix message sending bug
	  - (class QHelperPopupMenu): renamed from HelperPopup
	  - add const prefix to proper function
	  - (signal messageSendDone): deleted
	  - (slot slotMessageSendDone): deleted
	
2004-09-27 kzk <mover@hct.zaq.ne.jp>
	
	* This commit fixes wrong message after "branch" tag.
	
	* scm/canna.scm
	  - fix wrong message described before
	  - fix typo
	* scm/anthy.scm
	  - fix wrong message described before
	
2004-09-27 kzk <mover@hct.zaq.ne.jp>
	
	* scm/generic.scm
	  - update prop-list when prop-handler is invoked
	
2004-09-27 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	* japanese.scm (load-azik-table) :
	 - change azik mode binding
	   see [anthy-dev 1073]. Thanks OHASHI-san.
	
2004-09-26 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	* configure.ac
	* Makefile.am
	  - add --enable-debug option to store scheme file and line number information.
	* uim/siod.h uim/slib.c
	  - store file name and linenumber to scheme object, if DEBUG_SCM is turned on.
	    see [anthy-dev 1077]. Thanks Inoue-san.
	
2004-09-26 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/locale.cpp : Remove ustring_to_euc_str() and
	Locale::uStringToCtext().	
	(ustring_to_utf8_str) : New function.  Replaces old
	  ustring_to_euc_str().
	(createLocale) : Renamed from getLocale() and take language name
	  as a argument.  Return UTF-8 locale to support multiple
	  languages.
	(class UTF8_Locale) : New class to handle UTF-8.
	(UTF8_Locale::UTF8_Locale) : Constructor using language name to
	  set internal locale name.
	(UTF8_Locale::compose_localename_from_lang) : Return UTF-8 locale
	  name for corresponding language name.  At the moment, it only
	  contains CJK and vi locale names, and should be fixed later.
	(UTF8_Locale::set_localename_from_lang) : Set internal UTF-8
	  locale name from language name.
	* xim/connection.h : Remove redundant include of <list>.
	* xim/main.cpp (supported_locales) : New static variable for
	  selection target locales.
	(notifyLocale) : Use supported_locales variable as a selection
	  target locales instead of using "ja_JP" only.
	(get_uim_info) : Use UTF-8 instead of EUC-JP for
	  uim_create_context().
	(init_supported_locales) : New function to get supported locale
	  list from uim engine's language information.
	(main) : Remove setlocale(), and this will be done in
	  InputContext::createUimContext() later.  Check supported locales
	  just after getting uim information.  Don't do init_convdisp()
	  here since it needs language information to draw correct
	  characters.
	* xim/ximserver.cpp : Remove str_to_ustring().
	(print_ustring) : Change to handle UTF-8 string instead of EUC-JP.
	(XimServer::Ximserver) : Don't copy language name.
	(XimServer::changeWholeContext) : Renamed from changeContext().
	(XimServer::strToUstring) : Change to handle UTF-8 string instead
	  of EUC-JP.
	(XimServer::getLocale) : New function.
	(XimServer::set_im) : Change internal language and locale names
	 upon changing back-end conversion engines.
	(get_im_lang_from_engine) : New function to get language name from
	  corresponding uim back-end conversion engine's name.
	(InputContext::InputContext) : Now InputContext has current
	  context's conversion engine's name.  The name is copied with
	  strdup() since it may be different from ximserver's one.
	(InputContext::~InputContext) : Free mEngineName.
	(InputContext::createUimContext) : Do setlocale() with
	  corresponding locale name while creating uim context.  Use UTF-8
	  instead of EUC-JP for uim_create_context().
	(InputContext::changeContext) : Renamed from changeUimContext.
	  This function changes InputContext's uim back-end engine, and
	  set language of its preedit window.
	(InputContext::update_prop_list) : Change to use dynamic memory
	  allocation for message buffer.
	(InputContext::update_prop_label) : Ditto.
	(InputContext::get_engine_name) : New function to return
	  conversion engine's name of the context.
	* xim/canddisp.cpp : Include "uim/uim.h" instead of <uim/uim.h>.
	(Canddisp::activate) : Send messages for uim-candwin-gtk with
	  UTF-8 string.
	* xim/convdisp.cpp : Add default fontset for zh_CN, zh_TW, and ko.
	(init_convdisp) : Create fontset for zh_CN, zh_TW, and ko.
	(class PeWin) : Now constructor handles language name for
	  argument.
	(class PeLineWin) : Ditto.
	(class PeOvWin) : Ditto.
	(class ConvdispOv) : Add virtual method set_lang().  Add private
	  variables m_initial_fontset and m_initial_lang.
	(create_convdisp) : Do initi_convdisp() here.
	(PeWin::PeWin) : Handles language name for argument.  Set initial
	  fontset considering with language.
	(PeWin::draw_char) : Change to handle UTF-8 string.
	(PeLineWin::PeLineWin) : Handles language name for argument.
	  Make window height a bit smaller.
	(PeLineWin::draw_segment) : Remove spaces between characters.
	(PeLineWin::calc_extent) : Make window height a bit smaller.
	(PeOvWin::PeOvWin) : Handles language name for argument.
	(Convdisp::Convdisp) : Set language name from its context's
	  conversion engine.
	(Convdisp::set_lang) : New function.
	(ConvdispRw::ConvdispRw) : Change to use dynamic creation and
	  destruction of root  style preedit window.
	(ConvdispRw::~ConvdispRw) : Ditto.
	(ConvdispRw::update_preedit) : Ditto.
	(ConvdispRw::clear_preedit) : Ditto.
	(ConvdispRw::move_candwin) : Don't check focus.  Remove redundant
	  code.
	(ConvdispOv::ConvdispOv) : Remember language name.
	(ConvdispOv::~ConvdispOv) : Free the language name.
	(ConvdispOv::set_lang) : New function to set correct fontset from
	  the displayed language.
	(ConvdispOv::do_draw_preedit) : Fix typo in comment.
	(ConvdispOv::check_win) : Add language information for creating
	  PeOvWin.
	(ConvdispOv::check_atr) : Set initial fontset with corresponding
	  language is ICA_FontSet is not available.  If ICA_FontSet is
	  available, remember it.
	(ConvdispOv::layoutCharEnt) : Change to handle UTF-8 string.
	(ConvdispOs::move_candwin) : Don't check focus.
	* xim/ximserver.h : Include "uim/uim.h" instead of <uim/uim.h>.
	  Change the type of uchar from int to wchar_t.  Remove prototype
	  of str_to_ustring().  Rename prototype of getLocale() to
	  createLocale().  Add prototype of get_im_lang_from_engine().
	(class InputContext) : Add public method get_engine_name().
	  Rename method name changeUimContext() to changeContext().  Add
	  private variable mEngineName.
	(class Locale) : Mark uStringToCtext() as pure virtual method.
	  Add prototype of set_locale_from_lang() and
	  compose_localename_from_lang().  Add private variable
	  mLocaleName.
	(class XimServer) : Rename changeContext() into
	  changeWholeContext().  Add public method getLocale().  Make
	  mLang const.
	* convdisp.h (class Convdisp) : Add virtual method set_lang().
	  Add protected variable mLang.
	
2004-09-26 kzk <mover@hct.zaq.ne.jp>
	
	* doc/HELPER-PROTOCOL
	  - (im_list): add selectedflag information
	
2004-09-25 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* scm/prime.scm:
	 -(prime-context-history-set!): Fixed the lack of the first argument of 
	    prime-context-set-history!
	
2004-09-25 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* helper/input-pad-ja.c:
	 -(buttontable_create): Removed calling gtk_widget_size_request.
	
2004-09-25 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit fixes compilation-time problems. No actual codes are
	  modified
	
	* Makefile.am
	  - Remove unused and invalid DEFS which masks autoconf'ed one
	
	* uim/Makefile.am
	  - Remove invalid DEFS which masks autoconf'ed one. Definition are
	    move into an user variable and included via per_exec_CPPFLAGS
	  - Move invalid -I in per_exec_CFLAGS into per_exec_CPPFLAGS
	
	* helper/Makefile.am
	  - Remove invalid CFLAGS which masks autoconf'ed one. Definition are
	    move into an user variable and included via per_exec_CPPFLAGS
	  - Move invalid -I in per_exec_CFLAGS into per_exec_CPPFLAGS
	
	* gtk/Makefile.am
	  - Move invalid -I in per_exec_CFLAGS into per_exec_CPPFLAGS
	
	* xim/Makefile.am
	  - Move invalid -I in per_exec_CFLAGS into per_exec_CPPFLAGS
	  - Add uim_xim_CFLAGS for failsafe for future
	
	* fep/Makefile.am
	  - Move invalid -I in per_exec_CFLAGS into per_exec_CPPFLAGS
	
	* sumika/common/Makefile.am
	  - Rename deprecated INCLUDES to AM_CPPFLAGS
	* sumika/gtk2/Makefile.am
	  - Rename deprecated INCLUDES to AM_CPPFLAGS
	  - Move -D in AM_CFLAGS to AM_CPPFLAGS appropriately
	  - Remove redundant -DHAVE_CONFIG_H which automatically included in
	    DEFS
	
	* uim/uim.c
	* uim/uim-ipc.c
	* uim/uim-helper.c
	* uim/uim-helper-server.c
	* uim/uim-helper-client.c
	* uim/getpeereid.c
	* uim/uim-sh.c
	  - Replace #include <> with "" to appropriately include the files in
	    local directly
	
2004-09-24 kzk <mover@hct.zaq.ne.jp>
	
	* qt/quiminputcontextplugin
	* qt/quiminputcontextplugin-qt4
	  - disable immodule layer implemented IM-switching
	  - (sendImList): add "selected" flag
	    (Now uim-im-switcher is available for this purpose)
	
2004-09-24 Masahito Omote <omote@utyuuzin.net>
	
	* helper/dict-main-gtk.c:
	  - (parse_arg): Use getopt. But this entry is now in comment entry.
	
2004-09-24 kzk <mover@hct.zaq.ne.jp>
	
	* qt/quiminputcontextplugin/src/qhelpermanager.cpp
	* qt/quiminputcontextplugin-qt4/qhelpermanager.cpp
	  - (parseHelperStr): Fix message handling of
	    prop_update_custom to be complied with the intended
	    specification. It should be processed even if not focused
	
	  - this change corresponds to gtk-immodule's change at r1287
	
2004-09-24 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/HELPER-PROTOCOL
	  - Fix a typo
	
2004-09-24 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/HELPER-PROTOCOL
	  - Describe a new chapter 'Network topology and message passing'
	  - Describe about the protocol into 'Message format in BNF'
	  - Describe about the name 'property' into 'Property messages'
	  - (prop_custom_update): Describe a design decision
	  - (commit_string): Describe reasonably
	
2004-09-24 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* gtk/gtk-im-uim.c
	  - (im_uim_parse_helper_str): Fix message handling of
	    prop_update_custom to be complied with the intended
	    specification. It should be processed even if not focused
	
	
2004-09-24 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/HELPER-PROTOCOL
	  - (focus_in, focus_out): Describe well
	  - (prop_update_custom): Fix a message definition
	    bug. prop_update_custom uses "\n" as argument delimiter to allow
	    "\t" as value
	
2004-09-24 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/HELPER-PROTOCOL
	  - (prop_label_update): Describe as reasonable
	  - (prop_list_update): Describe well
	  - Fix menucommand_name definition
	
2004-09-24 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/HELPER-PROTOCOL
	  - (prop_label_get, prop_list_get): Describe well
	
2004-09-24 kzk <mover@hct.zaq.ne.jp>
	
	* qt/quiminputcontextplugin/src/qhelpermanager.cpp
	* qt/quiminputcontextplugin-qt4/qhelpermanager.cpp
	  - fix wrong if condition for "im_change_*" message
	
2004-09-24 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/xim.h (class Connection) : Add new function prototype,
	  is_xim_sync_reply_timeout() and clear_pendign_rx().  Add new
	  private variable, mSyncStartTime.
	* xim/ximtrans.cpp (Connection::setSyncFlag) : Record the time of
	  setting flag.
	(Connection::xim_forward_event) : Handle XIM protocol error
	  situation as XIM library won't return XIM_SYNC_REPLY after
	  some time interval.  Hopefully this is the last modification
	  about XIM event flow of uim-xim.
	(Connection::is_xim_sync_reply_timeout) : New function.  Set
	  timeout interval with 5 second for now.
	(Connection::clear_pending_rx) : New function.
	
2004-09-24 kzk <mover@hct.zaq.ne.jp>
	
	* doc/HELPER-PROTOCOL
	* qt/quiminputcontextplugin/src/qhelpermanager.cpp
	* qt/quiminputcontextplugin-qt4/qhelpermanager.cpp
	  - replace all of "this_context" with "this_text_area"
	
2004-09-24 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/HELPER-PROTOCOL
	  - Fix message delimiter definition. "\n\n" does not mean session
	    termination but message boundary. See uim_helper_get_message()
	  - (prop_label_update): Replace label_string and tooltip_string with
	    iconic_label and menulabel_string in accordance with anthy.scm and
	    toolbar-common-gtk.c. Fix it if my understanding is wrong
	  - (prop_list_update): Give branch arguments semantic names
	
2004-09-24 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* helper/toolbar-common-gtk.c
	  - (helper_applet_prop_label_update): Rename tmp and tmp2 with
	    'lines' and 'pair' to indicate what it means. It helps to
	    recognize the helper protocol definition
	
2004-09-24 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/HELPER-PROTOCOL
	  - (prop_activate): Describe well
	  - (prop_list_update): Rename icon_name to iconic_label
	  - Define menucommand_name in accordance with my knowledge. Fix if
	    wrong.
	
2004-09-24 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* doc/HELPER-PROTOCOL
	  - Describe 'prop_update_custom' message well
	  - Categorize messages as 'Focus notification messages', 'Property
	    messages', 'IM management messages' and 'Other messages'
	  - Add some definitions
	  - Form as structured document
	
2004-09-24 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* gtk-im-uim.c: All of "this widget" was renamed to "this text area".
	
2004-09-24 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* im-switcher-gtk.c: all of "this widget" was renamed to "this text area".
	
2004-09-24 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* im.scm: Rewrited short description of default im.
	
2004-09-24 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* im-switcher-gtk.c:
	 -(parse_arg): New function. Renamed from arg_parse from the point of view
	   of consistency.
	 -(parse_helper_str_im_list): Interpret "selected" flag.
	
	
2004-09-24 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* gtk/gtk-im-uim.c:
	 -(im_uim_send_im_list): Send im infomation with "selected" flag when 
	    the input method is selected.
	
2004-09-24 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* uim/uim.h: Added new function, uim_get_current_im_name.
	* uim/uim.c: Added new function, uim_get_current_im_name.
	
	* uim/context.h: Added new struct member current_im_name to uim_context.
	
2004-09-24 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* uim-helper-server.c: Added some comments.
	
2004-09-24 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* uim/intl.c : Use LANG instead of LC_ALL.
	* uim/gettext.h : Enable compilation if nls is disabled.
	
2004-09-24 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/ximtrans.cpp (Connection::xim_forward_event) : Add received
	  XIM_FORWARD packet to pending queue while synchronous flag is
	  on.
	(Connection::xim_sync_reply) : Handle pending Rx event upon
	  receiving XIM_SYNC_REPLY.
	(Connection::~Connection) : Update.
	* xim/connection.cpp (XConnection::writeProc) : Use pending Tx
	  packet queue just for XIM_FORWARD event consecutive to
	  XIM_COMMIT.
	* xim/xim.h : Add new definition copyRxPacket().
	(class Connection) : Add new list for pending RxQ.  Delete
	  pending queue for mPTxQ which is now unused.
	* xim/ximpacket.cpp (class RxPacket_impl) : Add copy constructor.
	(RxPacket_impl::RxPacket_impl) : Implement copy constructor.
	(copyRxPacket) : New function.  Return duplicated Rx packet.
	
2004-09-24 kzk <mover@hct.zaq.ne.jp>
	
	* helper/toolbar-common-gtk.c
	  - (switcher_button_create): new function
	  - (switcher_button_pressed): renamed from (switch_button_clicked_cb)
	  - add tooltip for switcher-exec button
	
	* added the code for using icon (switcher.png) in
	  (switcher_button_create) function. But corrently,
	  this code is commented out. Once icon is committed,
	  please use the code.
	
2004-09-24 kzk <mover@hct.zaq.ne.jp>
	
	* helper/input-pad-ja.c
	  - update message
	
2004-09-24 kzk <mover@hct.zaq.ne.jp>
	
	* helper/toolbar-common-gtk.c
	  - prevent multiple "sw" button creation.
	    (add sw button to the menu_button list and
	    make it deleted in list-updating)
	  - add tooltip to the label
	
2004-09-24 kzk <mover@hct.zaq.ne.jp>
	
	* qt/quiminputcontextplugin/src/qhelpermanager.cpp
	  - (parseHelperStr): Changed condition of calling
	   parseHelperStrImChange. This change enables
	   some messages. (im_change_whole_desktop).
	
	  - this commit corresponds to gtk's change at r1259
	
	
2004-09-23 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/util.scm
	  - (define-record): Fix default value copying
	* uim/slib.c
	  - (siod_init): Add NIL initilization of sym_else
	
2004-09-23 kzk <mover@hct.zaq.ne.jp>
	
	* This commit adds data/icon directory for icon support
	
	* helper/Makefile.am
	  - define UIM_DATADIR and add it to CFLAG
	
	* configure.ac
	  - add "data/Makefile" and "data/icons/Makefile" to AC_CONFIG_FILES
	
	* Makefile.am
	  - define data directory as subdirectory
	
	* data/
	  - the directory to store icons or other datas.
	    (alphabet_a.png is the experimental one)
	
	
2004-09-22 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* toolbar-common-gtk.c:
	 -(switch_button_clicked_cb): New function.
	 -(helper_applet_prop_list_update): Add a button to exec switcher.
	
2004-09-22 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* uim-fep.c: Some comments were translated into English.
	
2004-09-22 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* gtk-im-uim.c:
	 -(im_uim_parse_helper_str): Changed condition of calling
	   im_uim_parse_helper_str_im_change. This change enables
	   some messages. (im_change_whole_desktop).
	
2004-09-22 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* dict-anthy-gtk.c:
	 -(anthy_add_window_necessary_create): New function.
	
2004-09-22 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* helper/Makefile.am: Removed uncreated rule uim-pref.
	
2004-09-22 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* helper/: Added uim-dict.
	 dict-main-gtk.c: New file.
	 dict-anthy.c: New file.
	 dict-util.c: New file.
	 dict-anthy-gtk.c: New file.
	
2004-09-22 kzk <mover@hct.zaq.ne.jp>
	
	* doc/HELPER-PROTOCOL
	  - fix typo
	  - rename "str" to more semantic name
	
2004-09-22 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* configure.ac Makefile.am:
	  Added a new directory sumika.
	
	
2004-09-22 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* sumika/: Now we can compile sumika. But I've used many #if 0,
	           it wouldn't works properly.
	
2004-09-22 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* sumika/: Merged sumika. (This will not work yet.)
	
2004-09-21 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	* gtk/gtk-im-uim.c : treat Kanji key same as Zenkaku-Hankaku key
	* xim/ximserver.cpp : Ditto.
	
2004-09-21 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/ximserver.cpp : Update changes of r1249.  Make modifier
	  values static to prevent calculation upon every key press.
	* xim/ximserver.h : Ditto.
	
2004-09-21 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/ximserver.cp (keyState::keyState) : Check modifier keys with
	  corresponding keysyms.
	(keyState::check_modifier) : New function.  Return correct UMod
	  values from keysyms.
	(init_modifier_keys) : New function to check current modifier map.
	* xim/main.cpp (main) : Do init_modifier_keys() at startup.
	* xim/ximserver.h : Add prototype of init_modifier_keys().  Add
	  new lists for modifier keysyms: gShiftMask, gLockMask,
	  gControlMask, gMod1Mask, gMod2Mask, gMod3Mask, gMod4Mask,
	  gMod5Mask.
	
2004-09-21 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/util.scm
	  - (else): Move into slib.c
	* uim/slib.c
	  - (sym_else): New static variable
	  - (init_storage_1): Add initialization of sym_else
	  - (leval_case): Clean up using sym_else
	
	* uim/uim.c
	  - (uim_init_scm): Add comments to siod_argv values
	
2004-09-21 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/ximic.cpp (XimIC::setFocus) : Move candidate window before
	  updating.
	
2004-09-21 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	*po/ja.po: Added some translations.
	
2004-09-21 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* po/ja.po: Added some translations.
	
2004-09-21 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* po/uim.pot: Updated pot file.
	
2004-09-21 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* POTFILES.in: Added some files to translate.
	
2004-09-21 kzk <mover@hct.zaq.ne.jp>
	
	* scm/anthy.scm
	  - fix ambiguous helper message for tooltip
	
2004-09-21 kzk <mover@hct.zaq.ne.jp>
	
	* helper/toolbar-common-gtk.c
	  - introduce tooltip message.
	    add "prop_tooltip" list and use it.
	
2004-09-21 kzk <mover@hct.zaq.ne.jp>
	
	* helper/toolbar-common-gtk.c
	  - fix memory leak introduced r1140
	
2004-09-21 kzk <mover@hct.zaq.ne.jp>
	
	* tables/Makefile.am: remove trailing "/"
	
2004-09-20 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/convdisp.cpp (ConvdispOv::move_candwin) : Give
	  ICA_FocusWindow priority over ICA_Client_Window.  Add some more
	  hack for flashplayer plugin.
	(ConvdispOv::validate_area) : Give ICA_FocusWindow priority.
	(ConvdispOv::do_draw_preedit) : Ditto.
	(ConvdispOv::check_win) : Ditto.
	
2004-09-20 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/convdisp.cpp (ConvdispOv::do_draw_preedit) : Fix silly bug
	  introduced in r1213.
	
2004-09-20 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/ximserver.cpp (keyState::keyState) : Remove check for mod2 mask.
	-This line, and those below, will be ignored--
	
	M    xim/ximserver.cpp
	
2004-09-20 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/canddisp.cpp : Include <unistd.h> for read(2).
	
2004-09-20 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* helper/helper-candwin-gtk.c : Make candidate window style
	  compatible with gtk immodule's one (many code copied from
	  gtk/uim-candidate-windoe.c).  Handle display_limit value while
	  activating candidate window.
	
	* doc/HELPER-CANDWIN : Add description about display_limit value.
	
	* xim/connection.cpp : Separate XConnection class definition into
	  connection.h.
	* xim/connection.h : New file.
	* xim/xim.h (class XimIC) : Add new prototype force_send_packet().
	* xim/ximic.c (XimIC::force_send_packet) : New function to send
	  packet queue without X event.
	* xim/main.cpp (add_fd_watch) : Remove static.
	* xim/ximserver.cpp : Handle shift_page_cb.
	(InputContext::InputContext) : set initial values for mNumPage and
	  mDisplayLimit.
	(InputContext::createUimContext) : Add candidate_shift_page_cb
	  callback.
	(InputContext::candidate_shift_page_cb) : New function.
	(InputContext::candidate_activate) : Handle display_limit while
	  activating the candidate window.  Set candidate page number
	  properly.
	(InputContext::candidate_update) : Handle display_limit.
	(InputContext::candidate_select) : Set current candidate page.
	(InputContext::candidate_shift_page) : New function of shift_page
	  implementation.
	* xim/canddisp.cpp (canddisp_singleton) : Add handler to receive
	  message from helper-cand-win-gtk.
	(Canddisp::activate) : Send display_limit value while activating
	  candidate window.
	(Canddisp::candwin_read_cb) : New function.  Receive message from
	  uim-candwin-gtk.  Set candidate index upon receiving "index".
	* xim/ximserver.h (class InputContext) : Add new prototype
	  candidate_shift_page and candidate_shift_page_cb.  Add new
	  private menber mDisplayLimit, mNumPage, and current_page.
	* xim/canddisp.h (class Canddisp) : Change prototype of
	  activate().
	
2004-09-20 kzk <mover@hct.zaq.ne.jp>
	
	* doc/HELPER-PROTOCOL
	  - rewrite to BNF style (assigned by bug1420)
	    please check.
	
2004-09-20 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* test/test-im.scm
	  - Describe which revision is tested by this test
	* test/test-util.scm
	  - Likewise
	
	* scm/util.scm
	  - (define-record): Add a comment about what it does
	
2004-09-20 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit refactors im.scm
	
	* scm/util.scm
	  - (filter): New SRFI procedure. Tested by test-util.scm
	  - (define-record): Add a comment which describes a design
	    consideration about rec-spec
	
	* test/test-util.scm
	  - (test map): Comment out 2 tests due to bug #617 'boolean value
	    representation is inconsistent'
	  - (test filter): New test
	  - (test filter-map): Add 3 tests
	
	* scm/im.scm
	  - Refactored with test-im.scm
	  - (preedit-attr?, register-im, next-im, find-context,
	    remove-context, add-context, create-context, release-context,
	    key-press-handler, key-release-handler, reset-handler,
	    mode-handler, get-candidate, set-candidate-index): Refactor
	  - (find-im-by-name-rec, remove-context-rec): Remove as result of the
	    refactoring
	  - (select-im): Renamed to find-im to avoid being regarded as
	    'switch-im'
	  - (find-im): Renamed from select-im and refactored
	  - (invoke-handler): New procedure
	  - (im-name, im-init-arg, im-init-handler, im-release-handler,
	    im-key-press-handler, im-encoding, im-key-release-handler,
	    im-reset-handler, im-mode-handler, im-get-candidate-handler,
	    im-set-candidate-index-handler, im-prop-handler): Replace with
	    define-record
	  - (make-im): Replace with define-record'ed im-new
	
	* test/test-im.scm
	  - Replace select-im with find-im in accordance the renaming
	  - (test im-record accessors): Replace make-im with im-new
	  - (test make-im, test find-im-by-name-rec): Remove as result of
	    the refactoring
	  - (testcase im handlers): Add entry point for invoke-handler. The
	    test is not written yet
	
2004-09-20 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* test/test-im.scm
	  - (testcase im im-management): Add 'short-desc' arg to register-im
	    in accordance with specification change in r1190
	* scm/im.scm
	  - (register-im): Rename short_desc to short-desc to conform to lisp
	    culture
	
2004-09-20 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* scm/anthy.scm
	  - (record anthy-context): Fix invalid list expression
	* scm/canna.scm
	  - (record canna-context): Fix invalid list expression
	* scm/skk.scm
	  - (record skk-context): Fix invalid list expression
	* scm/prime.scm
	  - (record prime-context, prime-context-new): Fix invalid list
	    expression
	
2004-09-20 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* This commit replaces boring context definitions with define-record
	  to make maintenance easy, avoid human errors and know what members
	  are defined at a glance. See test/test-util.scm to know what
	  define-record does. Developers, remove unused members in
	  define-record definitions which is named as "unused-nth" if truely
	  unused. They are temporarily existing as comment to preserve
	  original definition information
	
	* scm/generic.scm
	  - (generic-context-set-rk-context!, generic-context-rk-nth,
	    generic-context-set-rk-nth!, generic-context-on,
	    generic-context-set-on!, generic-context-candidate-op-count,
	    generic-context-set-candidate-op-count!,
	    generic-context-raw-commit, generic-context-set-raw-commit!,
	    generic-context-converting, generic-context-set-converting!):
	    Replace with define-record
	  - (generic-context-new-internal): New alias of generic-context-new
	    that implicitly defined by define-record
	  - (generic-context-new): Replace value initialization with
	    generic-context-new-internal
	
	* scm/rk.scm
	  - (rk-context-rule, rk-context-set-rule!, rk-context-seq,
	    rk-context-set-seq!, rk-context-immediate-commit,
	    rk-context-set-immediate-commit!, rk-context-back-match,
	    rk-context-set-back-match!): Replace with define-record
	  - (rk-context-new-internal): New alias of rk-context-new that
	    implicitly defined by define-record
	  - (rk-context-new): Replace value initialization with rk-context-new-internal
	
	* scm/anthy.scm
	  - (anthy-context-id, anthy-context-set-id!): Remove these invalid
	    and unused definitions
	  - (anthy-context-on, anthy-context-set-on!, anthy-context-state,
	    anthy-context-set-state!, anthy-context-ac-id,
	    anthy-context-set-ac-id!, anthy-context-left-string,
	    anthy-context-set-left-string!, anthy-context-right-string,
	    anthy-context-set-right-string!, anthy-context-rkc,
	    anthy-context-set-rkc!, anthy-context-index-list,
	    anthy-context-set-index-list!, anthy-context-cur-seg,
	    anthy-context-set-cur-seg!, anthy-context-candidate-window,
	    anthy-context-set-candidate-window!,
	    anthy-context-candidate-op-count,
	    anthy-context-set-candidate-op-count!, anthy-context-wide-latin,
	    anthy-context-set-wide-latin!, anthy-context-kana-mode,
	    anthy-context-set-kana-mode!, anthy-context-commit-raw,
	    anthy-context-set-commit-raw!, anthy-context-input-rule,
	    anthy-context-set-input-rule!, anthy-context-left-raw-string,
	    anthy-context-set-left-raw-string!,
	    anthy-context-right-raw-string,
	    anthy-context-set-right-raw-string!): Replace with define-record
	  - (anthy-context-new-internal): New alias of anthy-context-new that
	    implicitly defined by define-record
	  - (anthy-context-new): Replace value initialization with
	    anthy-context-new-internal
	
	* scm/canna.scm
	  - (canna-context-id, canna-context-set-id!): Remove these invalid
	    and unused definitions
	  - (canna-context-on, canna-context-set-on!, canna-context-state,
	    canna-context-set-state!, canna-context-cc-id,
	    canna-context-set-cc-id!, canna-context-left-string,
	    canna-context-set-left-string!, canna-context-right-string,
	    canna-context-set-right-string!, canna-context-rkc,
	    canna-context-set-rkc!, canna-context-index-list,
	    canna-context-set-index-list!, canna-context-cur-seg,
	    canna-context-set-cur-seg!, canna-context-candidate-window,
	    canna-context-set-candidate-window!,
	    canna-context-candidate-op-count,
	    canna-context-set-candidate-op-count!, canna-context-wide-latin,
	    canna-context-set-wide-latin!, canna-context-kana-mode,
	    canna-context-set-kana-mode!, canna-context-commit-raw,
	    canna-context-set-commit-raw!, canna-context-input-rule,
	    canna-context-set-input-rule!): Replace with define-record
	  - (canna-context-new-internal): New alias of canna-context-new that
	    implicitly defined by define-record
	  - (canna-context-new): Replace value initialization with
	    canna-context-new-internal
	  - (canna-proc-input-state-no-preedit): Replace invalid
	    canna-type-hankana with multi-segment-type-hankana
	
	* scm/skk.scm
	  - (skk-context-completion-nth, skk-context-set-completion-nth!,
	    skk-context-commit-raw, skk-context-set-commit-raw!,
	    skk-context-latin-conv, skk-context-set-latin-conv!,
	    skk-context-editor, skk-context-set-editor!,
	    skk-context-parent-context, skk-context-set-parent-context!,
	    skk-context-child-context, skk-context-set-child-context!,
	    skk-context-candidate-window, skk-context-set-candidate-window!,
	    skk-context-candidate-op-count,
	    skk-context-set-candidate-op-count!, skk-context-rk-context,
	    skk-context-set-rk-context!, skk-context-nth,
	    skk-context-set-nth!, skk-context-okuri, skk-context-set-okuri!,
	    skk-context-okuri-head, skk-context-set-okuri-head!,
	    skk-context-set-head!, skk-context-head, skk-context-kana-mode,
	    skk-context-set-kana-mode!, skk-context-state,
	    skk-context-set-state!): Replace with define-record
	  - (skk-context-new-internal): New alias of skk-context-new that
	    implicitly defined by define-record
	  - (skk-context-new): Replace value initialization with
	    skk-context-new-internal
	* scm/skk-editor.scm
	  - (skk-editor-context, skk-editor-set-context!, skk-editor-id,
	    skk-editor-set-id!, skk-editor-left-string,
	    skk-editor-set-left-string!, skk-editor-right-string,
	    skk-editor-set-right-string!): Replace with define-record
	  - (skk-editor-new-internal): New alias of skk-editor-new that
	    implicitly defined by define-record
	  - (skk-editor-new): Replace value initialization with skk-editor-new-internal
	
	* scm/prime.scm
	  - (prime-context-set-register-line!,
	    prime-context-set-preedit-line!, prime-context-last-word,
	    prime-context-set-last-word!, prime-context-mode,
	    prime-context-set-mode!, prime-context-candidates,
	    prime-context-set-candidates!, prime-context-nth,
	    prime-context-set-nth!, prime-context-set-learning-word!,
	    prime-context-learning-word, prime-context-state,
	    prime-context-set-state!): Replace with define-record
	  - (prime-context-new-internal): New alias of prime-context-new
	    that implicitly defined by define-record
	  - (prime-context-new): Replace value initialization with
	    prime-context-new-internal
	  - (prime-context-history-set!): Rewrite the implementation using
	    prime-context-set-history!
	  - (prime-context-history-get): Replace the implementation with
	    prime-context-history
	  - (prime-context-get-register-line): Replace the implementation with
	    prime-context-register-line
	  - (prime-context-get-preedit-line): Replace the implementation with
	    prime-context-preedit-line
	  - (prime-mode): Replace magic numbers with symbolic variable
	
	* scm/m17nlib.scm
	  - (m17nlib-context-id, m17nlib-context-set-id!,
	    m17nlib-context-showing-candidate,
	    m17nlib-context-set-showing-candidate!): Replace with define-record
	  - (m17nlib-context-new-internal): New alias of m17nlib-context-new
	    that implicitly defined by define-record
	  - (m17nlib-context-new): Replace value initialization with
	    m17nlib-context-new-internal
	
	* scm/tutcode.scm
	  - (tutcode-context-on?): Replace with alias of tutcode-context-on
	  - (tutcode-context-katakana-mode?): Replace with alias of
	    tutcode-context-katakana-mode
	  - (tutcode-context-rk-context, tutcode-context-set-rk-context!,
	    tutcode-context-set-on!, tutcode-context-set-katakana-mode!):
	    Replace with define-record
	  - (tutcode-context-new-internal): New alias of tutcode-context-new
	    that implicitly defined by define-record
	  - (tutcode-context-new): Replace value initialization with
	    tutcode-context-new-internal
	
	* scm/spellcheck.scm
	  - (spell-context-set-immediate-commit!, spell-context-last-word,
	    spell-context-set-last-word!, spell-context-mode,
	    spell-context-set-mode!, spell-context-left-string,
	    spell-context-set-left-string!, spell-context-right-string,
	    spell-context-set-right-string!, spell-context-candidates,
	    spell-context-set-candidates!, spell-context-candidate-window,
	    spell-context-set-candidate-window!,
	    spell-context-candidate-op-count,
	    spell-context-set-candidate-op-count!, spell-context-rk-context,
	    spell-context-set-rk-context!, spell-context-nth,
	    spell-context-set-nth!, spell-context-tail,
	    spell-context-set-tail!, spell-context-set-head!,
	    spell-context-head, spell-context-kana-mode,
	    spell-context-set-kana-mode!, spell-context-state,
	    spell-context-set-state!): Replace with define-record
	  - (spell-context-new-internal): New alias of spell-context-new that
	    implicitly defined by define-record
	  - (spell-context-new): Replace value initialization with
	    spell-context-new-internal
	
	* scm/hk.scm
	  - (hk-context-table-id, hk-context-set-table-id!,
	    hk-left-string-list, hk-set-left-string-list!,
	    hk-context-right-string-list, hk-context-set-right-string-list!):
	    Replace with define-record
	  - (hk-context-new-internal): New alias of hk-context-new that
	    implicitly defined by define-record
	  - (hk-context-new): Replace value initialization with
	    hk-context-new-internal
	  - (hk-left-string-append, hk-get-left-string, hk-get-right-string):
	    Replace dangerous numeric access to hk-context with symbolic
	    accessors
	
2004-09-19 kzk <mover@hct.zaq.ne.jp>
	
	* qt/quiminputcontext/src
	  - update label when index is set
	
2004-09-19 kzk <mover@hct.zaq.ne.jp>
	
	* qt/quiminutcontext/src
	  - add uim project's copyright
	  - enable "commit_string" helper message
	
2004-09-19 kzk <mover@hct.zaq.ne.jp>
	
	* qt/quiminputcontext/src/candidatewindow.cpp
	  - fix prime's infinite loop bug reported by UTUMI-san.
	    thank you! :-)
	
2004-09-19 Masanari Yamamoto <h013177b@ice.nuie.nagoya-u.ac.jp>
	
	* fep/callback.c (shift_page_cb): bugfix shift page doesn't work
	
	* fep/{draw.c,escseq.c,uim-fep.c}: refactoring
	
2004-09-19 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* uim/uim-helper.h
	  - (uim_helpler_fd_writable): Rename to uim_helper_fd_writable to fix
	    a typo
	  - (uim_helper_fd_writable): Renamed from uim_helpler_fd_writable to
	    fix a typo
	* uim/uim-helper.c
	  - (uim_helpler_fd_readable): Rename to uim_helper_fd_readable to fix
	    a typo
	  - (uim_helper_fd_readable): Renamed from uim_helpler_fd_readable to
	    fix a typo
	  - (uim_helpler_fd_writable): Rename to uim_helper_fd_writable to fix
	    a typo
	  - (uim_helper_fd_writable): Renamed from uim_helpler_fd_writable to
	    fix a typo
	* uim/uim-helper-server.c
	  - (parse_content): Fix a function name uim_helpler_fd_writable()
	    with uim_helper_fd_writable()
	
2004-09-18 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* helper/Makefile.am:
	  - Added dummy install-exec-local-applet & install-exec-local-gtk2
	
	
2004-09-18 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* scm/skk.scm : Support next-page-key and prev-page-key.
	
2004-09-17 kzk <mover@hct.zaq.ne.jp>
	
	* doc/HELPER-PROTOCOL
	  - add "commit_string" message
	
2004-09-17 kzk <mover@hct.zaq.ne.jp>
	
	* gtk/gtk-im-uim.c
	  - enable "commit_string" message
	    Now input-pad-ja works well.
	
2004-09-17 kzk <mover@hct.zaq.ne.jp>
	
	* helper/input-pad
	  - rename uim-input-pad --> uim-input-pad-ja
	  - rename input-pad.c --> input-pad-ja.c
	  - delete language selector list (seems ugly way)
	
	
2004-09-17 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* helper/helper-candwin-gtk.c : Make candidate window shrinkable
	  by using GTK_TREE_VIEW_COLUMN_AUTOSIZE.
	
2004-09-17 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* test-ext.scm:
	 - Fixed test case. Thanks to Jun Inoue.
	
2004-09-17 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* configure.ac:
	 - Fixed broken localedir setting.
	
2004-09-17 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* japanese-azik.scm:
	 - Added some rules.
	   Thanks to OHASHI Hideya    ohashi <at> kinkei co jp
	
2004-09-16 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/convdisp.cpp : Add dirty workaround for *over-the-spot*
	  style of flashplayer plugin for Linux (version 7.0.25.0).  This
	  hack ensures preedit area shown within the player's window.
	
2004-09-16 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* japanese-azik.scm: Rule format was wrong.
	  "." is wrong, " " is OK.
	
	
2004-09-15 Takuro Ashie <ashie@homa.ne.jp>
	
	* toolbar-standalone-gtk.c: Never expand button size.
	  - (size_request_cb): New callback function. Force set window size to
	    requested size.
	  - (main): Set above callback function for the toolbar window.
	
2004-09-15 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	* uim-util.h: some typo fixes
	
2004-09-14 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	*anthy.scm (anthy-proc-input-state-with-preedit): some style fix related to 'if form
	
2004-09-14 kzk <mover@hct.zaq.ne.jp>
	
	* doc/HELPER-PROTOCOL
	  - add five new commands around im-switcher
	
	
2004-09-14 kzk <mover@hct.zaq.ne.jp>
	
	* This commit is Qt4 version of r1206
	
2004-09-14 kzk <mover@hct.zaq.ne.jp>
	
	* This commit enables "im_change" and "im_list_get"from helper.
	  and decide "uim" as default locale im
	
	* src/plugin.cpp
	  - (create): regard "uim" key as locale default im
	  - (createImList): append "uim" key
	  - (createLanguageList): append language for "uim" key
	
	* src/quiminputcontext.h
	  - add short_desc member to struct UIMInfo
	
	* src/quiminputcontext.cpp
	  - add QPtrList<QUimInputContext> contextList
	
	* src/qhelpermanager.h
	  - (parseHelperStrImChange): new function
	  - (sendImList): new function
	
	* src/qhelpermanager.cpp
	  - enable "uim_list_get" message
	  - enable "im_change" message
	  - (parseHelperStrImChange): new function
	  - (sendImList): new function
	
2004-09-13 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* configure.ac: Used AC_DEFINE_UNQUOTED instead of AC_DEFINE.
	
2004-09-13 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* fep/: Added ignore propset.
	
2004-09-13 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* Makefile.am: a line EXTRA_DIST moved.
	
2004-09-13 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* Added ignore propset.
	
2004-09-13 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* uim/uim.c:
	 -(uim_get_default_im_name): Added a feature to get default input method
	   name from scheme world.
	 -(uim_check_im_exist): New function.
	
2004-09-13 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* gtk-im-uim.c:
	 -(im_uim_send_im_list): call uim_get_language_name_from_locale to
	   get long language name.
	
2004-09-13 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* iso-639-1.def: New file including ISO 639-1 name <-> language name 
	   converting talble.
	   
	* uim-util.c:
	 -(uim_get_language_name_from_locale): New function.
	
2004-09-13 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* gtk-im-uim.c: Reverted some code to rev1194, because switcher doesn't
	  have enough quality now. But I'll remove this code until 0.4.4.
	 -(im_module_list): list modules both of "uim" and "uim-??".
	
2004-09-12 Takuro Ashie <ashie@homa.ne.jp>
	
	* helper/im-switcher-gtk.c: Fixed some compile time warnings.
	
2004-09-12 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* uim/uim.c: Removed a line "#include languages.h" because this file doesn't exist.
	
2004-09-12 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* gtk/gtk-im-uim.c:
	 -(im_uim_send_im_list): New function.
	 -(im_uim_parse_helper_str_im_change): New function.
	 -(im_module_list): Changed to list one IM "uim" only.
	 !!!!Note, you MUST call gtk-query-immodules-2.0!!!!
	
	
2004-09-12 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* im-switcher-gtk.c:
	 -(get_selected_im_name): New function.
	 -(send_message_im_change): New function.
	 -(change_this_widget_only): Changed to call send_message_im_change.
	 -(change_whole_desktop): Implemented. 
	 -(change_this_application_only): Implemented.
	
2004-09-12 Takuro Ashie <ashie@homa.ne.jp>
	
	* toolbar-common-gtk.c
	  - (prop_button_released): Return FALSE on func end to propagate the
	    button_release event to button widget.
	
2004-09-12 Takuro Ashie <ashie@homa.ne.jp>
	
	* helper/toolbar-common-gtk.c:
	 - (helper_applet_prop_list_update)
	 - (uim_helper_toolbar_new):
	   Set button relief as GTK_RELIEF_NONE.
	
	* helper/toolbar-standalone-gtk.c
	 - (main): Added shadow for the window edge.
	
2004-09-12 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* uim/context.h
	 -(REQUEST_SURROUNDING_CB): macro -> enum
	 -(DELETE_SURROUNDING_CB):  macro -> enum
	
2004-09-12 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* uim/uim.c:
	 -(uim_change_input_method_engine): New API.
	 -(uim_get_im_short_desc):          New API.
	 -(uim_get_default_im_name):        New API.
	   
	* uim/uim-func.c
	 -(im_register_im): An argument added. short_desc is a description
	   of registered input method.
	
	* scm/im.scm
	 -(register-im): An argument added. short_desc is a description.
	   All caller changed.
	
	
2004-09-12 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* im-switcher-gtk.c:
	 -(change_this_widget_only): Fixed a memory leak.
	
2004-09-12 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	* context.h, uim-func.c: add new callback functions.
	 - REQUEST_SURROUNDING_CB, DELETE_SURROUNDING_CB
	
2004-09-12 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	* uim/uim.c, uim.h, context.h: 1st step to implement surrounding text.
	 - uim_set_surrounding_text_cb: new API
	 - uim_set_surrounding_text: new API
	
2004-09-12 Takuro Ashie <ashie@homa.ne.jp>
	
	* helper/toolbar-standalone-gtk.c: Handle window moving more smartly.
	  - (button_press_event_cb): Renamed from button_press_event.
	  - (helper_win_set_position):
	    New function. Ensure to move whole window into screen.
	  - (motion_notify_event_cb): New callback function.
	  - (size_allocate_cb): New callback function.
	  - (button_release_event_cb): New callback function.
	  - (main): Set default window position to right bottom corner of
	    the screen.
	
2004-09-12 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* im-switcher-gtk.c
	 -(change_this_widget_only): Second argument of gtk_tree_selection_get_selected
	   is a pointer of pointer of GtkTreeModel.
	
2004-09-12 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* helper/: Renamed silly filename typo. toobar-standalone-gtk.c -> too*l*bar-standalone-gtk.c
	
2004-09-12 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* configure.ac: Added AC_DEFINE(GNOMELOCALEDIR)
	
2004-09-12 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* helper/: Renamed some files for consistency.
	 helper-toolbar-gtk.c ->         toolbar-standalone-gtk.c
	 helper-toolbar-gtk-systray.c -> toolbar-systray-gtk.c
	 helper-applet.c ->              toolbar-applet-gnome.c
	 helper-toolbar-common-gtk.c ->  toolbar-common-gtk.c
	 
	
2004-09-12 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* helper-toolbar-common-gtk.c:
	 -(helper_applet_prop_list_update): Used gtk_widget_set_size_request
	    to button widgets.
	
2004-09-12 Takuro Ashie <ashie@homa.ne.jp>
	
	* configure.ac: Show some configture results.
	
2004-09-12 Takuro Ashie <ashie@homa.ne.jp>
	
	* helper/helper-applet.c
	  - (PANEL_APPLET_BONOBO_FACTORY): Removed needless semicolon.
	
2004-09-12 Takuro Ashie <ashie@homa.ne.jp>
	
	* helper/helper-toolbar-gtk.c: Added a handle.
	  - (hadle_expose_event): New function for drawing handle.
	  - (main): Added a drawing area for the handle.
	
2004-09-12 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	*im-switcher-gtk.c:
	 -(parse_helper_str_im_list): Reduced unneeded treeview updating.
	    Fixed memory leaking.
	
	
2004-09-12 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* im-switcher-gtk.c: New function.
	 -(reload_im_list): New function.
	 -(parse_helper_str): New function.
	 -(parse_helper_str_im_list): New function.
	 -(change_this_widget_only): New function.
	 -(change_whole_desktop): New function.
	 -(change_this_application_only): New function.
	 -(create_switcher_treeview): Renamed from switcher_treeview_create
	    for consistency.
	
2004-09-11 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/connection.cpp : Change TRANSPORT_MAX from 100 to 20 in
	  order to make Emacs's XIM happy.
	(XConnection::writeProc) : Use pending Tx queues to enable
	  synchronous XIM Protocol event flow.
	
	* xim/xim.h (class Connection) : Adding new protected functions;
	  setSyncFlag, unsetSyncFlag, hasSyncFlag,
	  setPreeditStartSyncFlag, unsetPreeditStartSyncFlag, and
	  hasPreeditStartSyncFlag.  Adding new protected lists;
	  mPendingTxQ, and mPPendingTxQ.  Adding new private function
	  xim_sync_reply.  Adding new private variables; mSyncFlag, and
	  mPreeditStartSyncFlag.
	
	* xim/ximtrans.cpp (Connection::OnRecv) : Handle XIM_SYNC_REPLY
	  and XIM_PREEDIT_START_REPLY upon receive.
	(Connection::setSyncFlag) : Implement.
	(Connection::unsetSyncFlag) : Ditto.
	(Connection::hasSyncFlag) : Ditto.
	(Connection::setPreeditStartSyncFlag) : Ditto.
	(Connection::unsetPreeditStartSyncFlag) : Ditto.
	(Connection::hasPreeditStartSyncFlag) : Ditto.
	(Connection::xim_open) : Change synchronous-event-mask so that XIM
	  client not sending synchronous flag to XIM server.
	(Connection::xim_sync_reply) : Implement.  Unset the synchronous
	  flag and then send pending Tx packets.
	(Connection::xim_preedit_start_reply) : Ditto, but this is not
	  enabled for the moment since XIM_PREEDIT_START_REPLY is not sent
	  synchronously by XIM library on some circumstances.
	
	* xim/ximic.cpp (XimIC::OnKeyEvent) : Push XIM_COMMIT event when
	  receiving UPDATE_MODE by InputContext::pushKey().
	(XimIC::send_key_event) : Use push_packet.
	
	* xim/ximim.cpp (XimIM_impl::forward_event) : No need to send
	  XIM_SYNC_REPLY because of change of synchronous-event-mask.
	
	* xim/convdisp.cpp (ConvdispOs::update_preedit) : Use
	  push_passive_packet() again.
	
	* xim/ximserver.h : Indentation fixes.
	
2004-09-11 kzk <mover@hct.zaq.ne.jp>
	
	* qt/quiminputcontextplugin/README
	* qt/quiminputcontextplugin/INSTALL
	  - documentation update
	
2004-09-11 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* test/run-test.scm:
	 -(add-load-path): Added "." to the load path.
	* test/test-ext.scm: Added test name.
	
2004-09-11 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* input-pad.c: Added language selector.
	  - (language_selector_create): New function.
	  - (input_table_create): New function.
	  - (input_pad_create): Renamed from inputpad_create for consistency.
	
2004-09-10 kzk <mover@hct.zaq.ne.jp>
	
	* qt/quiminputcontextplugin
	  - commit autotoolized version of UimQt
	
2004-09-10 kzk <mover@hct.zaq.ne.jp>
	
	* qt/quiminputcontextpluing
	  - temporary delete UimQt
	
2004-09-10 Takuro Ashie <ashie@homa.ne.jp>
	
	* configure.ac: Fixed typo.
	
2004-09-09 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	*uim/siod.h, uim/slib.c: implement `case'. Thanks to Jun Inoue. 
	*test/test-ext.scm: new file. test `case'
	
2004-09-09 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	*helper/Makefile.am: add -f flag to rm. Thanks to Jun Inoue.
	
2004-09-09 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	* uim/Makefile.am: do not include autogenerated config.h in EXTRA_DIST
	
2004-09-09 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/connection.cpp (writeProc) : Finally fixes the occasional
	  crash of uim-xim.
	* xim/xdispatch.h (class WindowIf) : Indentation fixes.
	
2004-09-09 kzk <mover@hct.zaq.ne.jp>
	
	* This commit aims to follow the API change of
	  Qt-immodule r123.
	
	* quiminputcontext.h, quiminputcontext.cpp
	  - change "virtual QCString identifierName()" to "virtual QString identifierName()"
	  - change "virtual QCString language()" to "virtual QString language()"
	  - now (m_imname) is QString
	  - now (m_lang) is QString
	
2004-09-09 kzk <mover@hct.zaq.ne.jp>
	
	* helper/input-pad.c
	  - use tab widget (GtkNotebook)
	  - add hiragana & katakana table
	  - (buttontable_create): add empty str check
	
2004-09-09 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* input-pad.c:
	 -(buttontable_create): Used GtkTable instead of GtkHButtonBox.
	
2004-09-08 kzk <mover@hct.zaq.ne.jp>
	
	* helper/input-pad.c
	  - initial commit of input-pad
	
2004-09-08 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* scm/skk.scm :	(skk-append-okuri-string) : New function to allow
	  (("A" "a") ("X" "x") ..) style result of rk-push-key! 
	(skk-proc-state-direct) : Allow (("A" "a") ("X" "x") ..) style
	  result of rk-push-key! 
	(skk-proc-state-kanji) : Ditto.
	(skk-proc-state-okuri) : Ditto.
	
2004-09-08 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	* canna.scm: allow (("A" "a") ("X" "x") ..) style result of rk-push-key!
	
2004-09-08 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* scm/skk.scm (skk-proc-state-direct-no-preedit) : Change to
	  handle symbol? key lastly.  Thanks to Masaki Yatsu
	  <yatsu@yatsu.info>.
	(skk-proc-state-direct) : Ditto.
	
2004-09-08 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* xim/Makefile.am: LOCALEDIR is now defined at configure.ac, so removed from Makefile.am.
	
2004-09-07 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* helper/im-switcher-gtk.c: Added mock up functions.
	 - (load_configration): New function.
	 - (save_configration): New function.
	
2004-09-07 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	*anthy.scm(anthy-proc-input-state-with-preedit): allow (("A" "a") ("X" "x") ..) style result of rk-push-key!
	
2004-09-07 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* scm/rk.scm (rk-proc-tail) : Comment out the code using
	  rk-merge-seqs for the moment.
	* scm/skk.scm : Revert r1151 changes.
	
2004-09-07 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	* scm/rk.scm: add comments, fix non EUC-JP char
	
2004-09-07 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	* uim/skk-dic.c: check if skk_dic is null or not.
	
2004-09-07 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* scm/rk.scm (rk-merge-seqs) : New function to combine two lists.
	(rk-proc-tail) : Use rk-merge-seqs to get "n1" sequence as "ん1".
	  Thanks to Jun Inoue <jun0@nerdshack.com>.
	* scm/skk.scm (skk-proc-state-direct) : Remove hackish code to get
	  "n1" as "ん1".
	(skk-proc-state-kanji) : Ditto.
	
2004-09-07 kzk <mover@hct.zaq.ne.jp>
	
	* scm/canna.scm
	  - this commit relates to r1140 (Extending HELPER-PROTOOL
	    and add radio button to the helper menu).
	
	
2004-09-07 kzk <mover@hct.zaq.ne.jp>
	
	* helper/Makefile.am: fix typo
	
2004-09-07 kzk <mover@hct.zaq.ne.jp>
	
	* scm/skk.scm
	  - this commit relates to r1140 (Extending HELPER-PROTOOL
	    and add radio button to the helper menu).
	
2004-09-07 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* im-switcher-gtk.c: New file. Mock up for input method switcher.
	
2004-09-07 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* uim-helper-candwin-gtk -> uim-candwin-gtk (renamed.)
	* uim-helper-toolbar-gtk -> uim-toolbar-gtk (renamed.)
	* uim-helper-toolbar-gtk-systray -> uim-toolbar-gtk-systray (renamed.)
	
	Old name such as uim-helper-candwin-gtk will be replaced with symbolic
	link. But I'm not confident in my install-exec-local target. Please test
	it.
	
	
2004-09-07 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* configure.ac: Added AC_MSG_RESULT.
	
2004-09-06 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* uim/intl.c: new file to support gettext.
	* uim/intl.h: new file to support gettext.
	Thanks to Kouhei Sutou <kou@cozmixng.org>
	
2004-09-06 kzk <mover@hct.zaq.ne.jp>
	
	* UimQt: added "thread" parameter to qmake's project file
	
2004-09-05 kzk <mover@hct.zaq.ne.jp>
	
	* scm/skk.scm: fixed typo
	
2004-09-05 kzk <mover@hct.zaq.ne.jp>
	
	* helper/helper-toolbar-common-gtk.c
	  - indentation fix
	  - draw radio button only when state data is available
	
2004-09-05 kzk <mover@hct.zaq.ne.jp>
	
	* This commit add radio button to helper-toolbar for
	  indicating the current state of IM. To achieve this,
	  I extend the HELPER-PROTOCOL. Please look at the change
	  of the document. This function is now for only generic-im
	  and anthy.
	
	* helper/helper-toolbar-common-gtk.c
	  - use GTK_CHECK_MENU_ITEM and draw_as_radio
	
	* generic.scm, anthy.scm
	  - update prop-list at the appropriate timing
	  - add "*" to message
	
2004-09-05 kzk <mover@hct.zaq.ne.jp>
	
	* scm/generic.scm
	  - fix wrong helper message of (generic-update-prop-list)
	
2004-09-04 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	*  slib.c: move backtrace link to leval function.
	
2004-09-04 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* Release 0.4.3
	
2004-09-04 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* AUTHORS, gnuify-changelog.pl: Added new committer's names!
	
2004-09-04 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* canna.scm: Update property label in canna-mode-handler.
	
2004-09-04 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* generic.scm: Update property label in generic-mode-handler.
	
2004-09-04 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* configure.ac : Removed a commented line.
	
2004-09-04 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* anthy.scm: update label property in anthy-mode-handler.
	
2004-09-04 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* skk.scm: update label property in skk-mode-handler.
	
2004-09-04 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* prime.scm: Updated with Hiroyuki Komatsu's new version.
	 - Fixed some bugs related on tcode.
	 - Fixed a bug misaligned candidate window.
	 - Default setting changed. prime-pseude-mode-cursor? #t -> #f.
	
2004-09-04 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* tutcode.scm: Update label propertyin mode-handler.
	
2004-09-02 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/convdisp.cpp (ConvdispOs::update_preedit) : use
	  push_packet() instead of push_passive_packet() to prevent
	  getting XIM_ERROR from some clients.
	
2004-09-02 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/convdisp.cpp (ConvdispOs::move_candwin) : Set candidate
	  window near the spotlocation in case ICA_SpotLocation is
	  available.
	(ConvdispRw::move_candwin) : Ditto.
	
2004-09-02 Takuro Ashie <ashie@homa.ne.jp>
	
	* japanese.scm:
	  - (ja-raw-string-to-valid-roma): Removed needless code.
	
2004-09-02 Takuro Ashie <ashie@homa.ne.jp>
	
	* Added kana->roma conversion on F9 and F10 pressing on uim-anthy.
	  But at this time, this feature does not consider about ja-kana-rule
	  and ja-azik-rule yet. At least, it does not work well with
	  ja-kana-rule. I'll fix it later.
	
	* anthy.scm: Modified to store raw key string for kana->roma conversion.
	  - (anthy-context-left-raw-string): New procedure.
	  - (anthy-context-set-left-raw-string!): New procedure.
	  - (anthy-context-right-raw-string): New procedure.
	  - (anthy-context-set-right-raw-string!): New procedure.
	  - (anthy-context-new): Added two new entries for buffering raw key
	    string to anthy context.
	  - (anthy-make-raw-string): New procedure.
	  - (anthy-make-whole-raw-string): New procedure.
	    Make valid whole roma-ji string from bufferd key string.
	  - (anthy-flush): Clear raw string.
	  - (anthy-proc-input-state-no-preedit): Added raw-string handling
	    functions.
	  - (anthy-proc-input-state-with-preedit): Added raw-string handling
	    functions and some comments.
	
	* japanese.scm:
	  - (ja-rk-rule): Added ("l" "t" "u") and ("l" "t" "s" "u") entry.
	  - (ja-vowel-table): New table. For detecting vowel in a string.
	  - (ja-consonant-table): New table. For detecting consonant in a string.
	  - (ja-default-small-tsu-roma): New variable.
	    Added for auto kana->roma conversion.
	  - (ja-vowel?): New procedure.
	    Detect whether the character is vowel or not.
	  - (ja-consonant?): New procedure.
	    Detect whether the character is consonant or not
	  - (ja-string-list-to-wide-alphabet): New procedure.
	    Convert characters in string-list to multi-byte alphabet.
	  - (ja-raw-string-to-valid-roma): New procedure.
	    Fix a broken roma-ji string to valid one.
	  - (ja-raw-string-list-to-valid-roma): New procedure.
	    Fix a broken roma-ji string list to valid one.
	  - Added some comments.
	
2004-09-01 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* pyload.scm:
	 -(pinyin-big5): indicate locale "zh".
	
2004-09-01 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	* uim-helper.c, uim-helper-server.c, uim-helper.h, uim-table.c: fix warnings
	
2004-08-31 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* scm/skk.scm (skk-proc-state-direct-no-preedit) : Move
	  key handlings without preedit state from skk-proc-state-direct.
	  Remove unnecessary skk-update-mode.
	
	(skk-proc-state-direct) : Move key handlings without preedit state
	  to skk-proc-state-direct-no-preedit.  Add skk-wide-latin-key?,
	  skk-latin-key?, skk-latin-conv-key?, skk-kanji-mode-key?,
	  skk-hankaku-kana-key?, and skk-kana-toggle-key? key handlings
	  according to ddskk's behavior.  Remove redundant code.  Fix a
	  bug that preedit was not updated correctly with commit-raw when
	  key is symbol?.  Handle "n1" sequence properly.
	
	(skk-proc-state-kanji) : Add some comments.  Remove unnecessary
	  skk-update-mode.  Handle "n1" sequence properly.
	
2004-08-28 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	* uim/uim-ipc.c
	 - rename FILE * type _handler to _fp
	 - close fp in case of feof
	
2004-08-27 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* scm/skk.scm (skk-proc-state-kanji) : Add two lines for
	skk-kanji-mode-key? condition, which was missed to commit in
	r1118.
	
2004-08-27 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* scm/skk.scm (skk-special-midashi-key?) : New key definition for
	  supporting Setsubi-ji and Settou-ji conversion.  The name of
	  definition is taken from "skk-special-midashi-char-list" in
	  original skk.
	(skk-proc-state-kanji) : Change some behavior according to ddskk
	  (With skk-begin-conv-key?, don't do kanji conversion unless
	  skk-context-head have some strings, otherwise just do
	  flush. With skk-kanji-mode-key?, commit string and create a new
	  conversion state.  Add alphabet key checking for checking
	  shift-key-mask for okuri state. With skk-kana-toggle-key?, don't
	  flush the context unless skk-contex-head have some strings). Add
	  Settou-ji conversion with skk-special-midashi-key?.
	(skk-proc-state-converting) : Add Setsubi-ji conversion.
	
2004-08-26 kzk <mover@hct.zaq.ne.jp>
	
	* quiminputcontextplugin: disable debug and warning as default
	
2004-08-26 kzk <mover@hct.zaq.ne.jp>
	
	* doc/HELPER-PROTOCOL
	  - fix trivial mistake
	  - add the rule around IMEngine-switching
	
2004-08-25 Masanari Yamamoto <h013177b@ice.nuie.nagoya-u.ac.jp>
	
	* fep/ new option -o: on the spot style
	
2004-08-25 kzk <mover@hct.zaq.ne.jp>
	
	* quiminputcontextplugin-qt4/plugin.h
	* quiminputcontextplugin-qt4/plugin.cpp
	  - rename QSimpleInputContextPlugin to UimInputContextPlugin
	    (the pained remains of porting...)
	
2004-08-25 kzk <mover@hct.zaq.ne.jp>
	
	* This commit aims to add temporal candidate window.
	  Qt4-tp1 seems not provide the widget for candwin,
	  so I decide not to implement candwin until qt4-tp2 release.
	  All the codes except GUI part is moved from uim-qt3.
	
	* quiminputcontextplugin-qt4/quiminputcontextplugin.pro
	  - add candidatewindow.h and candidatewindow.cpp
	* quiminputcontextplugin-qt4/quiminputcontext.h
	  - restore candwin around code
	* quiminputcontextplugin-qt4/quiminputcontext.cpp
	  - restore candwin around code
	* quiminputcontextplugin-qt4/candidatewindow.h
	  - added
	* quiminputcontextplugin-qt4/candidatewindow.cpp
	  - added
	* quiminputcontextplugin-qt4/qhelpermanager.cpp
	  - small loop refactoring
	
	* quiminputcontextplugin-qt4/edittest/main.cpp
	  - remove copyright
	
2004-08-25 kzk <mover@hct.zaq.ne.jp>
	
	* quiminputcontextplugin/candidatewindow.cpp
	  - more valid candidate data's clear
	
2004-08-24 kzk <mover@hct.zaq.ne.jp>
	
	* This commit is small refactoring. The contents of uim-qt isn't
	  changed.
	
	* quiminputcontextplugin/quiminputcontext.cpp
	  - remove unnecessary #include
	  - move the codes of deactivating candwin to candidatewindow.cpp
	
	* quiminputcontextplugin/candidatewindow.cpp
	  - remove unnecessary #include
	  - implement deactivateCandwin()
	
	* quiminputcontextplugin/candidatewindow.h
	  - remove unnecessary #include
	  - remove unnecessary class
	  - remove (setCandidateIndex)
	  - declare (slotCandidateSelected) as protected
	
2004-08-24 kzk <mover@hct.zaq.ne.jp>
	
	* qt/qtkde-helper/src/candwin/uim-helper-candwin-qt.h
	* qt/qtkde-helper/src/candwin/uim-helper-candwin-qt.h
	  - move codes from qt-uim's candidate window
	
	  - (FOUNDED BUG): the position of candwin is invalid.
	    Possibly my misunderstanding of mapToGlobal(),
	    mapFromGlobal(), etc.
	
2004-08-24 kzk <mover@hct.zaq.ne.jp>
	
	* qt/quiminputcontextplugin-qt4/plugin.cpp
	* qt/quiminputcontextplugin-qt4/quiminputcontext.cpp
	* qt/quiminputcontextplugin-qt4/qhelpermanager.h
	* qt/quiminputcontextplugin-qt4/plugin.h
	* qt/quiminputcontextplugin-qt4/edittest
	* qt/quiminputcontextplugin-qt4/edittest/edittest.pro
	* qt/quiminputcontextplugin-qt4/edittest/main.cpp
	* qt/quiminputcontextplugin-qt4/edittest/README
	* qt/quiminputcontextplugin-qt4/quiminputcontext.h
	* qt/quiminputcontextplugin-qt4/quiminputcontext_with_slave.cpp
	* qt/quiminputcontextplugin-qt4/install
	* qt/quiminputcontextplugin-qt4/README.ja
	* qt/quiminputcontextplugin-qt4/COPYING
	* qt/quiminputcontextplugin-qt4/quiminputcontext_with_slave.h
	* qt/quiminputcontextplugin-qt4/qhelpermanager.cpp
	* qt/quiminputcontextplugin-qt4/quiminputcontextplugin.pro
	* qt/quiminputcontextplugin-qt4/README.en
	  - this is the initial commit of uim-qt for 'qt4' with Yamaken's
	    qt-x11-immodule-qt4.0.0-tp1-20040822.diff.gz.
	    Because of the big API change between qt3 and qt4, we cannot
	    port CandidateWindow directly. So this commit doesn't include
	    CandidateWindow. Now I'm working on it.
	
	  - edittest is the program for test inputting
	
	  - (FOUNDED BUG): cannot activate IM on QTextEdit
	
2004-08-23 kzk <mover@hct.zaq.ne.jp>
	
	* scm/skk.scm
	  - no need to commit string when uim_set_candidate_index is called.
	    (NOTE) this commit is possibly unsafe, but fixes the problem of
	    using uim-skk via uim-qt. I confirm this change doesn't affect
	    the behavior of uim-gtk.
	
2004-08-21 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	* uim/m17nlib.c (init_m17nlib): add null check of imlist
	
2004-08-21 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	* uim/context.h: add declaration of uim_init_m17nlib(), uim_quit_m17nlib()
	
2004-08-21 kzk <mover@hct.zaq.ne.jp>
	
	* quiminputcontextplugin/install
	  - the name of IM related plugin's dir was changed
	
2004-08-21 Masanari Yamamoto <h013177b@ice.nuie.nagoya-u.ac.jp>
	
	* fep/uim-fep.c (set_signal_handler):
	  Add initialization of sigaction#sa_flags.
	
2004-08-21 Masanari Yamamoto <h013177b@ice.nuie.nagoya-u.ac.jp>
	
	* fep/escseq.c (set_attr): Fix the bug enbuged at 1102.
	
2004-08-21 Masanari Yamamoto <h013177b@ice.nuie.nagoya-u.ac.jp>
	
	* fep/str.c
	  - (width2byte, width2byte2): bug fix
	
	* fep/escseq.c
	  - (set_attr): bug fix
	
	* fep/draw.c
	  - (draw_statusline): Add NULL check.
	
2004-08-20 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/main.cpp (get_uim_info) : Add uim_release_context() after
	  getting uim engine information.  It seems that uim-xim didn't do
	  this from the very early version until now...
	
2004-08-19 kzk <mover@hct.zaq.ne.jp>
	
	* This commit aims to cut out the cost of recreating temporal uim_context
	
	* quiminputcontextplugin/ChangeLog
	  - obsolete
	
	* quiminputcontextplugin/quiminputcontext.h
	  - (createUimInfo): new function
	  - (UIMInfo): new struct
	
	* quiminputcontextplugin/quiminputcontext.cpp
	  - (uimInfo): new variable
	  - (createUimInfo): new function
	
	* quiminputcontextplugin/qhelpermanager.cpp
	  - use uimInfo instead of recreating temporal uim_context
	
2004-08-19 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/xim.h (class RxPacket) : Add destructor.
	(class XimIC) : Change the declaration of destructor as not virtual. 
	* xim/ximic.cpp (release_font_set) : Plug leak.
	* xim/ximpacket.cpp : Mark all the virtual functions as "virtual".
	(RxPacket_impl::~Rxpacket_impl) : Plug leak.
	* xim/ximim.cpp (class XimIM_impl) : Mark all the virtual
	  functions as "virtual".
	* xim/main.cpp (main) : Suppress warning.
	* xim/ximserver.cpp (InputContext::get_preedit_string) : Ditto.
	* xim/canddisp.h (class Canddisp) : Change the declaration of
	  destructor as not virtual.
	* xim/canddisp.cpp (canddisp_singleton) : Make char *command as
	  static to prevent calling candwin_command() every time.
	* xim/convdisp.h (class Convdisp) : Mark some functions as pure
	  virtual method.
	* xim/convdisp.cpp (class PeWin) : Mark virtual function as
	  "virtual".
	(class ConvdispOv) : Delete set_focus() and unset_focus(), and use
	  parent class's one.
	(class ConvdispOs) : Ditto.
	(class ConvdispRw) : Add move_candwin().
	(Convdisp::set_focus) : Move from child classes.
	(Convdisp::unset_focus) : Ditto.
	
2004-08-18 kzk <mover@hct.zaq.ne.jp>
	
	* This change aims to enable IM switching from helper toolbar
	
	* quiminputcontextplugin/quiminputcontext.h, quiminputcontext.cpp
	  - (changeUimContext) : new function
	  - (createUimContext) : rename from createUC
	
	* quiminputcontextplugin/qhelpermanager.cpp
	  - add codes to enable IM switching from helper toolbar
	
2004-08-17 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* qt/quiminputcontextplugin/quiminputcontext.cpp
	  - (updatePreedit) Revert a wrong change in r1093. It had caused
	    weird update about selection moving. We must always commit preedit
	    string although the new string is equivalent to old one. Consider
	    preedit attributes
	* qt/quiminputcontextplugin/ChangeLog
	  - Update. Is this file obsolete?
	
2004-08-17 kzk <mover@hct.zaq.ne.jp>
	
	* doc/00INDEX
	  - add HELPER-CANDWIN and HELPER-PROTOCOL
	
	* doc/HELPER-PROTOCOL: initial commit
	  (NOTE: when you create new helper protocol,
	   please add your rule to this file.)
	
2004-08-17 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* doc/XIM-SERVER : Change description about uim-xim according to
	  new feature.
	* README.ja : Ditto.
	
2004-08-17 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/locale.cpp (getLocale) : Constify.
	* xim/ximserver.cpp (XimServer::XimServer) : Constify.
	(XimServer::createContext) : Add context to ic_list.
	(XimServer::deleteContext) : New function.  Remove selected
	  context from ic_list.
	(XimServer::changeContext) : New function.  Change uim engine of
	  all context belonging to the XimServer with selected engine.
	(XimServer::setupConnection) : Conditionalize to setup @server=uim
	  for default uim engine.
	(XimServer::getIMName) : New function.
	(XimServer::getIMLang) : New function.
	(XimServer::set_im) : New function.
	(InputContext::InputContext) : Constify.  Change sequence of
	  initialization.
	(InputContext::~InputContext) : Delete context.
	(InputContext::createUimContext) : Constify.
	(InputContext::changeUimContext) : New function.
	(InputContext::update_prop_list) : Add uim engine selection property.
	(InputContext::update_prop_label) : Add uim engine selection property.
	* xim/main.cpp (version_name) : Constify.
	(usage) : Constify.  Add --list and --engine=ENGINE.
	(uim_info) : New list containing information about uim engines.
	(get_uim_info) : New function.
	(print_uim_info) : New function.
	(parse_args) : Add default uim engine selection feature with
	  --engine=ENGINE, and show available uim engines with --list.
	(helper_str_parse) : Change the uim context when reading
	  "prop_engine_".
	(main) : Setup default server @im=uim.
	* xim/ximserver.h : Constify.  Add some new prototype.
	
2004-08-15 kzk <mover@hct.zaq.ne.jp>
	
	* quiminputcontextplugin/candidatewindow.h, quiminputcontextplugin/candidatewindow.cpp
	  - (deactivateCandwin): new function
	  - (activateCandwin): renamed from activateCandidate
	
	* quiminputcontextplugin/quiminputcontext.cpp
	  - not send IMCompose event when new preedit and old preedit is same
	
	* quiminputcontextplugin/quiminputcontext.h
	  - avoid unnecessary object copying
	
2004-08-14 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* Follow new API of the immodule for Qt
	
	* qt/quiminputcontextplugin/quiminputcontext.h
	  - (filterEvent) Change the argument to const to follow the API change
	* qt/quiminputcontextplugin/quiminputcontext.cpp
	  - (filterEvent) Change the argument to const to follow the API change
	
2004-08-12 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* scm/skk.scm (skk-commit) : Delete annotation-removing code since
	  this has already been done in skk-prepare-commit-string.
	(skk-proc-state-direct) : Fix typo in comment.
	(skk-proc-state-converting) : Remove redundant code.
	
2004-08-12 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/ximim.cpp (XimIM_impl::forward_event) : Fix endian
	  conversion on xevent forwarding.  This fixes XIM behavior on gtk+2
	  text widget.
	
2004-08-10 Masahito Omote <omote@utyuuzin.net>
	
	* uim/prime.c(primer, primew): Initialize as NULL.
	
2004-08-10 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* fep/: Fixed a color related bug. Thanks to Masanari Yamamoto.
	
2004-08-10 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* gtk-im-uim.c:
	 -(focus_in):  Install snooper if not installed.
	 -(focus_out): Remove snooper if installed.
	
2004-08-10 kzk <mover@hct.zaq.ne.jp>
	
	* quiminputcontextplugin/plugin.cpp
	  - use QUimInputContextWithSlave instead of QUimInputContext
	* quiminputcontextplugin/quiminputcontext.cpp
	  - remove unnecessary #include
	  - event handling refactoring
	* quiminputcontextplugin/AUTHORS
	  - add Yamaken's name
	* quiminputcontextplugin/THANKS
	  - add pakager's name
	* quiminputcontextplugin/quiminputcontext_with_slave.[cpp,h]
	  - the class to deal with dead/multi key with using QSimpleInputContext
	* quiminputcontextplugin/quiminputcontextplugin.pro
	  - add two files
	
2004-08-04 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/ximic.cpp (XimIC::setFocus) : Don't update preedit, and only
	  update candidate window.
	(XimIC::reset_ic) : Implement sending uncommitted strings on
	  XIM_RESET_IC_REPLY. Clear input context after sending the
	  strings.
	* xim/ximserver.cpp (InputContext::get_preedit_string) : New
	  procedure.
	(InputContext::clear) : Implement, and change the type of return
	  value.
	(InputContext::candidate_deactivate) : Add condition check.
	* xim/convdisp.cpp (Convdisp::clear_preedit) : New procedure.
	(Convdisp::move_candwin) : Divided from update_preedit()
	(Convdisp::get_pe) : New procedure to get preedit strings
	* xim/Makefile.am : Remove AM_CPPFLAGS and add its content to
	  uim_xim_CPPFLAGS.
	* xim/ximserver.h : (InputContext) : Add get_preedit_string() as a
	  member.  Change the type of return value for clear().
	* xim/convdisp.h (Convdisp) : Add get_pe(), clear_preedit() and
	  move_candwin() as a member.
	
2004-08-04 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/connection.cpp : More indentation fixes. Hopefully this
	  would	be the last one.
	* xim/xim.h : Ditto
	* xim/ximtrans.cpp : Ditto
	* xim/main.cpp : Ditto
	* xim/ximpacket.cpp : Ditto
	* xim/xdispatch.h : Ditto
	* xim/ximic.cpp : Ditto
	* xim/convdisp.cpp : Ditto
	* xim/ximserver.h : Ditto
	
2004-08-04 Takuro Ashie <ashie@homa.ne.jp>
	
	* uim.pc.in:
	  - Added -L{libdir}. Thanks to Seiichi SATO <ssato@sh.rim.or.jp>.
	
2004-08-04 Takuro Ashie <ashie@homa.ne.jp>
	
	* uim/uim.c
	  - (uim_get_mode_name): Added range check for uc->modes.
	
2004-08-04 kzk <mover@hct.zaq.ne.jp>
	
	* qt/quiminputcontextplugin/candidatewindow.cpp
	  - revert the change of candidate window height handling
	
2004-08-03 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* Follow new API of the immodule for Qt
	
	* qt/quiminputcontextplugin/plugin.cpp
	  - (description): New function to follow new immodule API
	  - (displayName): Add language indication
	
2004-08-03 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* fep/: You can assign preedit fore/back ground color by -C option.
	        E.G. $uim-fep -C white:black -e jed 
	
	
2004-08-02 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* helper/helper-candwin-gtk.c (read_cb) : Add code which closes fd and
	exit program upon reading end-off-file.
	
2004-08-02 kzk <mover@hct.zaq.ne.jp>
	
	* developer's document: update comment of shift_page_cb
	
2004-08-02 kzk <mover@hct.zaq.ne.jp>
	
	* src/quiminputcontextplugin/candidatewindow
	  - avoid flicker when popup() is called
	  - more proper caluculation of candwin's height
	  - change column's resizing mode
	
2004-08-02 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/ximserver.cpp (InputContext::InputContext) : Set focused
	context while InputContext is constructed, since some clients
	(rxvt, kterm) don't call XIM_SET_IC_FOCUS initially.
	
2004-08-02 kzk <mover@hct.zaq.ne.jp>
	
	* quiminputcontext.cpp, qhelpermanager.cpp
	  - implement proper focusedInputContext handling
	    (this commit fixes helper messaging problem)
	* quiminputcontext.h
	  - delete unnecessary slot
	
2004-08-02 kzk <mover@hct.zaq.ne.jp>
	
	* qt/qtkde-helper
	  - delete unnecessary files around autotools
	  - add bootstrap script
	
2004-08-02 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/convdisp.cpp (ConvdispOv::update_preedit) : Move
	candidates window only when the context has focus.
	(ConvdispOs::update_preedit) : Ditto.
	
2004-08-02 kzk <mover@hct.zaq.ne.jp>
	
	* qt/quiminputcontextplugin
	  - implement shift_page_cb
	  - implement proper destructor of CandidateWindow
	  - some indentation fixes
	
2004-08-02 Takuro Ashie <ashie@homa.ne.jp>
	
	* scm/anthy.scm
	  - (anthy-update-prop-label): Fixed indent.
	
	* scm/canna.scm
	  - Enabled to switch input rule between "roma" and "kana".
	    Changes are almost same with anthy.
	  - Some minor bug fix.
	
2004-08-01 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* xim/ximic.cpp (XimIC::set_ic_attr) : Tidy up a bit.
	
	* xim/convdisp.cpp (ConvdispOs::update_preedit) : Make candidates
	window present at lower-left corner of client window when
	on-the-spot style conversion.
	
2004-08-01 kzk <mover@hct.zaq.ne.jp>
	
	* This commit is in accordance with Takuro's refactoring of uim-gtk
	
	* This will fix these problems
	  - label doesn't sync on mouse cliking.
	  - selection is gone on selecting empty row by mouse clicking.
	    (surplus items aren't added now)
	  - performance improvement
	
	* But adjustWindowSize() doesn't properly deal with list width
	
2004-08-01 Takuro Ashie <ashie@homa.ne.jp>
	
	* scm/anthy.scm
	  - (anthy-update-prop-label): Now helper toolbar will be synchronized
	    with anthy-context-input-rule value.
	
2004-08-01 Takuro Ashie <ashie@homa.ne.jp>
	
	* scm/anthy.scm
	  - Enabled to switch input rule between "roma" and "kana" by selecting
	    it from helper toolbar. But helper toolbars aren't synchronized
	    with its state yet.
	  - (anthy-context-input-rule, anthy-context-set-input-rule):
	    New procedures.
	  - (anthy-input-rule-roma, anthy-input-rule-kana,
	    anthy-input-rule-azik): New constants.
	  - (anthy-context-new): Added a flag for input rule.
	  - (anthy-make-whole-string, anthy-proc-input-state-no-preedit,
	    anthy-proc-input-state-with-preedit): Replaced using-kana-table?
	    with anthy-context-input-rule.
	  - (anthy-prop-handler): Set input rule for rk context.
	
2004-08-01 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	* slib.c: preliminary implementation of backtrace. (this can be backed out later.)
	
2004-07-31 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	* slib.c: some indent fix. mark some functions static
	
2004-07-31 Takuro Ashie <ashie@homa.ne.jp>
	
	* gtk/gtk-im-uim.c
	  (cand_activate_cb): Removed unused variables.
	
2004-07-31 Takuro Ashie <ashie@homa.ne.jp>
	
	* gtk/gtk-im-uim.c
	  - (cand_activate_cb): Removed needless code.
	  - (im_module_list): Fixed indent.
	
2004-07-31 Takuro Ashie <ashie@homa.ne.jp>
	
	* gtk/gtk-im-uim.c
	  - Fixed indent.
	
2004-07-31 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* helper/helper-candwin-gtk.c : include <sys/types.h> and <unistd.h>
	for read(2).
	
2004-07-31 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* helper/helper-candwin-gtk.c (read_cb) : Change to use read()
	instead of fgets() and not to return at line containing only "\n".
	This changes make all the input buffer read while the callback is
	in action.
	
	* xim/main.cpp (helper_str_parse) : Hide candidate window when
	when getting "focus_in" message from some other input contexts via
	helper.
	
	* xim/ximic.cpp (setFocus) : When input context get focus, update
	and show its candidate window if the context has active
	candidates, and hide if there is no active candidate with the
	context.
	
	* xim/ximserver.h : Add candidate status with InputContext.
	(candidate_update) : New
	(hasActiveCandwin) : New
	(mCandwinActive) : New
	(current_cand_selection) : New
	(active_candidates) : New
		
	* xim/ximserver.cpp : Add candidate status with Input Context.
	(KeyState::keyState) : Simplify.  Add
	UKey_Shift_key, UKey_Control_key, UKey_Alt_key, UKey_Super_key,
	UKey_Hyper_key.
	
2004-07-31 Etsushi Kato <ekato@ees.hokudai.ac.jp>
	
	* helper/helper-candwin-gtk.c : indentation fixes
	* xim/connection.cpp : indentation fixes
	* xim/locale.cpp : indentation fixes
	* xim/xim.h : indentation fixes
	* xim/ximtrans.cpp : indentation fixes
	* xim/ximic.cpp : indentation fixes
	* xim/ximim.cpp : indentation fixes
	* xim/main.cpp : indentation fixes
	* xim/ximserver.cpp : indentation fixes
	* xim/canddisp.cpp : indentation fixes
	* xim/convdisp.cpp : indentation fixes
	* xim/ximpacket.cpp : indentation fixes
	* xim/ximserver.h : indentation fixes
	* xim/convdisp.h : indentation fixes
	* xim/xdispatch.h : indentation fixes
	
2004-07-31 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	Release 0.4.2.1
	
2004-07-31 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* Makefile.am: Added $(top_builddir)
	
2004-07-31 Yusuke Tabata <yusuke@cherubim.icw.co.jp>
	
	* AUTHORS: fix spell commiter -> committer
	
2004-07-30 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* skk.scm: Removed obsolute comments.
	
2004-07-30 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* fep/Makefile.am, gtk/Makefile.am, xim/Makefile.am, helper/Makefile.am
	 - Used $(top_builddir)
	
	
2004-07-30 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* AUTHORS: New commiter Etsushi Kato added to the list.
	
2004-07-30 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* uim/Makefile.am: Used CFLAGS instead of INCLUDES.
	
2004-07-30 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* helper/Makefile.am: CFLAGS is used instead of INCLUDES.
	
2004-07-30 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* gtk/Makefile.am, fep/Makefile.am, xim/Makefile.am:
	  - CFLAGS is used instead of INCLUDES. (I don't have confident in 
	    this change.)
	
2004-07-30 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* fep/config.h.in: Removed uneed file from repository.
	
2004-07-29 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* configure.ac: Some space was eliminated.
	
2004-07-29 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* anthy.c: Replaced () with (void).
	
2004-07-29 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* m17nlib.c:
	 -(convert_mtext2str): New function.
	
2004-07-29 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* fep/callbacks.c
	 -(select_cb):     Added range check of index. 
	 -(shift_page_cb): Added range check of index. 
	 -(get_candidate): Added NULL check.
	
2004-07-28 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* generic.scm:
	 (generic-proc-input-state): generic-proc-on-mode is splitted into 2 procedures.
	 (generic-proc-converting-state): generic-proc-on-mode is splitted into
	                                  2 procedures.
					    
	 * hangul.scm:
	 (hangul-proc-on-mode): generic-proc-on-mode was renamed to generic-proc-input-state.
	
2004-07-28 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* uim.c:
	 (uim_init_scm): siod_verbose_level should be configurable.
	
2004-07-28 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* m17nlib.scm:
	  Argument of m17nlib-lib-preedit-changed?, m17nlib-lib-compose-mode?,
	  m17nlib-lib-get-commit-string is mid, not mere id.
	
	
2004-07-28 Takuro Ashie <ashie@homa.ne.jp>
	
	* Separated candidates window related functions to new files to share
	  the code with uim-helper-candwin-gtk.
	
	* gtk/Makefile.am: Added uim-cand-win-gtk.[ch].
	* gtk/uim-cand-win-gtk.[ch]
	  - New files. Fixed some odd behavior of candidates window.
	  - The bug that sometimes it could switch to invalid page has been
	    fixed.
	  - The bug that selection was gone by clicking emty row has been
	    fixed.
	  - The bug that label didn't sync with current state when clicked a
	    row has been fixed.
	  - Performance improvement.
	  - Plugged some memory leaks.
	* gtk/gtk-im-uim.c
	  - Moved most code for the candidates window to the new file.
	  - Use strstr() instead of strncmp() to detecting messages from helper
	    server (This code was removed by rescent rewiding, so I revived it).
	
2004-07-28 YamaKen <yamaken@bp.iij4u.or.jp>
	
	* Follow new API of the immodule. In the API, two query functions
	  languages() and displayName() are added. I think that current
	  index-based query API of uim for language and input method name is
	  useless and should be redesigned. I will suggest the change in
	  future
	
	* plugin.cpp
	  - Remove #include <stdio.h>
	  - (create):
	    * Follow new QUimInputContext constructor interface
	    * Move createUC into QUimInputContext constructor
	    * Replace stdc functions with Qt functions
	  - (languages): New function to follow new immodule API
	  - (displayName): Remove excessive "uim-" prefix
	  - (createLanguageList): New function
	
	
	* quiminputcontext.h
	  - (class QUimInputContext): Add Q_OBJECT to follow new API
	  - (QUimInputContext): Add imname and lang args
	  - (name): Remove to follow new API
	  - (identifierName): New function to follow new API
	  - (isPreeditRelocationEnabled): Move to public from protected to
	    follow new API
	  - (createUC): Move to protected from public
	  - (m_imname, m_lang): New variables
	
	* quiminputcontext.cpp
	  - (QUimInputContext):
	    * Add imname and lang args
	    * Move createUC from QInputContextPlugin
	  - (name): Remove to follow new API
	  - (identifierName): New function. Properly implemented
	  - (language): Implement properly
	
2004-07-27 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
	* anthy.scm:
	 (anthy-proc-compose-state): PageUp/Down key should be ignored if 
	                             candidate window is not opened.
	
2004-07-27 TOKUNAGA Hiroyuki <tkng@xem.jp>
	
